<?php
/****************************************************************
* SMF Media Gallery												*
* Version 2.0													*
*  SMF-Media.com												*
*****************************************************************
* MGallery-Embed.php											*
*****************************************************************
* Users of this software are bound by the terms of the			*
* SMG license. You can view it in the license_smg.txt file,		*
* or online at http://smf-media.com/smg/license.php				*
*																*
* Support and updates for this software can be found at			*
* http://smf-media.com											*
****************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function embed_video($message)
{
	global $context, $sites, $sourcedir, $modSettings;

	$msg = '<a href="' . preg_replace(array('~\[url=([^]]*)][^[]*\[/url]~', '~\[url]([^[]*)\[/url]~'), '$1', $message) . '"></a>';

	// If Aeva is installed, no need for this masquerade
	if (!empty($modSettings['aeva_enable']) || !empty($modSettings['aevac_enable']) || file_exists($sourcedir . '/Subs-AEVAC.php'))
		return parse_bbc(substr($message, 4) == 'http' ? $msg : $message);

	$sites = mgal_aeva_load();

	// For each site, attempt to embed
	foreach (array_keys($sites) as $i)
	{
		// Store where we are upto - this is needed to know which one to build
		$context['aeva_rocks'] = $i;
		$msg = mgal_aeva_match($msg);

		// If no active http links remain (making further embedding impossible), then stop
		if (stripos($msg, '<a href="http://') === false)
			break;
	}
	unset($context['aeva_rocks']);

	// All sites are done.
	return $msg;
}

function checkEmbedLink($link)
{
	global $context, $sites, $boardurl, $sourcedir, $modSettings;

	// If Aeva is installed and we're checking the link instead of retrieving a site ID, load the site list from Aeva 4/5, or just bypass for AEVAC 3
	if (isset($modSettings['aeva_enable']) || isset($modSettings['aevac_enable']) || file_exists($sourcedir . '/Subs-AEVAC.php'))
	{
		// If Aeva 5.0+ or Aevac 4.0+ are found, try to go through the normal embedding process and return a fixed link...
		$c = isset($modSettings['aevac_enable']) ? 'c' : '';
		if (isset($modSettings['aeva' . $c . '_enable']))
		{
			@require_once($sourcedir . '/Subs-Aeva' . $c . '.php');
			$onposting = 'aeva' . $c . '_onposting';
			$main = 'aeva' . $c . '_main';
			if (function_exists($onposting) && function_exists($main))
			{
				$link2 = $onposting($link);
				$link3 = preg_replace(
					array('~\[url=([^]]*)]([^[]*)\[/url]~', '~\[url]([^[]*)\[/url]~'),
					array('<a href="$1">$2</a>', '<a href="$1">$1</a>'), $link2);
					if (strpos($main($link3), '<embed ') !== false)
						return $link2;
			}
		}

		// Parse the boardurl to grab the domain we're on.
		$x = @parse_url($boardurl);
		$x['scheme'] = !empty($x['scheme']) ? $x['scheme'] : 'http';
		$x['host'] = !empty($x['host']) ? $x['host'] : NULL;

		if (!empty($x['host']))
			if (preg_match('~' . preg_quote($x['scheme'].'://', '~') . '(?:(?:(?:[a-z0-9-]{1,32})\.){0,3})' . preg_quote($x['host'] . '/', '~') . '~i', $link, $void))
				return true;
		unset($x);

		// Aeva 5
		if (file_exists($sourcedir . '/Subs-Aeva.php'))
		{
			require_once($sourcedir . '/Subs-Aeva.php');
			if (empty($sites))
				@include_once($sourcedir . '/Subs-Aeva-Generated-Sites.php');
			if (empty($sites))
			{
				@include_once($sourcedir . '/Subs-Aeva-Sites.php');
				if (file_exists($sourcedir . '/Subs-Aeva-Custom.php'))
					@include_once($sourcedir . '/Subs-Aeva-Custom.php');
			}
		}
		// AEVAC 4
		elseif (file_exists($sourcedir . '/Subs-Aevac-Sites.php'))
		{
			require_once($sourcedir . '/Subs-Aevac.php');
			if (empty($sites))
				@include_once($sourcedir . '/Subs-Aevac-Generated-Sites.php');
			if (empty($sites))
				@include_once($sourcedir . '/Subs-Aevac-Sites.php');
		}
		// AEVAC 3 can't return the site list, so we'll just consider the test passed.
		elseif (file_exists($sourcedir . '/Subs-AEVAC.php'))
			return true;
	}

	if (empty($sites)) // No Aeva found? What a shame!
		$sites = mgal_aeva_load();

	$link = preg_replace(array('~\[url=([^]]*)][^[]*\[/url]~', '~\[url]([^[]*)\[/url]~'), '$1', $link);
	foreach ($sites as $arr)
		if (preg_match('~^' . (isset($arr['pattern']) ? $arr['pattern'] : $arr['embed-pattern']) . '~i' . ($context['utf8'] ? 'u' : ''), $link))
			return true;

	return false;
}

// Generates thumbnail for site if possible
function generateVideoSiteThumb($link, $id_album, $id_file = 0, $folder = '')
{
	global $embed_album, $embed_folder, $context, $force_id;

	$link = preg_replace(array('~\[url=([^]]*)]([^[]*)\[/url]~', '~\[url]([^[]*)\[/url]~'), array('$1', '$1'), $link);
	$thumbs = array(
		'ytb' => 'youtubeCreateThumb',
		'dam' => 'dailymotionCreateThumb',
		'ggl' => 'googleCreateThumb',
		'mcf' => 'metacafeCreateThumb',
		'vim' => 'vimeoCreateThumb',
	);

	// Load limited site list
	$thumbsites = mgal_aeva_load();

	foreach ($thumbsites as $ids => $arr)
		if (!empty($ids) && preg_match('~^' . $arr['embed-pattern'] . '.*?$~i' . ($context['utf8'] ? 'u' : ''), $link))
			$id = $arr['id'];

	$embed_folder = $folder;
	$embed_album = $id_album;
	$force_id = $id_file;

	// Let's create the thumbnail
	return empty($id) || !isset($thumbs[$id]) || !isset($thumbsites[$id]) ? 0 : $thumbs[$id]($link, '`' . $thumbsites[$id]['embed-pattern'] . '`i');
}

// Retrieves Youtube thumbnail. Geek pawaa!
function youtubeCreateThumb($link, $regexp)
{
	return preg_match($regexp, $link, $dt) ? downloadThumbnail('http://img.youtube.com/vi/' . $dt[1] . '/0.jpg', $dt[1]) : 0;
}

function dailymotionCreateThumb($link, $regexp)
{
	return preg_match($regexp, $link, $dt) ? downloadThumbnail('http://www.dailymotion.com/thumbnail/320x240/video/' . $dt[1], $dt[1]) : 0;
}

function googleCreateThumb($link, $regexp)
{
	return preg_match($regexp, $link, $dt) ? downloadThumbnailVia('http://video.google.com/videofeed?docid=' . $dt[2], $dt[2], '<media:thumbnail url="([^"]+)') : 0;
}

function metacafeCreateThumb($link, $regexp)
{
	return preg_match($regexp, $link, $dt) ? downloadThumbnail('http://www.metacafe.com/thumb/' . $dt[1] . '.jpg', $dt[1]) : 0;
}

function vimeoCreateThumb($link, $regexp)
{
	return preg_match($regexp, $link, $dt) ? downloadThumbnailVia('http://vimeo.com/api/clip/' . $dt[1] .'.xml', $dt[1], '<thumbnail_medium>([^<]+)') : 0;
}

// This annoying little function is needed when the frigging server really doesn't want to cooperate...
// Inspired (and hopefully improved) from http://www.php.net/manual/en/function.curl-setopt.php#71313
function smg_curl_redir_exec($ch)
{
	static $curl_loops = 0;
	if ($curl_loops++ >= 20)
	{
		$curl_loops = 0;
		return false;
	}
	curl_setopt($ch, CURLOPT_HEADER, true);
	$data = curl_exec($ch);
	list ($header, $data) = preg_split("/(\n\n|\r\r|\r\n\r\n)/", $data, 2);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if ($http_code == 301 || $http_code == 302)
	{
		$matches = array();
		preg_match('/Location:(.*?)[\r\n]/', $header, $matches);
		if ($url = @parse_url(trim(array_pop($matches))))
		{
			$last_url = parse_url(curl_getinfo($ch, CURLINFO_EFFECTIVE_URL));
			$url['scheme'] = $url['scheme'] ? $url['scheme'] : $last_url['scheme'];
			$url['host'] = $url['host'] ? $url['host'] : $last_url['host'];
			$url['path'] = $url['path'] ? $url['path'] : $last_url['path'];
			$new_url = $url['scheme'] . '://' . $url['host'] . $url['path'] . ($url['query'] ? '?' . $url['query'] : '');
			curl_setopt($ch, CURLOPT_URL, $new_url);
			return smg_curl_redir_exec($ch);
		}
	}
	$curl_loops = 0;
	return $data;
}

function smg_file_get_contents($url)
{
	if (!function_exists('curl_init') || !$c = curl_init())
		return false;
	curl_setopt($c, CURLOPT_URL, $url);
	curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
	$contents = curl_exec($c);
	if (!$contents)
		$contents = smg_curl_redir_exec($c);
	curl_close($c);
	return $contents ? $contents : false;
}

function downloadToString($url, &$file)
{
	$file = @file_get_contents($url);
	if (!$file)
		$file = @implode('', @file($url));
	if (!$file)
		$file = smg_file_get_contents($url);
}

function downloadToLocal($url, $local)
{
	$file = '';
	downloadToString($url, $file);
	$len = strlen($file);
	$my_file = @fopen($local, 'w');
	@fwrite($my_file, $file, $len);
	@fclose($my_file);
	unset($file);
	return $len;
}

function mgal_url_exists($url)
{
	$a_url = parse_url($url);
	if (!isset($a_url['scheme']))
		return false;
	$temp = '';
	$fid = fsockopen($a_url['host'], !isset($a_url['port']) ? 80 : $a_url['port'], $temp, $temp, 8);
	if (!$fid)
		return false;
	fputs($fid, 'HEAD ' . $a_url['path'] . (isset($a_url['query']) ? '?' . $a_url['query'] : '') . ' HTTP/1.0' . "\r\n" . 'Host: ' . $a_url['host'] . "\r\n\r\n");
	$head = fread($fid, 1024);
	fclose($fid);
	return preg_match('~^HTTP/.+\s+[23][0-9][0-9]~i', $head) == 1;
}

function downloadThumbnailVia($via_url, $name, $regexp)
{
	$via_page = '';
	if (mgal_url_exists($via_url))
		downloadToString($via_url, $via_page);
	return preg_match('`' . $regexp . '`i', $via_page, $thumb_url) ? downloadThumbnail(str_replace('&amp;', '&', $thumb_url[1]), $name) : 0;
}

function downloadThumbnail($url_thumb, $name)
{
	global $mgalSettings, $mgalFunc, $embed_album, $embed_folder, $force_id;

	$dir = !empty($embed_folder) ? $embed_folder : getSuitableDir($embed_album);
	$local_file = $mgalSettings['data_dir_path'] . '/tmp/thumb_' . $name . '.jpg';
	$thumb_length = mgal_url_exists($url_thumb) ? downloadToLocal($url_thumb, $local_file) : 0;
	if (empty($thumb_length))
		return 0;
	$my_file = new mgal_media_handler;
	$my_file->init($local_file);
	list ($width, $height) = $my_file->getSize();

	mgal_deleteFiles($force_id, true);

	if ($resizedpic = $my_file->createThumbnail($local_file . '2.jpg', min($width, $mgalSettings['max_thumb_width']), min($height, $mgalSettings['max_thumb_height'])))
	{
		list ($twidth, $theight) = $resizedpic->getSize();
		$fsize = $resizedpic->getFileSize();
		$resizedpic->close();
	}

	$my_file->close();
	$twidth = empty($twidth) ? $mgalSettings['max_thumb_width'] : $twidth;
	$theight = empty($theight) ? $mgalSettings['max_thumb_height'] : $theight;

	$id_thumb = smg_insert_file_id(
		$force_id, $fsize, 'thumb_' . $name . '.jpg', $twidth, $theight,
		substr($dir, strlen($mgalSettings['data_dir_path']) + 1), $embed_album
	);

	@unlink($local_file);
	@rename($local_file . '2.jpg', $dir . '/' . getEncryptedFilename('thumb_' . $name . '.jpg', $id_thumb, true));
	return $id_thumb;
}

///////////////////////////////////////////////////////////////////////
// Thanks to <karlbenson> for the inspiration for the following code //
///////////////////////////////////////////////////////////////////////

function mgal_aeva_match($input)
{
	global $context, $sites;

	// Prevent stupid loop/crash
	if (empty($sites[$context['aeva_rocks']]['embed-pattern']))
		return $input;

	// This copy of the regex we will modify
	$regex = $sites[$context['aeva_rocks']]['embed-pattern'];

	// Complete the regex pattern
	$regex = '~<a href="(' . $regex . '[^"]*)">.*?</a>~i' . ($context['utf8'] ? 'u' : '');

	$input = preg_replace_callback($regex, 'mgal_aeva_build_object', $input);

	return $input;
}

function mgal_aeva_build_object($input)
{
	global $context, $modSettings, $sites;

	$arr = $sites[$context['aeva_rocks']];

	// Depending on the plugin, use different parameters
	if ($arr['plugin'] == 'flash')
	{
		$plugin = array(
			'classid' => 'CLSID:D27CDB6E-AE6d-11CF-96B8-444553540000',
			'type' => 'application/x-shockwave-flash',
			'codebase' => 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,115,0',
			'params' => array(
				'wmode' => 'transparent',
				'quality' => 'high',
				'allowFullScreen' => 'true',
				'allowScriptAccess' => 'never',
				'pluginspage' => 'http://www.macromedia.com/go/getflashplayer',
				'autoplay' => 'false',
				'autostart' => 'false',
			),
		);
	}
	elseif ($arr['plugin'] == 'divx')
	{
		$plugin = array(
			'classid' => 'CLSID:67DABFBF-D0AB-41FA-9C46-CC0F21721616',
			'type' => 'video/divx',
			'codebase' => 'http://go.divx.com/plugin/DivXBrowserPlugin.cab',
			'params' => array(
				'allowFullScreen' => 'true',
				'allowScriptAccess' => 'never',
				'pluginspage' => 'http://go.divx.com/plugin/download/',
				'custommode' => 'none',
				'autoPlay' => 'false',
				'mode' => 'full',
				'minVersion' => '1.0.0',
				'allowContextMenu' => 'true',
				'url' => '$2',
				'bannerEnabled' => 'false',
				'showpostplaybackad' => 'false',
			),
			'src' => 'src',
		);
	}
	elseif ($arr['plugin'] == 'wmp')
	{
		$plugin = array(
			'classid' => 'CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95',
			'type' => 'application/x-mplayer2',
			'codebase' => 'http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,4,7,1112',
			'params' => array(
				'wmode' => 'transparent',
				'quality' => 'high',
				'allowFullScreen' => 'true',
				'allowScriptAccess' => 'never',
				'Showcontrols' => 'True',
				'autostart' => 'false',
				'autoplay' => 'false',
			),
			'src' => 'filename', // wmp uses filename instead of src or movie for the param name
		);
	}
	elseif ($arr['plugin'] == 'quicktime')
	{
		$plugin = array(
			'classid' => 'CLSID:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B',
			'type' => 'video/quicktime',
			'codebase' => 'http://www.apple.com/qtactivex/qtplugin.cab',
			'params' => array(
				'pluginspage' => 'http://www.apple.com/quicktime/download/',
				'wmode' => 'transparent',
				'quality' => 'high',
				'allowFullScreen' => 'true',
				'allowScriptAccess' => 'never',
				'scale' => 'aspect',
				'loop' => 'false',
				'controller' => 'true',
				'autoplay' => 'false',
				'src' => 'src', // Uses src instead of 'movie' like flash
			),
		);
	}
	elseif ($arr['plugin'] == 'realmedia')
	{
		$plugin = array(
			'classid' => 'CLSID:CFCDAA03-8BE4-11CF-B84B-0020AFBBCCFA',
			'type' => 'audio/x-pn-realaudio-plugin',
			'params' => array(
				'pluginspage' => 'http://www.real.com',
				'wmode' => 'transparent',
				'quality' => 'high',
				'allowFullScreen' => 'true',
				'allowScriptAccess' => 'never',
				'controls' => 'imagewindow',
				'console' => 'video',
				'autostart' => 'false',
				'src' => true, // Uses src instead of 'movie' like flash
			),
			'extra' => (($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '<object id="rvocx" classid="clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA" width="$8px" height="30px"><param name="src" value="$1"><param name="autostart" value="false"><param name="controls" value="ControlPanel"><param name="console" value="video">' : '' ) .
				'<embed src="$1" width="$8px" height="30" controls="ControlPanel" type="audio/x-pn-realaudio-plugin" console="video" autostart="false"></embed>' . ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'] ? '</object>' : '')),
		);
	}
	// Build the params with both formats for <object> and <embed>
	$object_params = $embed_params = '';

	foreach ($plugin['params'] as $a => $b)
	{
		// If blank field, continue
		if ($b === '')
			continue;

		// <Embed>
		$embed_params .= ' '.$a.'="'.$b.'"';

		// <Object>?
		if ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'])
			$object_params .= '<param name="'.$a.'" value="'.$b.'" />';
	}
	// Tidy up
	unset($a, $b);

	// Object must be wrapped inside a div (otherwise on clicking quick edit, the object is reloaded)
	$object = '<div>';

	// Some sites might have stuff to show before
	if (!empty($arr['embed-html-before']))
		$object .= $arr['embed-html-before'];

	// Build the <object> (Non-Mac IE Only)
	if ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'])
		$object .= '<object classid="'.$plugin['classid'].'" '.
					(!empty($plugin['codebase']) ? 'codebase="'.$plugin['codebase'].'" ' : '' ).
					'type="'.$plugin['type'].'" width="'.$arr['embed-width'].'px" height="'.$arr['embed-height'].'px">'.
					'<param name="'.( empty($plugin['src']) ? 'movie' : $plugin['src'] ).'" value="'. $arr['embed'.(empty($arr['embed-movie']) ? '-hq' : '' ).'-movie'] .'" />'. $object_params;

	// Build the <embed>
	$object .= '<embed type="'.$plugin['type'].'" '.
					'src="'. $arr['embed'.(empty($arr['embed-movie']) ? '-hq' : '' ).'-movie'] .'" width="'.$arr['embed-width'].'px" height="'.$arr['embed-height'].'px"'. $embed_params .' />';

	// <noembed> tag containing raw link in case flash is disabled.
	if (!isset($arr['embed-showlink']))
		$object .= '<noembed><a href="'. $arr['embed'.(empty($arr['embed-movie']) ? '-hq' : '' ).'-movie'] .'" target="_blank">'. $arr['embed'.(empty($arr['embed-movie']) ? '-hq' : '' ).'-movie'] .'</a></noembed>';

	// If using <object> remember to close it
	if ($context['browser']['is_ie'] && !$context['browser']['is_mac_ie'])
		$object .= '</object>';

	// Any extra - required for realplayer since it needs dual embeds, and fix the width/height while we're at it
	if (!empty($plugin['extra']))
		$object .= str_replace(array('$8', '$9'), array($arr['embed-width'], $arr['embed-height']) , $plugin['extra']);

	// Like before, but after ;)
	if (!empty($arr['embed-html-after']))
		$object .= $arr['embed-html-after'];

	// Wrap: After - leave empty if not required
	$object .= '';

	// Include the original link?
	if (isset($arr['embed-showlink']))
		$object .= '<br /><a href="$1" target="_blank" class="bbc_link new_win">$1</a>';

	// Close our div. (We had to wrap Object inside a div to prevent on clicking quick edit, the object being reloaded)
	$object .= '</div>';

	// Replace the $1, $2, $3	etc
	for ($i=1; $i < count($input); $i++)
		$object = str_replace('$'.$i, $input[$i], $object);

	// All ampersands need to be &amp;, however some may be already encoded. So to prevent double-encoding, convert them back to &, then back again
	$object = strtr($object, array('&amp;' => '&'));
	$object = strtr($object, array('&' => '&amp;'));

	// Protect http links inside the object from being double embedded
	return $object;
}

// This function loads the supported video sites.
function mgal_aeva_load()
{
	return array(
		'ytb' => array(
			'id' => 'ytb',
			'title' => 'YouTube',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:video\.google\.(?:com|com?\.[a-z]{2}|[a-z]{2})/[^"]*?)?(?:(?:www|[a-z]{2})\.)?youtube\.com/[^"#[]*?(?:&|&amp;|/|\?|;|\%3F|\%2F)(?:video_id=|v(?:/|=|\%3D|\%2F))([\w-]{11})',
			'embed-movie' => 'http://www.youtube.com/v/$2&rel=0&fs=1',
			'embed-width' => '425',
			'embed-height' => '344',
		),
		'dam' => array(
			'id' => 'dam',
			'title' => 'Dailymotion',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:www\.)?dailymotion\.(?:com|alice\.it)/(?:[^"]*?video|swf)/([a-z0-9]{1,18})',
			'embed-movie' => 'http://www.dailymotion.com/swf/$2&related=0',
			'embed-width' => '420',
			'embed-height' => '336',
		),
		'ggl' => array(
			'id' => 'ggl',
			'title' => 'Google Video',
			'plugin' => 'flash',
			'embed-pattern' => 'http://video\.google\.(com|com?\.[a-z]{2}|[a-z]{2})/(?:videoplay|url|googleplayer\.swf)\?[^"]*?docid=([\w-]{1,20})',
			'embed-movie' => 'http://video.google.$2/googleplayer.swf?docId=$3',
			'embed-width' => '400',
			'embed-height' => '326',
			'embed-showlink' => true,
		),
		'mcf' => array(
			'id' => 'mcf',
			'title' => 'MetaCafe',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:www\.)?metacafe\.com/(?:watch|fplayer)/([\w-]{1,20})/',
			'embed-movie' => 'http://www.metacafe.com/fplayer/$2/metacafe.swf',
			'embed-width' => '400',
			'embed-height' => '345',
		),
		'vim' => array(
			'id' => 'vim',
			'plugin' => 'flash',
			'title' => 'Vimeo',
			'embed-pattern' => 'http://(?:www\.)?vimeo\.com/(\d{1,12})',
			'embed-movie' => 'http://vimeo.com/moogaloop.swf?clip_id=$2&server=vimeo.com&fullscreen=1&show_title=1&show_byline=1&show_portrait=0&color=01AAEA',
			'embed-width' => '640', // 400
			'embed-height' => '360', // 326
			'embed-showlink' => true,
		),
		array(
			'id' => 'ytp',
			'title' => 'YouTube (Playlists)',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:(?:www|[a-z]{2})\.)?youtube\.com/(?:[^"]*?)?(?:&|&amp;|/|\?|;)(?:id=|p=|p/)([0-9a-f]{16})',
			'embed-movie' => 'http://www.youtube.com/p/$2&rel=0&fs=1',
			'embed-width' => '480',
			'embed-height' => '385',
		),
		array(
			'id' => 'mgv',
			'title' => 'MegaVideo',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:www\.)?megavideo\.com/(?:\?(?:[^"]*?)?v=|v/)([0-9a-z]{8})',
			'embed-movie' => 'http://www.megavideo.com/v/$2.0.0',
			'embed-width' => '432',
			'embed-height' => '351',
		),
		array(
			'id' => 'ima',
			'title' => 'ImageShack',
			'plugin' => 'flash',
			'embed-pattern' => 'http://img([0-9]{1,5})\.imageshack\.us/(?:my\.php\?image=|img(?:[0-9]{1,5})/(?:[0-9]{1,8})/|flvplayer\.swf\?f=T)([a-z0-9-_]{1,20})\.flv',
			'embed-movie' => 'http://img$2.imageshack.us/flvplayer.swf?f=T$3&autostart=false',
			'embed-width' => '424',
			'embed-height' => '338',
		),
		array(
			'id' => 'msn',
			'title' => 'MSN Live/Soapbox',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:soapbox|video)\.msn\.com/video\.aspx\?(?:(?:[^"]*?)?vid=|from=msnvideo&showPlaylist=true&playlist=videoByUuids:uuids:)((?:[0-9a-z]{8})(?:(?:-(?:[0-9a-z]{4})){3})-(?:[0-9a-z]{12}))',
			'embed-movie' => 'http://images.video.msn.com/flash/soapbox1_1.swf?c=v&v=$2',
			'embed-width' => '432',
			'embed-height' => '364',
		),
		array(
			'id' => 'myt',
			'title' => 'MySpaceTv',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:vids\.myspace|myspacetv)\.com/index\.cfm\?(?:[^"]*?)?VideoID=([0-9]{1,10})',
			'embed-movie' => 'http://mediaservices.myspace.com/services/media/embed.aspx/m=$2',
			'embed-width' => '425',
			'embed-height' => '360',
		),
		array(
			'id' => 'pho',
			'title' => 'Photobucket',
			'plugin' => 'flash',
			'embed-pattern' => 'http://s([\w]{1,5})\.photobucket\.com/albums/((?:(?:[\%0-9a-z_-]{1,50})/){1,10})(?:\?(?:[^"]*?)current=)?([\%0-9a-z_-]{1,50})\.flv',
			'embed-movie' => 'http://www.photobucket.com/player.swf?file=http://vid$2.photobucket.com/albums/$3$4.flv',
			'embed-width' => '448',
			'embed-height' => '361',
		),
		array(
			'id' => 'veo',
			'title' => 'Veoh',
			'plugin' => 'flash',
			'embed-pattern' => 'http://(?:www\.)?veoh\.com/(?:videos/|videodetails2\.swf\?permalinkId=)([0-9a-z]{14,17})',
			'embed-movie' => 'http://www.veoh.com/veohplayer.swf?permalinkId=$2&id=anonymous&player=videodetailsembedded&videoAutoPlay=0',
			'embed-width' => '460',
			'embed-height' => '345',
		),
	);
}

?>