<?php
/*****************************************************************
* SMF Media Gallery												 *
* Version 2.0													 *
*  SMF-Media.com												 *
******************************************************************
* MGallery.template.php											 *
******************************************************************
* Users of this software are bound by the terms of the			 *
* SMG license. You can view it in the license_smg.txt file,		 *
* or online at http://smf-media.com/smg/license.php				 *
*																 *
* Support and updates for this software can be found at			 *
* http://smf-media.com											 *
*****************************************************************/

function template_mgallery_above()
{
	global $context, $txt, $mgalSettings, $scripturl, $settings, $shown_linktree;

	// SMF 2.0 (Apr '09 revs) shows linktrees automatically
	if (empty($shown_linktree))
		theme_linktree();

	// Show SMG tabs, except if not inside the gallery itself
	if (empty($context['current_board']))
	{
		echo '
		<div class="tborder">
			<div class="titlebg header" style="border: 1px solid white">
				<ul class="smalltext" id="smg_tabs">';

		if (isset($context['mgallery_header']['tabs']))
			foreach ($context['mgallery_header']['tabs'] as $tab)
				echo '
					<li', $tab['active'] ? ' class="selected"' : '', '>', !empty($tab['icon']) ? '<img src="' . $settings['images_smg'] . '/' . $tab['icon'] . '" alt="" style="vertical-align: text-bottom" />&nbsp;' : '', '<a href="', $tab['url'], '">', $tab['title'], '</a></li>';

		echo '
				</ul>
				', !isset($context['mgallery_header']['data']['title']) ? $txt['mgallery_title'] : $context['mgallery_header']['data']['title'], '
			</div>
		</div>';
	}

	// Any unapproved stuff?
	if (mGalAllowedTo('moderate') && ($mgalSettings['num_unapproved_items'] > 0 || $mgalSettings['num_unapproved_comments'] > 0 || $mgalSettings['num_unapproved_albums'] > 0))
	{
		echo '
	<div class="unapproved_notice">';
		if ($mgalSettings['num_unapproved_items'] > 0)
			printf($txt['mgallery_unapproved_items_notice'] . '<br />', $scripturl.'?action=mgallery;area=moderate;sa=submissions;filter=items;' . $context['session_var'] . '='.$context['session_id'], $mgalSettings['num_unapproved_items']);
		if ($mgalSettings['num_unapproved_comments'] > 0)
			printf($txt['mgallery_unapproved_coms_notice'] . '<br />', $scripturl.'?action=mgallery;area=moderate;sa=submissions;filter=coms;' . $context['session_var'] . '='.$context['session_id'], $mgalSettings['num_unapproved_comments']);
		if ($mgalSettings['num_unapproved_albums'] > 0)
			printf($txt['mgallery_unapproved_albums_notice'], $scripturl.'?action=mgallery;area=moderate;sa=submissions;filter=albums;' . $context['session_var'] . '='.$context['session_id'], $mgalSettings['num_unapproved_albums']);
		echo '</div>';
	}

	// Any reported stuff?
	if (mGalAllowedTo('moderate') && ($mgalSettings['num_reported_items'] > 0 || $mgalSettings['num_reported_comments'] > 0))
	{
		echo '
	<div class="unapproved_notice">';
		if ($mgalSettings['num_unapproved_items'] > 0)
			printf($txt['mgallery_reported_items_notice'] . '<br />', $scripturl.'?action=mgallery;area=moderate;sa=reports;items;' . $context['session_var'] . '='.$context['session_id'], $mgalSettings['num_reported_items']);
		if ($mgalSettings['num_unapproved_comments'] > 0)
			printf($txt['mgallery_reported_coms_notice'] . '<br />', $scripturl.'?action=mgallery;area=moderate;sa=reports;comments;' . $context['session_var'] . '='.$context['session_id'], $mgalSettings['num_reported_comments']);
		echo '</div>';
	}

	// Any further data to show?
	if (!empty($context['mgallery_header']['data']['description']))
		echo '
	<div class="subheader">
		<h4 class="catbg">', !isset($context['mgallery_header']['data']['title']) ? $txt['mgallery_title'] : $context['mgallery_header']['data']['title'], '</h4>
		<p class="windowbg smalltext">', $context['mgallery_header']['data']['description'], '</p>
	</div>';

	// area-tabs maybe?
	if (!empty($context['mgallery_header']['areatabs']))
	{
		$buttons = array();
		foreach ($context['mgallery_header']['areatabs'] as $tab)
			$buttons[] = array(
				'text' => $tab['title'],
				'url' => $tab['url'],
				'custom' => $tab['active'] ? ' class="currentbutton"' : '',
			);
		mgal_button_strip($buttons, 'top');
	}

	// sub-tabs maybe?
	if (!empty($context['mgallery_header']['subtabs']))
	{
		$buttons = array();
		foreach ($context['mgallery_header']['subtabs'] as $tab)
			$buttons[] = array(
				'text' => $tab['title'],
				'url' => $tab['url'],
				'custom' => $tab['active'] ? ' class="currentbutton"' : '',
			);
		mgal_button_strip($buttons);
	}
}

function mgal_button_strip(&$buttons, $direction = 'bottom')
{
	global $context;

	if ($context['is_smf2'])
		echo '
		<div class="floatleft" style="margin-left: 10px">', template_button_strip($buttons, $direction), '
		</div>
		<div class="clearfix"></div>';
	else
		echo '
		<table cellpadding="0" cellspacing="0" border="0">
			<tr>', template_button_strip($buttons, $direction), '</tr>
		</table>';
}

function template_mgallery_home()
{
	global $context, $mgalSettings, $txt, $galurl, $scripturl, $settings, $sourcedir;

	$has_albums = count($context['mgallery_home_albums']) > 0;
	$foxy = file_exists($sourcedir . '/MGallery-Foxy.php');

	// The Albums!
	echo '
<div id="home">
	<div class="catbg item_heading">', ($has_albums ? '
		<b>'.$txt['mgallery_albums'].'</b>' : ''), $context['show_user_albums_link'] ? ($has_albums ? ' -' : '') . '
		<b><a href="'.$galurl.'sa=vua">'.$txt['mgallery_user_albums'].'</a></b>' : '', $foxy ? ' -
		<b><a href="'.$galurl.'sa=playlists">'.$txt['mgallery_playlists'].'</a></b>' : '', '
	</div>';

	if ($has_albums)
	{
		echo '
	<table cellpadding="6" cellspacing="1" width="100%" style="margin-top: 8px">
		<tr class="titlebg2">
			<td width="8%">', $txt['mgallery_icon'], '</td>
			<td width="80%">', $txt['mgallery_name'], '</td>
			<td>', $txt['mgallery_items'], '</td>
		</tr>';

		foreach ($context['mgallery_home_albums'] as $album)
		{
			echo '
		<tr class="windowbg2">
			<td width="6%" align="center">', $album['icon']['src'], '</td>
			<td><div class="mg_large"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a></div><div class="mg_desc">', $album['description'], '</div></td>
			<td>', $album['overall_total'], '</td>
		</tr>
		', !empty($album['sub_albums']) && $mgalSettings['show_sub_albums_on_index'] == 1 ? '<tr class="windowbg"><td colspan="3" class="smalltext">'.$txt['mgallery_sub_albums'].': '.implode(', ', $album['sub_albums']).'</td></tr>' : ''.'';
		}

		echo '
	</table>';
	}

	echo "\n";

	// OK Now side stuff
	// Recent items?
	if (!empty($context['recent_items']))
	{
		echo '
	<div class="catbg item_heading">', $txt['mgallery_recent_items'], '</div>';

		$view = isset($_REQUEST['fw']) ? 'file' : 'normal';
		// Page index and sorting things
		$sort_list = array('m.id_media' => 0, 'm.time_added' => 1, 'm.title' => 2, 'm.views' => 3, 'm.weighted' => 4);
		echo '
	<div class="windowbg smalltext sort_options">
		<div class="windowbg smalltext view_options">
			', $txt['mgallery_items_view'], ': ', $view == 'normal' ? '<b>' . $txt['mgallery_view_normal'] . '</b> <a href="' . $galurl . 'fw'. $context['mgal_urlmore'] . '">' . $txt['mgallery_view_filestack'] . '</a>' : '<a href="' . $galurl . $context['mgal_urlmore'] . '">' . $txt['mgallery_view_normal'] . '</a> <b>' . $txt['mgallery_view_filestack'] . '</b>', '
		</div>
		', $txt['mgallery_sort_by'], ':';
		$sort = empty($sort_list[$context['mgal_sort']]) ? 0 : $sort_list[$context['mgal_sort']];
		for ($i = 0; $i < 5; $i++)
			echo $sort == $i ? ' <b>' . $txt['mgallery_sort_by_'.$i] . '</b>' :
		' <a href="'.$galurl.'sort=' . $i . ($view == 'normal' ? '' : ';fw') . '">' . $txt['mgallery_sort_by_'.$i] . '</a>';
		echo '
		| ', $txt['mgallery_sort_order'], ':',
		($context['mgal_asc'] ? ' <b>' . $txt['mgallery_sort_order_asc'] . '</b>' : ' <a href="' . $galurl . (isset($_REQUEST['sort']) ? 'sort='.$_REQUEST['sort'].';' : '') . 'asc' . ($view == 'normal' ? '' : ';fw') . '">' . $txt['mgallery_sort_order_asc'] . '</a>'),
		(!$context['mgal_asc'] ? ' <b>' . $txt['mgallery_sort_order_desc'] . '</b>' : ' <a href="' . $galurl . (isset($_REQUEST['sort']) ? 'sort=' . $_REQUEST['sort'].';' : '') . 'desc' . ($view == 'normal' ? '' : ';fw') . '">'.$txt['mgallery_sort_order_desc'].'</a>'), '
	</div>
	<div class="titlebg page_index">
		', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
	</div>
	<div id="recent_pics">',
		$view == 'normal' ? smg_item_list($context['recent_items']) : smg_filestack_list($context['recent_items']), '
	</div>
	<div class="titlebg page_index" style="margin-top: 8px">
		', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
	</div>';
	}

	// Random items?
	if (!empty($context['random_items']))
	{
		echo '
	<div class="catbg item_heading">', $txt['mgallery_random_items'], '</div>
	<div id="random_pics">',
		smg_item_list($context['random_items']), '
	</div>';
	}

	// Recent comments!
	if (!empty($context['recent_comments']))
	{
		echo '
	<div class="', !empty($context['recent_albums']) ? 'recent_comments' : '', '">
		<div class="catbg item_heading">', $txt['mgallery_recent_comments'], '</div>';

		foreach ($context['recent_comments'] as $i)
			echo '
		<div class="windowbg smalltext" style="padding: 0.3em">', $txt['mgallery_comment_in'], ' <a href="', $i['url'], '">', $i['media_title'], '</a> ',
		$txt['mgallery_by'], ' ', $i['member_link'], ' ', is_numeric($i['posted_on'][0]) ? $txt['mgallery_on_date'] . ' ' : '', $i['posted_on'], '</div>';

		echo '
	</div>';
	}

	// Random comments!
	if (!empty($context['recent_albums']))
	{
		echo '
	<div class="', !empty($context['recent_comments']) ? 'recent_albums' : '', '">
		<div class="catbg item_heading">', $txt['mgallery_recent_albums'], '</div>';

		foreach ($context['recent_albums'] as $i)
			echo '
		<div class="windowbg smalltext" style="padding: 0.3em"><a href="', $scripturl, '?action=mgallery;sa=album;id=', $i['id'], '">', $i['name'], '</a> (',
		$i['num_items'], ') ', $txt['mgallery_by'], ' <a href="', $scripturl, '?action=profile;u=', $i['owner_id'], $context['is_smf2'] ? ';area' : ';sa', '=mgallery">', $i['owner_name'], '</a></div>';

		echo '
	</div>';
	}

	// Fix
	if (!empty($context['recent_comments']) && !empty($context['recent_albums']))
		echo '<br style="clear: both" />';

	// Show some general stats'n'stuff below
	echo '
	<div class="catbg item_heading"><img alt="" src="', $settings['images_smg'], '/chart_bar.png" class="vam" />&nbsp;<a href="', $galurl, 'sa=stats">', $txt['mgallery_stats'], '</a></div>
	<table cellpadding="5" cellspacing="0" width="100%"><tr class="windowbg"><td>
		<div class="smalltext">', $txt['mgallery_total_items'], ': ', $mgalSettings['total_items'], '</div>
		<div class="smalltext">', $txt['mgallery_total_albums'], ': ', $mgalSettings['total_albums'], '</div>
		<div class="smalltext">', $txt['mgallery_total_comments'], ': ', $mgalSettings['total_comments'], '</div>', mGalAllowedTo('manage') ? '
		' . show_stat($txt['mgallery_reported_items'], $mgalSettings['num_reported_items']) : '', '
	</td>';

	if (mGalAllowedTo('moderate'))
	{
		echo '
	<td style="text-align: right">
		', show_stat($txt['mgallery_unapproved_items'], $mgalSettings['num_unapproved_items']), '
		', show_stat($txt['mgallery_unapproved_albums'], $mgalSettings['num_unapproved_albums']), '
		', show_stat($txt['mgallery_unapproved_comments'], $mgalSettings['num_unapproved_comments']), mGalAllowedTo('manage') ? '
		' . show_stat($txt['mgallery_reported_comments'], $mgalSettings['num_reported_comments']) : '', '
	</td>';
	}
	echo '
	<tr></table>
</div>';
}

function show_stat($intro, $number)
{
	return '<div class="smalltext">' . ($number > 0 ? '<b>' : '') . $intro . ': ' . $number . ($number > 0 ? '</b>' : '') . '</div>';
}

function template_mgallery_viewItem()
{
	global $galurl, $context, $mgalSettings, $txt, $scripturl, $settings, $boardurl, $user_info, $mgalFunc;

	$item = $context['item_data'];

	// Show the item and info boxes
	echo '
	<div id="viewitem">';

	if (empty($mgalSettings['prev_next'])) // 3 items
		echo '
		<table cellspacing="0" cellpadding="2" border="0" class="mg_prevnext windowbg bordercolor" width="100%">
			<tr class="mg_prevnext_pad">
				<td rowspan="2">', (int) $item['prev'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev'].'">&laquo;</a>' : '&laquo;', '</td>
				<td width="33%">', (int) $item['prev'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev'].'"><img src="'.$item['prev_thumb'].'" alt="" /></a>' : $txt['mgallery_prev'], '</td>
				<td width="34%" class="titlebg"><img src="'.$item['current_thumb'].'" alt="" /></td>
				<td width="33%">', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'"><img src="'.$item['next_thumb'].'" alt="" /></a>' : $txt['mgallery_next'], '</td>
				<td rowspan="2">', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'">&raquo;</a>' : '&raquo;', '</td>
			</tr>
			<tr class="smalltext">
				<td>', (int) $item['prev'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev'].'">'.$item['prev_title'].'</a>' : '', '</td>
				<td class="titlebg">'.$item['current_title'].'</td>
				<td>', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'">'.$item['next_title'].'</a>' : '', '</td>
			</tr>
		</table>';
	elseif ($mgalSettings['prev_next'] == 1) // 5 items
		echo '
		<table cellspacing="0" cellpadding="3" border="0" class="mg_prevnext windowbg bordercolor" width="100%">
			<tr class="mg_prevnext_pad">
				<td rowspan="2">', (int) $item['prev_page'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev_page'].'">&laquo;</a>' : '&laquo;', '</td>
				<td width="20%">', (int) $item['prev2'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev2'].'"><img src="'.$item['prev2_thumb'].'" alt="" /></a>' : '', '</td>
				<td width="20%">', (int) $item['prev'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev'].'"><img src="'.$item['prev_thumb'].'" alt="" /></a>' : '', '</td>
				<td width="20%" class="titlebg"><img src="'.$item['current_thumb'].'" alt="" /></td>
				<td width="20%">', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'"><img src="'.$item['next_thumb'].'" alt="" /></a>' : '', '</td>
				<td width="20%">', (int) $item['next2'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next2'].'"><img src="'.$item['next2_thumb'].'" alt="" /></a>' : '', '</td>
				<td rowspan="2">', (int) $item['next_page'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next_page'].'">&raquo;</a>' : '&raquo;', '</td>
			</tr>
			<tr class="smalltext">
				<td>', (int) $item['prev2'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev2'].'">'.$item['prev2_title'].'</a>' : '', '</td>
				<td>', (int) $item['prev'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['prev'].'">'.$item['prev_title'].'</a>' : '', '</td>
				<td class="titlebg">'.$item['current_title'].'</td>
				<td>', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'">'.$item['next_title'].'</a>' : '', '</td>
				<td>', (int) $item['next2'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next2'].'">'.$item['next2_title'].'</a>' : '', '</td>
			</tr>
		</table>';
	elseif ($mgalSettings['prev_next'] == 2) // Text links
		echo '
		<div class="mg_prev">', (int) $item['prev'] > 0 ? '&laquo; <a href="'.$galurl.'sa=item;id='.$item['prev'].'">'.$txt['mgallery_prev'].'</a>' : '&laquo; '.$txt['mgallery_prev'], '</div>
		<div class="mg_next">', (int) $item['next'] > 0 ? '<a href="'.$galurl.'sa=item;id='.$item['next'].'">'.$txt['mgallery_next'].'</a> &raquo;' : $txt['mgallery_next'].' &raquo;', '</div>';

	echo '
		<div class="tborder">
			<div class="titlebg info" style="border: 1px solid white; text-align: center"><strong>', $item['title'], '</strong></div>
		</div>';

	echo '
		<div id="itembox">', $item['embed_object'], $item['is_resized'] ? '
			<div class="mg_subtext" style="padding-top: 6px">' . $txt['mgallery_resized'] . '</div>' : '', '
		</div>', !empty($item['description']) ? '
		<div class="mg_item_desc" style="margin: auto; text-align: justify; width: ' . (strlen($item['description']) > 800 ? '90%' : max($item['preview_width'], 400) . 'px') . '">' . $item['description'] . '</div>
		<br />' : '', $context['is_smf2'] ? '

		<div class="clearfix"></div>' : '<br style="clear: both" />';

	if (!$item['approved'] && ($item['member']['id'] == $user_info['id']) && !mgalAllowedTo('moderate') && !mgalAllowedTo('auto_approve_item'))
		echo '
		<div class="unapproved_yet">', $txt['mgallery_will_be_approved'], '</div>';

	if (!$item['approved'] && (mgalAllowedTo('moderate') || mgalAllowedTo('auto_approve_item')))
		echo '
		<div class="unapproved_yet">', $txt['mgallery_approve_this'], '</div>';

	echo '

		<table cellspacing="1" cellpadding="0" border="0" class="bordercolor" width="100%">
		<tr><td valign="top" class="windowbg" width="25%">
			<div class="titlebg header">', $txt['mgallery_poster_info'], '</div>', empty($item['member']['id']) ? '
			<h4>' . $txt['guest'] . '</h4>' : '
			<h4>' . $item['member']['link'] . '</h4>
			<ul class="smalltext info_list">' . (!empty($item['member']['group']) ? '
				<li>' . $item['member']['group'] . '</li>' : '') . (!empty($item['member']['avatar']['image']) ? '
				<li>' . $item['member']['avatar']['image'] . '</li>' : '') . '
				<li>' . $txt['mgallery_total_items'] . ': ' . $item['member']['mgallery']['total_items'] . '</li>
				<li>' . $txt['mgallery_total_comments'] . ': ' . $item['member']['mgallery']['total_comments'] . '</li>', '
			</ul>
		</td>
		<td valign="top" class="windowbg2"', $mgalSettings['show_extra_info'] == 1 ? ' rowspan="2"' : '', '>
			<div class="titlebg header">', $txt['mgallery_item_info'], '</div>
			<table cellspacing="0" cellpadding="3" border="0" width="100%">
			<tr><td class="info smalltext">', $txt['mgallery_posted_on'], '</td><td class="info">', timeformat($item['time_added']), '</td></tr>';

	if ($item['type'] != 'embed')
		echo !empty($item['width']) && !empty($item['height']) ? '
			<tr><td class="info smalltext" style="white-space: nowrap">' . $txt['mgallery_width'] . ' x ' . $txt['mgallery_height'] . '</td><td class="info">' . $item['width'] . 'x' . $item['height'] . '</td></tr>' : '', '
			<tr><td class="info smalltext">', $txt['mgallery_filesize'], '</td><td class="info">', $item['filesize'], ' ', $txt['mgallery_kb'], '</td></tr>
			<tr><td class="info smalltext">', $txt['mgallery_filename'], '</td><td class="info">', $item['filename'], '</td></tr>';

	if ((!empty($item['keyword_list']) && implode('', $item['keyword_list']) != '') || !empty($item['keywords']))
	{
		echo '
			<tr><td class="info smalltext">', $txt['mgallery_keywords'], '</td><td class="info">';
		$tag_list = '';
		if (!empty($item['keyword_list']))
		{
			foreach ($item['keyword_list'] as $tag)
				if (!empty($tag))
					$tag_list .= '<b><a href="' . $galurl . 'sa=search;search=' . urlencode($tag) . ';sch_kw">' . $tag . '</a></b>, ';
		}
		else
			echo $item['keywords'];
		echo substr($tag_list, 0, strlen($tag_list) - 2) . '</td></tr>';
	}

	echo '
			<tr><td class="info smalltext">', $txt['mgallery_views'], '</td><td class="info">', $item['views'], '</td></tr>', !empty($item['downloads']) ? '
			<tr><td class="info smalltext">' . $txt['mgallery_downloads'] . '</td><td class="info">' . $item['downloads'] . '</td></tr>' : '', '
			<tr><td class="info smalltext">', $txt['mgallery_rating'], '</td><td class="info" id="ratingElement">', template_mgallery_rating_object($item), '</td></tr>',
			!empty($item['num_comments']) ? '
			<tr><td class="info smalltext">' . $txt['mgallery_comments'] . '</td><td class="info">' . $item['num_comments'] . '</td></tr>' : '', !empty($item['last_edited']) ? '
			<tr><td class="info smalltext">' . $txt['mgallery_last_edited'] . '</td><td class="info">' . $item['last_edited'] . ($item['last_edited_by'] !== -2 ? ' ' . $txt['mgallery_by'] . ' ' . $item['last_edited_by'] : '') . '</td></tr>' : '';

	foreach ($item['custom_fields'] as $field)
	{
		if (!empty($field['value']))
			echo '
			<tr>
				<td class="info smalltext">', $field['name'], '</td>
				<td class="info">', $field['searchable'] ? '<a href="' . $galurl . 'sa=search;search=' . urlencode($field['value']) . ';fields[]=' . $field['id'] . '">' . $mgalFunc['htmlspecialchars']($field['value']) . '</a>' : (substr($field['value'], 0, 7) == 'http://' ? '<a href="' . $field['value'] . '">' . $mgalFunc['htmlspecialchars']($field['value']) . '</a>' : $field['value']), '</td>
			</tr>';
	}

	if ($mgalSettings['show_linking_code'])
	{
		echo '
			<tr>
				<td class="info smalltext">', $txt['mgallery_embed_bbc'], '</td>
				<td class="info">
					<input id="bbc_embed" type="text" size="56" value="[smg id=' . $item['id_media'] . ($item['type'] == 'image' ? '' : ' type=av') . ']" onclick="return selectText(this);" readonly="readonly" />
					<a href="', $scripturl, '?action=mgallery;sa=smgtaghelp" onclick="return reqWin(this.href, 600, 400);"><img alt="" src="', $settings['images_url'], '/helptopics.gif" class="vam" border="0" /></a>
				</td>
			</tr>';

		// Don't show html/direct links if the helper file was deleted
		if ($mgalSettings['show_linking_code'] == 1)
		{
			if (strpos($item['embed_object'], 'swfobject.embedSWF') === false)
				echo '
			<tr>
				<td class="info smalltext">', $txt['mgallery_embed_html'], '</td><td class="info">
					<input id="html_embed" type="text" size="60" value="', $item['type'] == 'image' ?
						htmlspecialchars('<img src="' . $boardurl . '/MGalleryItem.php?id=' . $item['id_media'] . '" alt="" />') :
						htmlspecialchars(trim(preg_replace('/[\t\r\n]+/', ' ', $item['embed_object']))), '" onclick="return selectText(this);" readonly="readonly" />
				</td>
			</tr>';
			if ($item['type'] != 'embed')
				echo '
			<tr>
				<td class="info smalltext">' . $txt['mgallery_direct_link'] . '</td>
				<td class="info">
					<input id="direct_link" type="text" size="60" value="' . $boardurl . '/MGalleryItem.php?id=' . $item['id_media'] . '" onclick="return selectText(this);" readonly="readonly" />
				</td>
			</tr>';
		}
	}
	echo '
			</table>
		</td></tr>';

	if ($mgalSettings['show_extra_info'] == 1)
	{
		echo '
		<tr><td valign="bottom" class="windowbg">
			<div class="titlebg header">', $txt['mgallery_extra_info'], '</div>';

		if (empty($item['extra_info']))
			echo '
			<div class="info">', $txt['mgallery_exif_not_available'], '</div>';
		else
		{
			echo $mgalSettings['use_lightbox'] ? '
			<div class="info"><img alt="" src="' . $settings['images_url'] . '/mgallery/magnifier.png" class="vam" /> <a href="#" onclick="return hs.htmlExpand(this);">'
			. $txt['mgallery_exif_entries'] . '</a> (' . count($item['extra_info']) . ')
			<div class="highslide-maincontent">
				<div class="titlebg header" style="padding: 4px; margin-bottom: 8px">' . $txt['mgallery_extra_info'] . '</div>' : '', '
				<div class="smalltext exif">';

			foreach ($item['extra_info'] as $info => $data)
				if (!empty($data))
					echo '
					<div class="info"><b>', $txt['mgallery_exif_'.$info], '</b>: ', $data, '</div>';
			echo '
				</div>
			</div>', $mgalSettings['use_lightbox'] ? '</div>' : '';
		}
		echo '
		</td></tr>';
	}

	echo '
		<tr><td align="center" colspan="2" class="windowbg3 info images" style="line-height: 16px; vertical-align: text-bottom">
			', mGalAllowedTo('comment') ? '<a href="' . $galurl . 'sa=comment;id=' . $item['id_media'] . '"' . ($mgalSettings['use_lightbox'] ? ' onclick="return hs.htmlExpand(this);"' : '') . '><img alt="" src="'.$settings['images_smg'].'/comment.png" /> ' . $txt['mgallery_comment_this_item'] . '</a>' : '';

	if (mGalAllowedTo('comment') && $mgalSettings['use_lightbox'])
		echo '
			<div class="highslide-maincontent">
				<form action="'.$galurl.'sa=comment;id='.$item['id_media'].'" method="post">
					<h3>'.$txt['mgallery_commenting_this_item'].'</h3>
					<img alt="" src="'.$settings['images_smg'].'/comment.png" align="middle" /> <a href="' . $galurl . 'sa=comment;id=' . $item['id_media'] . '">' . $txt['mgallery_switch_fulledit'] . '</a>
					<hr /><textarea name="comment" cols="" rows="8" style="width: 98%"></textarea>
					<p class="mgra"><input type="submit" value="'.$txt['mgallery_submit'].'" name="submit_mgal" class="smgbutton_ok" /> <input type="button" onclick="return hs.close(this);" value="'.$txt['mgallery_close'].'" class="smgbutton_cancel" /></p>
				</form>
			</div>';

	echo $item['can_report'] ? '
			<a href="'.$galurl.'sa=report;type=item;id='.$item['id_media'].'"' . ($mgalSettings['use_lightbox'] ? ' onclick="return hs.htmlExpand(this);"' : '') . '><img alt="" src="'.$settings['images_smg'].'/report.png" /> ' . $txt['mgallery_report_this_item'] . '</a>' : '';

	if ($item['can_report'] && $mgalSettings['use_lightbox'])
		echo '
			<div class="highslide-maincontent">
				<form action="'.$galurl.'sa=report;type=item;id='.$item['id_media'].'" method="post">
					<h3>'.$txt['mgallery_reporting_this_item'].'</h3>
					<hr />'.$txt['mgallery_reason'].'<br />
					<textarea cols="" rows="8" style="width: 98%" name="reason"></textarea>
					<p class="mgra"><input type="submit" value="'.$txt['mgallery_submit'].'" class="smgbutton_ok" name="submit_mgal" /> <input type="button" onclick="return hs.close(this);" value="'.$txt['mgallery_close'].'" class="smgbutton_cancel" /></p>
				</form>
			</div>';

	if ($item['can_edit'])
		echo '
			<a href="'.$galurl.'sa=post;id='.$item['id_media'].'"><img alt="" src="'.$settings['images_smg'].'/camera_edit.png" /> ' . $txt['mgallery_edit_this_item'] . '</a>
			<a href="'.$galurl.'sa=delete;id='.$item['id_media'].'"' . ($mgalSettings['use_lightbox'] ? ' onclick="return hs.htmlExpand(this);"' : ' onclick="return confirm(\''.$txt['mgallery_confirm'].'\')"') . '><img alt="" src="'.$settings['images_smg'].'/delete.png" /> ' . $txt['mgallery_delete_this_item'] . '</a>';

	if ($item['can_edit'] && $mgalSettings['use_lightbox'])
		echo '
			<div class="highslide-maincontent">
				<form action="'.$galurl.'sa=delete;id='.$item['id_media'].'" method="post">
					<h3>'.$txt['mgallery_delete_this_item'].'</h3>
					<hr />
					'.$txt['mgallery_confirm'].'
					<p class="mgra"><input type="submit" value="' . $txt['mgallery_yes'] . '" class="smgbutton_ok" /> <input type="button" onclick="return hs.close(this);" value="'.$txt['mgallery_no'].'" class="smgbutton_cancel" /></p>
				</form>
			</div>';

	echo
		mgalAllowedTo('download_item') && $item['type'] != 'embed' ? '
			<a href="'.$galurl.'sa=media;id='.$item['id_media'].';dl"><img alt="" src="'.$settings['images_smg'].'/download.png" /> ' . $txt['mgallery_download_this_item'] . '</a>' : '';

	if ($item['can_edit'])
		echo '
			<a href="'.$galurl.'sa=move;id='.$item['id_media'].'" '.($mgalSettings['use_lightbox'] ? 'onclick="return hs.htmlExpand(this);"' : '').'><img alt="" src="'.$settings['images_smg'].'/arrow_out.png" /> ' . $txt['mgallery_move_item'] . '</a>';

	if ($item['can_edit'] && $mgalSettings['use_lightbox'])
	{
		echo '
			<div class="highslide-maincontent">
				<h3>', $txt['mgallery_moving_this_item'], '</h3>
				<h2>', $txt['mgallery_album'], ': ', $item['album_name'], '</h2>
				<hr />
				<form action="', $galurl, 'sa=move;id=', $item['id_media'], '" method="post">
					', $txt['mgallery_album_to_move'], ': <select name="album">';

			foreach ($context['mgallery_move_albums'] as $album => $name)
				echo '<option value="'.$album.'" ', $album == $item['album_id'] ? 'disabled="disabled"' : '', '>'.$name.'</option>';

			echo '
					</select>
					<p class="mgra"><input type="submit" value="'.$txt['mgallery_submit'].'" class="smgbutton_ok" name="submit_mgal" /> <input type="button" onclick="return hs.close(this);" value="'.$txt['mgallery_close'].'" class="smgbutton_cancel" /></p>
				</form>
			</div>';
	}

	$un = $item['approved'] ? 'un' : '';
	echo $item['can_approve'] ? '
			<a href="'.$galurl.'sa='.$un.'approve;id='.$item['id_media'].'"><img alt="" src="'.$settings['images_smg'].'/'.$un.'tick.png" /> '.$txt['mgallery_admin_'.$un.'approve'].'</a>' : '';

	echo '
		</td></tr>
		</table>';

	if (isset($item['playlists'], $item['playlists']['current']))
		smg_foxy_show_playlists($item['id_media'], $item['playlists']);

	// Comments!
	if (!empty($item['comments']))
		echo '
		<table cellspacing="1" cellpadding="0" border="0" class="bordercolor" width="100%" style="margin-top: 12px" id="mg_coms">
		<tr><td valign="top" class="titlebg header">
			<span class="comment_header">', $txt['mgallery_comments'], '</span>
			<span class="smalltext comment_sort_options">', $txt['mgallery_sort_order_com'], ' -
			<a href="', $galurl, 'sa=item;id=', $item['id_media'], isset($_REQUEST['start']) ? ';start=' . $_REQUEST['start'] : '', '">', $txt['mgallery_sort_order_asc'], '</a>
			<a href="' . $galurl . 'sa=item;id=' . $item['id_media'] . ';com_desc', isset($_REQUEST['start']) ? ';start=' . $_REQUEST['start'] : '', '">', $txt['mgallery_sort_order_desc'], '</a>
			</span>
		</td></tr>
		<tr><td class="titlebg2 page_index">', $txt['mgallery_pages'], ': ', $item['com_page_index'], '</td></tr>';

	$alternative = false;
	foreach ($item['comments'] as $c)
	{
		$alternative = !$alternative;
		echo '
		<tr><td class="windowbg', !$alternative ? '2' : '', '">
			<table cellpadding="0" cellspacing="0" border="0"', $c['approved'] ? '' : ' class="unapp"', '><tr>
			<td width="20%"', $c['is_edited'] ? ' rowspan="2"' : '', '>', empty($c['member']['id']) ? '
				<h4>' . $txt['guest'] . '</h4>' : '
				<h4>' . $c['member_link'] . '</h4>
				<ul class="smalltext info_list">' . (!empty($c['member']['group']) ? '
					<li>' . $c['member']['group'] . '</li>' : '') . (!empty($c['member']['avatar']['image']) ? '
					<li>' . $c['member']['avatar']['image'] . '</li>' : '') . '
					<li>' . $txt['mgallery_total_items'] . ': ' . $c['member']['mgallery']['total_items'] . '</li>
					<li>' . $txt['mgallery_total_comments'] . ': ' . $c['member']['mgallery']['total_comments'] . '</li>
				</ul>', '
			</td>
			<td valign="top">
				<a name="com', $c['id_comment'], '"></a>
				<div class="mgc_main">
					', $txt['mgallery_comment'], ' <a href="#com', $c['id_comment'], '" rel="nofollow">#', $c['counter'], '</a> - ',
				is_numeric($c['posted_on'][0]) ? $txt['mgallery_posted_on_date'] : $txt['mgallery_posted_on'], ' ', $c['posted_on'], '
				</div>';

		// Currently, only managers can approve a comment from here. Needs to be changed...
		if ($c['can_edit'] || $c['can_report'])
			echo '
				<div class="mgc_icons">', $c['can_edit'] ? '
					<a href="'.$galurl.'sa=edit;type=comment;id='.$c['id_comment'].'"><img alt="" src="'.$settings['images_smg'].'/comment_edit.png" /> '.$txt['mgallery_edit_this_item'].'</a>
					<a href="'.$galurl.'sa=delete;type=comment;id='.$c['id_comment'].'" onclick="return confirm(\''.$txt['mgallery_confirm'].'\')"><img alt="" src="'.$settings['images_smg'].'/delete.png" /> '.$txt['mgallery_delete_this_item'].'</a> ' : '', $c['can_report'] ? '
					<a href="'.$galurl.'sa=report;type=comment;id='.$c['id_comment'].'"><img alt="" src="'.$settings['images_smg'].'/report.png" /> '.$txt['mgallery_report_this_item'].'</a>' : '', !$c['approved'] && mgalAllowedTo('manage') ? '
					<a href="'.$scripturl.'?action=mgallery;area=moderate;sa=submissions;do=approve;id='.$c['id_comment'].';type=coms;' . $context['session_var'] . '='.$context['session_id'].'"><img alt="" src="'.$settings['images_smg'].'/tick.png" title="'.$txt['mgallery_admin_approve'].'" /> '.$txt['mgallery_admin_approve'].'</a>' : '', '
				</div>';

		echo '
				<div class="mgc_post">
					', $c['message'], '
				</div>
			</td></tr>', $c['is_edited'] ? '
			<tr><td valign="bottom">
				<div class="mgc_last_edit">' . $txt['mgallery_last_edited'] . ': ' . $c['last_edited']['on'] .
				($c['last_edited']['id'] > -2 ? ' ' . strtolower($txt['mgallery_by']) . ' ' . $c['last_edited']['link'] : '') . '</div>
			</td></tr>' : '';

		echo '
			</table>
		</td></tr>';
	}
	echo !empty($item['comments']) ? '
		</table>' : '', '
	</div>';
}

function template_mgallery_done()
{
	// Template to show some "done" kind of things, uses $context['mgallery_done_txt'] as its context to show
	global $context;
	echo '
		<div style="font-size: 1.2em">
			<table border="0" width="100%" height="100px">
				<tr class="windowbg2">
					<td align="center">', $context['mgallery_done_txt'], '</td>
				</tr>
			</table>
		</div>';
}

function template_mgallery_form()
{
	// This is a pretty global template used for forms like reporting, commenting, adding, editing etc.
	global $mgalSettings, $context, $txt, $galurl;
	static $chk = 1;

	echo '
	<form action="', $context['mgallery_form_url'], '" method="post" enctype="multipart/form-data" id="mgal_form" name="mgal_form" onsubmit="submitonce(this);">
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor"', !empty($context['mgallery_form']) && isset($context['mgallery_form']['whitespace']) ? ' style="margin-top: 12px"' : '', '>';

	// Form headers
	if (isset($context['mgallery_form_headers']))
		foreach ($context['mgallery_form_headers'] as $h)
			if (!isset($h[1]) || $h[1])
				echo '
			<tr class="windowbg2"><td colspan="2" align="center">', $h[0], '</td></tr>';

	// The form itself.
	foreach ($context['mgallery_form'] as $e)
	{
		if ((!isset($e['perm']) || $e['perm']))
		{
			// If there's a text editor in the form, adjust the name/description column width accordingly.
			if (!isset($e['skip']))
				echo '
			<tr>', $e['type'] != 'title' ? '
				<td width="' . (isset($context['post_box_name']) ? ($context['post_box_name'] == 'desc' ? '35' : '10') : '50') . '%" class="windowbg2" valign="top">'.$e['label'].(isset($e['subtext']) ? '<div class="mg_subtext">'.$e['subtext'].'</div>' : '').'</td>
				<td class="windowbg2">' : '<td class="'.(isset($e['class']) ? $e['class'] : 'titlebg').'" colspan="2">'.$e['label'].'</td>';

			if ($e['type'] != 'title')
				switch($e['type'])
				{
					case 'text';
						echo '<input type="text"', isset($e['value']) ? ' value="'.$e['value'].'"' : '', ' name="', $e['fieldname'], '" size="', !empty($e['size']) ? $e['size'] : 50, '"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' />';
					break;
					case 'textbox';
						if (isset($context['post_box_name']) && $context['post_box_name'] == $e['fieldname'])
							template_mgallery_text_editor();
						else
							echo '<textarea name="', $e['fieldname'], '"', isset($e['custom']) ? ' ' . $e['custom'] : '', '>', isset($e['value']) ? $e['value'] : '', '</textarea>';
					break;
					case 'file';
						echo '<input type="file" name="', $e['fieldname'], '"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' />', isset($e['add_text']) ? ' ' . $e['add_text'] : '';
					break;
					case 'hidden';
						echo '<input type="hidden" name="', $e['fieldname'], '" value="', $e['value'], '"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' />';
					break;
					case 'small_text';
						echo '<input type="text"', isset($e['value']) ? ' value="'.$e['value'].'"' : '', ' name="', $e['fieldname'], '" size="15"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' />';
					break;
					case 'select';
						echo '<select name="', $e['fieldname'], isset($e['multi']) && $e['multi'] === true ? '[]' : '',	'" ',
							isset($e['multi']) && $e['multi'] === true ? 'multiple="multiple"' . (!empty($e['size']) ? ' size="' . $e['size'] . '"' : '') : '',
							isset($e['custom']) ? ' ' . $e['custom'] : '', '>';
						foreach ($e['options'] as $value => $name)
						{
							if (is_array($name) && isset($name[2]))
								echo $name[2] == 'begin' ? '<optgroup label="' . $name[0] . '">' : '</optgroup>';
							else
								echo '<option value="', $value, '"', is_array($name) && isset($name[1]) && $name[1] == true ? ' selected="selected"' : '', '>', is_array($name) ? $name[0] : $name, '</option>';
						}
						echo '</select>';
					break;
					case 'radio';
						foreach ($e['options'] as $value => $name)
							echo '<div><input id="radio', $chk, '" name="'.$e['fieldname'].'" value="'.$value.'"',is_array($name) && isset($name[1]) && $name[1] === true ? ' checked="checked"' : '', ' type="radio"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' /><label for="radio', $chk++, '"> ', is_array($name) ? $name[0] : $name, '</label></div>';
					break;
					case 'yesno';
						echo '<div><input id="yesno', $chk, '" name="', $e['fieldname'], '" value="1"', !empty($e['value']) ? ' checked="checked"' : '', ' type="radio" /><label for="yesno', $chk, '"> <span style="color: green">', $txt['mgallery_yes'], '</span></label> <input id="noyes', $chk, '" name="', $e['fieldname'], '" value="0"', empty($e['value']) ? ' checked="checked"' : '', ' type="radio" /><label for="noyes', $chk++, '"> <span style="color: red">', $txt['mgallery_no'], '</span></label></div>';
					break;
					case 'passwd';
						echo '<input name="', $e['fieldname'], '" value="', isset($e['value']) ? $e['value'] : '', '" type="password"', isset($e['custom']) ? ' ' . $e['custom'] : '', ' />';
					break;
					case 'checkbox';
						foreach ($e['options'] as $opt => $label)
						{
							if (!is_array($label) && $label == 'sep')
								echo '<hr />';
							else
								echo '<div><input type="checkbox" id="chk', $chk, '" name="', is_array($label) ?
									(!isset($label['force_name']) ? $e['fieldname'] . (isset($e['multi']) && $e['multi'] === true ? '[]' : '') : $label['force_name']) : $label,
									'" value="', $opt, '"', is_array($label) && isset($label[1]) && $label[1] === true ? ' checked="checked"' : '', is_array($label) && !empty($label['disabled']) ? ' disabled="disabled"' : '', 
									is_array($label) && isset($label['custom']) ? ' ' . $label['custom'] : '', ' /><label for="chk', $chk++, '"> ', is_array($label) ? $label[0] : $label, '</label></div>';
						}
					break;
					case 'link';
						echo '<a href="', $e['link'], '">', $e['text'], '</a>', !empty($e['add_text']) ? ' ' . $e['add_text'] : '';
					break;
				}

			if (!empty($e['next']))
				echo $e['next'];
			if (!isset($e['skip']) && $e['type'] != 'title')
				echo '
				</td>';
			echo '
			</tr>';
		}
	}

	// End the form.
	echo '
			<tr>
				<td class="windowbg" colspan="2" align="right"><input type="submit" value="', $txt['mgallery_submit'], '" name="submit_mgal" /></td>
			</tr>
		</table>
	</form>';

	if (!empty($context['mgallery_extra_data']))
		echo $context['mgallery_extra_data'];
}

function template_mgallery_viewAlbum()
{
	global $context, $txt, $galurl, $scripturl, $mgalSettings, $settings, $user_info;

	$album_data = &$context['album_data'];

	// Show some album data
	echo '
	<div id="albums">
		<table cellpadding="6" cellspacing="0" border="0" width="100%">
		<tr><td class="titlebg" width="2%"><img alt="" src="', $galurl, 'sa=media;id=', $album_data['id'], ';icon" /></td><td class="windowbg2">
			<div class="mg_large mg_pb4">', $album_data['name'], '</div>
			<div>', $album_data['type2'], $album_data['type'] == 'user' ? '
			- ' . $txt['mgallery_owner'] . ': ' . smg_profile($album_data['owner']['id'], $album_data['owner']['name']) : '', '
			- ', $album_data['num_items'], ' ', $txt['mgallery_items'], !empty($album_data['last_item']) ? ' - ' . $txt['mgallery_latest_item'] . ': <a href="'.$galurl.'sa=item;id='.$album_data['last_item'].'">'.$album_data['last_item_title'].'</a> (' . $album_data['last_item_date'] . ')' : '', '</div>
			<div class="mg_desc">', $album_data['description'], '</div>', $album_data['hidden'] && $album_data['owner']['id'] != 0 ? '
			<div style="color: red">' . $txt['mgallery_album_is_hidden'] . '</div>' : '', '
		</td></tr>
		</table>';

	$can_moderate_here = mgalAllowedTo('moderate') || (!$user_info['is_guest'] && $user_info['id'] == $album_data['owner']['id']);
	if ($can_moderate_here || $context['mgallery_can_add_item'] || $context['mgallery_can_multi_upload'] || mgalAllowedTo('multi_download'))
	{
		echo '
	<div class="windowbg data">';

		if ($context['mgallery_can_add_item'])
			echo '
			<img alt="" src="', $settings['images_smg'], '/camera_add.png" />&nbsp;<a href="', $galurl, 'sa=post;album=', $album_data['id'], '">', $txt['mgallery_add_item'], '</a>';

		if ($context['mgallery_can_multi_upload'])
			echo '
			<img alt="" src="', $settings['images_smg'], '/camera_mass.png" />&nbsp;<a href="', $galurl, 'sa=mass;album=', $album_data['id'], '">', $txt['mgallery_multi_upload'], '</a>';

		if ($can_moderate_here)
		{
			echo '
			<img alt="" src="', $settings['images_smg'], '/folder_edit.png" title="', $txt['mgallery_admin_edit'], '" />&nbsp;<a href="', $galurl, 'area=mya;sa=edit;id=' . $album_data['id'] . '">' . $txt['mgallery_admin_edit'] . '</a>';
			if (mgalAllowedTo('moderate') && $album_data['approved'] == 0)
				echo '
			<img alt="" src="'.$settings['images_smg'].'/tick.png" title="'.$txt['mgallery_admin_approve'].'" />&nbsp;<a href="', $scripturl.'?action=mgallery;area=moderate;sa=submissions;do=approve;type=albums;id='.$album_data['id'].';' . $context['session_var'] . '='.$context['session_id'].'">'.$txt['mgallery_admin_approve'].'</a>';
		}

		if (mgalAllowedTo('multi_download'))
			echo '
			<img alt="" src="', $settings['images_smg'], '/download.png" title="', $txt['mgallery_multi_download'], '" />&nbsp;<a href="', $galurl, 'sa=massdown;album=', $album_data['id'], '">', $txt['mgallery_multi_download'], '</a>';

		echo '
		</div>';
	}

	// Show their Sub-Albums
	if (!empty($context['mgallery_sub_albums']))
	{
		echo '
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
			<tr class="catbg3"><td colspan="3">', $txt['mgallery_sub_albums'], '</td></tr>
			<tr class="catbg">
				<td width="8%">', $txt['mgallery_icon'], '</td>
				<td>', $txt['mgallery_name'], '</td>
				<td>', $txt['mgallery_items'], '</td>
			</tr>';

		foreach ($context['mgallery_sub_albums'] as $album)
		{
			echo '
			<tr class="windowbg2">
				<td valign="top" align="center">', $album['icon'], '</td>
				<td>
					<a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a><div class="mg_desc">', $album['description'], '</div>
				</td>
				<td>
					', $album['items'], '
				</td>
			</tr>
			', !empty($album['sub_albums']) ? '<tr class="windowbg"><td colspan="3" class="smalltext">'.implode(', ', $album['sub_albums']).'</td></tr>' : '';
		}
		echo '
		</table>';
	}

	if ($context['no_items'] || empty($context['mgallery_items']))
	{
		echo '
		<p class="windowbg2 notice">
			', $txt['mgallery_no_listing'], '
		</p>
	</div>';
		return;
	}

	// Page index and sorting things
	$sort_list = array('m.id_media' => 0, 'm.time_added' => 1, 'm.title' => 2, 'm.views' => 3, 'm.weighted' => 4);
	echo '
		<div class="windowbg smalltext sort_options">
			<div class="windowbg smalltext view_options">
				', $txt['mgallery_items_view'], ': ', $album_data['view'] == 'normal' ? '<b>' . $txt['mgallery_view_normal'] . '</b> <a href="' . $galurl . 'sa=album;id=' . $album_data['id'] . ';fw'.  $context['mgal_urlmore'] . '">' . $txt['mgallery_view_filestack'] . '</a>' : '<a href="' . $galurl . 'sa=album;id=' . $album_data['id'] . ';nw' . $context['mgal_urlmore'] . '">' . $txt['mgallery_view_normal'] . '</a> <b>' . $txt['mgallery_view_filestack'] . '</b>', '
			</div>
			', $txt['mgallery_sort_by'], ':';
	$sort = empty($sort_list[$context['mgal_sort']]) ? 0 : $sort_list[$context['mgal_sort']];
	for ($i = 0; $i < 5; $i++)
		echo $sort == $i ? ' <b>' . $txt['mgallery_sort_by_'.$i] . '</b>' :
			' <a href="'.$galurl.'sa=album;id='.$album_data['id'] . ';sort=' . $i . ($album_data['view'] == 'normal' ? ';nw' : ';fw') . '">' . $txt['mgallery_sort_by_'.$i] . '</a>';
	echo '
			| ', $txt['mgallery_sort_order'], ':',
		($context['mgal_asc'] ? ' <b>' . $txt['mgallery_sort_order_asc'] . '</b>' : ' <a href="'.$galurl.'sa=album;id='.$album_data['id'].(isset($_REQUEST['sort']) ? ';sort='.$_REQUEST['sort'] : '').';asc;' . ($album_data['view'] == 'normal' ? 'nw' : 'fw') . '">' . $txt['mgallery_sort_order_asc'] . '</a>'),
		(!$context['mgal_asc'] ? ' <b>' . $txt['mgallery_sort_order_desc'] . '</b>' : ' <a href="'.$galurl.'sa=album;id='.$album_data['id'] . (isset($_REQUEST['sort']) ? ';sort=' . $_REQUEST['sort'] : '').';desc;' . ($album_data['view'] == 'normal' ? 'nw' : 'fw') . '">'.$txt['mgallery_sort_order_desc'].'</a>'), '
		</div>
		<div class="titlebg page_index">
			', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
		</div>',
		$album_data['view'] == 'normal' ? smg_item_list($context['mgallery_items'], true) : smg_filestack_list($context['mgallery_items']), '
		<div class="titlebg page_index" style="margin-top: 8px">
			', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
		</div>
	</div>';
}

function template_mgallery_unseen()
{
	global $context, $txt, $galurl, $scripturl;

	if (!empty($context['mgallery_items']))
	{
		$mark_seen = array('markseen' => array('text' => 'mgallery_mark_as_seen', 'image' => 'markread.gif', 'lang' => true, 'url' => $galurl . 'sa=unseen;markseen;' . $context['session_var'] . '=' . $context['session_id']));
		mgal_button_strip($mark_seen, 'top');
	}

	echo '
	<br />
	<div class="titlebg page_index">
		', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
	</div>
	<div id="unseen_items">', !empty($context['mgallery_items']) ? smg_item_list($context['mgallery_items']) : '<div class="notice">' . $txt['mgallery_no_listing'] . '</div>', '
	</div>
	<div class="titlebg page_index">
		', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
	</div>';
}

function template_mgallery_search_searching()
{
	global $txt, $galurl, $scripturl, $context, $settings;

	echo '
	<form action="'.$galurl.'sa=search" method="post">
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="tborder">
			<tr class="windowbg2">
				<td colspan="2" align="center">', $txt['mgallery_search_for'], ': <input type="text" name="search" size="50" /></td>
			</tr>
			<tr class="windowbg2">
				<td width="50%" align="right">', $txt['mgallery_search_in_title'], ': <input type="checkbox" name="sch_title" checked="checked" /></td>
				<td width="50%" align="left">', $txt['mgallery_search_in_description'], ': <input type="checkbox" name="sch_desc" /></td>
			</tr>
			<tr class="windowbg2">
				<td width="50%" align="right">', $txt['mgallery_search_in_kw'], ': <input type="checkbox" name="sch_kw" /></td>
				<td width="50%" align="left">', $txt['mgallery_search_in_album'], ':
					<select name="sch_album">
						<option value="0">', $txt['mgallery_search_in_all_albums'], '</option>';

	foreach ($context['mgallery_albums'] as $id => $name)
		echo '<option value="', $id, '">', $name, '</option>';

	echo '
					</select>
				</td>
			</tr>';

	foreach ($context['custom_fields'] as $field)
	{
		echo '
			<tr class="windowbg2">
				<td colspan="2" align="center">
					', sprintf($txt['mgallery_search_in_cf'], $field['name']), ' <input type="checkbox" name="fields[]" value="' . $field['id'] . '" />
				</td>
			</tr>';
	}

	echo '
			<tr class="windowbg2">
				<td width="50%" align="right">', $txt['mgallery_search_by_mem'], '<div class="mg_subtext">', $txt['mgallery_search_by_mem_sub'], '</div></td>
				<td width="50%" align="left"><input name="sch_mem" id="sch_mem" type="text" size="25" /><a href="', $scripturl, '?action=mgallery;action=findmember;input=sch_mem;' . $context['session_var'] . '=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img alt="" src="', $settings['images_url'], '/icons/assist.gif" /></a></td>
			</tr>
			<tr class="windowbg2">
				<td colspan="2" align="center"><input type="submit" name="submit_mgal" value="', $txt['mgallery_submit'], '" /></td>
			</tr>
		</table>
	</form>';
}

function template_mgallery_search_results()
{
	global $context, $txt, $scripturl;

	echo '
	<div class="titlebg page_index">
		', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
	</div>
	<div style="padding: 5px"><b>', $context['mgallery_total_results'], '</b> ', $txt['mgallery_search_results_for'], ' <b>', $context['mgallery_searching_for'], '</b></div>';

	if (!empty($context['smg_foxy_rendered_search']))
		echo $context['smg_foxy_rendered_search'];
	else
		echo '
	<div id="search_items">',
	smg_item_list($context['mgallery_items']), '
	</div>
	', $context['is_smf2'] ? '<div class="clearfix"></div>' : '<br style="clear: both" />';
}

function smg_show_sub_albums($alb)
{
	global $context, $galurl, $settings, $txt, $mgalFunc;

	$ret = '';
	foreach ($context['mgallery_albums'][$alb]['sub_albums'] as $sub_album)
	{
		$album = &$context['mgallery_albums'][$sub_album['id']];
		$ret .= smg_locked_album($album['passwd'], $album['id'], $album['owner']['id'], $album['num_items'] . ' ' . $txt['mgallery_items'])
				. '	<a href="' . $galurl.'sa=album;id=' . $album['id'] . '"' . (!$album['approved'] ? ' class="unapp"' : '') . '>' . $album['name'] . '</a>';

		if (!empty($album['sub_albums']))
			$ret .= ' (' . smg_show_sub_albums($album['id_album']) . ')';
		$ret .= ', ';
	}
	return rtrim($ret, ', ');
}

function template_mgallery_viewUserAlbums()
{
	global $txt, $context, $scripturl, $galurl, $sourcedir;

	$foxy = file_exists($sourcedir . '/MGallery-Foxy.php');

	// The Albums!
	echo '
	<div class="catbg item_heading">', $context['show_general_albums_link'] ? '
		<b><a href="'.$galurl.'">'.$txt['mgallery_albums'].'</a></b> -' : '', '
		<b>'.$txt['mgallery_user_albums'].'</b>', $foxy ? ' -
		<b><a href="'.$galurl.'sa=playlists">'.$txt['mgallery_playlists'].'</a></b>' : '', '
	</div>';

	echo '
	<table border="0" width="100%" cellspacing="1" cellpadding="4" class="tborder">
		<tr class="windowbg">
			<td colspan="4">', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '</td>
		</tr>
		<tr class="titlebg2">
			<td width="8%">', $txt['mgallery_icon'], '</td>
			<td>', $txt['mgallery_name'], '</td>
			<td>', $txt['mgallery_items'], '</td>
		</tr>';

	$current_owner = 0;
	foreach ($context['mgallery_user_albums'] as $album)
	{
		if ($album['owner']['id'] != $current_owner)
		{
			$current_owner = $album['owner']['id'];
			echo '
		<tr class="catbg item_heading">
			<td colspan="3">', $txt['mgallery_owner'], ': ', smg_profile($current_owner, $album['owner']['name']), '</td>
		</tr>';
		}
		echo '
		<tr class="windowbg">
			<td valign="top" align="center">', $album['icon']['src'], '</td>
			<td', !$album['approved'] ? ' class="unapp"' : '', '>
			<div class="mg_large"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a>',
			smg_locked_album($album['passwd'], $album['id'], $album['owner']['id']), '</div>
			<div class="mg_desc">', $album['description'], '</div></td>
			<td>', $album['num_items'], '</td>
		</tr>';
		if (!empty($album['sub_albums']))
			echo '
		<tr class="windowbg"><td colspan="4">', $txt['mgallery_sub_albums'], ': ', smg_show_sub_albums($album['id']), '</td></tr>';
	}
	echo '
	</table>';
}

// Show my user albums
function template_mgallery_useralbums_home()
{
	global $txt, $context, $scripturl, $galurl, $settings;

	echo '
		<script type="text/javascript"><!-- // --><![CDATA[
			var has_icon = new Array();';

	foreach ($context['mgallery_icon_ids'] as $id_album => $id_icon)
		echo '
			has_icon['.$id_album.'] = '.($id_icon > 0 ? 1 : 0).';';

	echo '
		// ]]></script>
		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="tborder" style="margin-top: 2ex">
			<tr class="titlebg">
				<td width="2%">&nbsp;</td>
				<td width="55%">', $txt['mgallery_name'], '</td>
				<td width="28%">', $txt['mgallery_admin_moderation'], '</td>
			</tr>
			<tr class="windowbg2">
				<td colspan="3"><a href="javascript:admin_toggle_all();">', $txt['mgallery_toggle_all'], '</a></td>
			</tr>';

	foreach ($context['mgallery_albums'] as $album)
	{
		echo '
			<tr class="windowbg2">
				<td><a href="javascript:admin_toggle('.$album['id'].', true);"><img alt="" src="', $settings['images_url'], '/expand.gif" id="toggle_img_', $album['id'], '" /></a></td>
				<td', !$album['approved'] ? ' class="unapp"' : '', ' style="padding-left: ',5 + 30 * $album['child_level'], 'px"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a><br />';

		echo '
				</td>
				<td><a href="', $galurl, 'area=mya;sa=edit;id=', $album['id'], '">', $txt['mgallery_admin_edit'], '</a></td>
			</tr>
			<tr class="windowbg" style="display: none" id="tr_expand_', $album['id'], '">
				<td colspan="4">
					<div>', $txt['mgallery_items'], ': ', $album['num_items'], '</div>', !empty($album['description']) ? '
					<div>' . $txt['mgallery_add_desc'] . ': ' . $album['description'] . '</div>' : '', '
					<div class="catbg" style="margin-top: 15px">', $txt['mgallery_admin_icon_info'], '</div>
					<div><img alt="" src="" id="img_'.$album['id'].'" /></div>';

		if ($album['icon']['id'] < 5)
			echo '<div>', $txt['mgallery_admin_no_icon'], '</div>';
		else
			echo '
					<div>', $txt['mgallery_width'], ': ', $album['icon']['width'], '</div>
					<div>', $txt['mgallery_height'], ': ', $album['icon']['height'], '</div>
					<div>', $txt['mgallery_filesize'], ': ', $album['icon']['size'], ' ', $txt['mgallery_kb'], '</div>';
			echo '
				</td>
			</tr>';
	}

	echo '
		</table>';
}

function template_mgallery_stats()
{
	global $txt, $galurl, $context, $scripturl, $settings;

	$stats = $context['mgallery_stats'];

	// Show the general stats
	echo '
		<table cellpadding="4" cellspacing="1" width="100%" border="0" class="bordercolor" style="margin-top: 10px">
			<tr>
				<td class="titlebg2" colspan="2" align="center"><img alt="" src="', $settings['images_smg'], '/chart_pie.png" class="vam" /> ', $txt['mgallery_gen_stats'], '</td>
			</tr>
			<tr>
				<td width="50%" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/images.png" class="vam" /> ', $txt['mgallery_total_items'], '</td>
							<td align="right">', $stats['total_items'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/comments.png" class="vam" /> ', $txt['mgallery_total_comments'], '</td>
							<td align="right">', $stats['total_comments'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/folder_image.png" class="vam" /> ', $txt['mgallery_total_albums'], '</td>
							<td align="right">', $stats['total_albums'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/group.png" class="vam" /> ', $txt['mgallery_total_user_albums'], '</td>
							<td align="right">', $stats['total_user_albums'], '</td>
						</tr>
					</table>
				</td>
				<td class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/images.png" class="vam" /> ', $txt['mgallery_avg_items'], '</td>
							<td align="right">', $stats['avg_items'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/comments.png" class="vam" /> ', $txt['mgallery_avg_comments'], '</td>
							<td align="right">', $stats['avg_comments'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/user.png" class="vam" /> ', $txt['mgallery_total_item_contributors'], '</td>
							<td align="right">', $stats['total_item_posters'], '</td>
						</tr>
						<tr>
							<td><img alt="" src="', $settings['images_smg'], '/user_comment.png" class="vam" /> ', $txt['mgallery_total_commentators'], '</td>
							<td align="right">', $stats['total_commentators'], '</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="titlebg" width="50%" align="center"><img alt="" src="', $settings['images_smg'], '/user.png" class="vam" /> ', $txt['mgallery_top_uploaders'], '</td>
				<td class="titlebg" align="center"><img alt="" src="', $settings['images_smg'], '/user_comment.png" class="vam" /> ', $txt['mgallery_top_commentators'], '</td>
			</tr>
			<tr>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_uploaders'] as $uploader)
		echo '
						<tr>
							<td align="left" width="60%">', smg_profile($uploader['id'], $uploader['name']), '</td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $uploader['percent'], '" height="15" /></td>
							<td align="right">', $uploader['total_items'], '</td>
						</tr>';

	if (empty($stats['top_uploaders']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_uploaders'], '</td>
						</tr>';
	echo '
					</table>
				</td>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_commentators'] as $uploader)
		echo '
						<tr>
							<td align="left" width="60%">', smg_profile($uploader['id'], $uploader['name']), '</td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $uploader['percent'], '" height="15" /></td>
							<td align="right">', $uploader['total_comments'], '</td>
						</tr>';

	if (empty($stats['top_commentators']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_commentators'], '</td>
						</tr>';

	echo '
					</table>
				</td>
			</tr>
			<tr>
				<td class="titlebg" width="50%" align="center"><img alt="" src="', $settings['images_smg'], '/folder_image.png" class="vam" /> ', $txt['mgallery_top_albums_items'], '</td>
				<td class="titlebg" align="center"><img alt="" src="', $settings['images_smg'], '/folder_table.png" class="vam" /> ', $txt['mgallery_top_albums_comments'], '</td>
			</tr>
			<tr>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_albums_items'] as $album)
		echo '
						<tr>
							<td align="left" width="60%"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a></td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $album['percent'], '" height="15" /></td>
							<td align="right">', $album['num_items'], '</td>
						</tr>';

	if (empty($stats['top_albums_items']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_albums'], '</td>
						</tr>';

	echo '
					</table>
				</td>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_albums_comments'] as $album)
		echo '
						<tr>
							<td align="left" width="60%"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a></td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $album['percent'], '" height="15" /></td>
							<td align="right">', $album['num_comments'], '</td>
						</tr>';

	if (empty($stats['top_albums_comments']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_albums'], '</td>
						</tr>';

	echo '
					</table>
				</td>
			</tr>
			<tr>
				<td class="titlebg" width="50%" align="center"><img alt="" src="', $settings['images_smg'], '/images.png" class="vam" /> ', $txt['mgallery_top_items_views'], '</td>
				<td class="titlebg" align="center"><img alt="" src="', $settings['images_smg'], '/comments.png" class="vam" /> ', $txt['mgallery_top_items_comments'], '</td>
			</tr>
			<tr>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_items_views'] as $item)
		echo '
						<tr>
							<td align="left" width="60%"><a href="', $galurl, 'sa=item;id=', $item['id'], '">', $item['title'], '</a></td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $item['percent'], '" height="15" /></td>
							<td align="right">', $item['views'], '</td>
						</tr>';

	if (empty($stats['top_items_views']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_items'], '</td>
						</tr>';

	echo '
					</table>
				</td>
				<td valign="top" class="windowbg2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_items_com'] as $item)
		echo '
						<tr>
							<td align="left" width="60%"><a href="', $galurl, 'sa=item;id=', $item['id'], '">', $item['title'], '</a></td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $item['percent'], '" height="15" /></td>
							<td align="right">', $item['num_com'], '</td>
						</tr>';

	if (empty($stats['top_items_com']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_items'], '</td>
						</tr>';

	echo '
					</table>
				</td>
			</tr>
			<tr>
				<td class="titlebg" colspan="2" align="center"><img alt="" src="', $settings['images_smg'], '/chart_pie.png" class="vam" /> ', $txt['mgallery_top_items_rating'], '</td>
			</tr>
			<tr>
				<td valign="top" class="windowbg2" colspan="2">
					<table cellpadding="4" cellspacing="0" width="100%">';

	foreach ($stats['top_items_rating'] as $item)
		echo '
						<tr>
							<td align="left" width="60%"><a href="', $galurl, 'sa=item;id=', $item['id'], '">', $item['title'], '</a></td>
							<td width="20%"><img alt="" src="', $settings['images_url'], '/bar.gif" width="', $item['percent'], '" height="15" /></td>
							<td align="right">', $item['rating'], '</td>
						</tr>';

	if (empty($stats['top_items_rating']))
		echo '
						<tr>
							<td align="center">', $txt['mgallery_no_items'], '</td>
						</tr>';
	echo '
					</table>
				</td>
			</tr>
		</table>';
}

function template_mgallery_below()
{
	global $txt, $context;
	echo '<div class="smalltext" style="margin-top:20px" align="center">', mgallery_copyright(), '</div>';
}

function template_mgallery_admin_albums()
{
	global $txt, $scripturl, $galurl, $context, $settings;

	// Some important javascript
	echo '
		<script type="text/javascript"><!-- // --><![CDATA[
			var has_icon = new Array();';
	foreach ($context['mgallery_icon_ids'] as $id_album => $id_icon)
		echo '
			has_icon['.$id_album.'] = '.($id_icon > 0 ? 1 : 0).';';
	echo '
		// ]]></script>';

	$buttons = array(
		'add' => array('text' => 'mgallery_admin_add_albums', 'url' => $scripturl . '?action=admin;area=mgallery;sa=albums;do=add;' . $context['session_var'] . '=' . $context['session_id'], 'lang' => false, 'image' => 'mgallery/folder_edit.png'),
		'general' => array('text' => 'mgallery_admin_list_gen_albums', 'url' => $scripturl . '?action=admin;area=mgallery;sa=albums;list_gen;' . $context['session_var'] . '=' . $context['session_id'], 'custom' => isset($_REQUEST['list_gen']) ? ' class="currentbutton"' : null, 'lang' => false, 'image' => 'mgallery/folder_image.png'),
		'user' => array('text' => 'mgallery_admin_list_user_albums', 'url' => $scripturl . '?action=admin;area=mgallery;sa=albums;list_user;' . $context['session_var'] . '=' . $context['session_id'], 'custom' => isset($_REQUEST['list_user']) ? ' class="currentbutton"' : null, 'lang' => true, 'image' => 'mgallery/folder_image.png'),
	);

	echo mgal_button_strip($buttons), '

		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr class="titlebg">
				<td width="2%">&nbsp;</td>
				<td width="55%">', $txt['mgallery_name'], '</td>
				<td width="15%">', $txt['mgallery_admin_type'], '</td>
				<td width="28%">', $txt['mgallery_admin_moderation'], '</td>
			</tr>
			<tr class="windowbg2">
				<td colspan="4"><a href="javascript:admin_toggle_all();">', $txt['mgallery_toggle_all'], '</a></td>
			</tr>';

	if ($context['mgallery_moving'] !== false)
		echo '
			<tr class="windowbg3">
				<td colspan="4">', $txt['moving_admin_moving_album'], ': ', $context['mgallery_albums'][$context['mgallery_moving']]['name'], ' <a href="', $scripturl, '?action=admin;area=mgallery;sa=albums;' . $context['session_var'] . '=', $context['session_id'], '">[', $txt['mgallery_admin_cancel_moving'], ']</a></td>
			</tr>';

	foreach ($context['mgallery_admin_albums'] as $album)
	{
		echo '
			<tr class="windowbg2">
				<td><a href="javascript:admin_toggle('.$album['id'].', true);"><img alt="" src="', $settings['images_url'], '/expand.gif" id="toggle_img_', $album['id'], '" /></a></td>
				<td style="padding-left: ',5 + 30 * $album['child_level'], 'px; ', $context['mgallery_moving'] !== false && ($context['mgallery_moving'] == $album['id'] || $context['mgallery_moving'] == $album['parent']) ? 'font-weight: bold;' : '', '"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a><br />';

		if ($context['mgallery_moving'] !== false && $context['mgallery_moving'] != $album['id'] && $context['mgallery_moving'] != $album['parent'])
			foreach ($album['move_links'] as $link)
				echo '<span class="smalltext"><a href="', $link['href'], '">', $link['label'], '</a></span>';

		echo '
				</td>
				<td>', $txt['mgallery_' . $album['type'] . '_album'], '</td>
				<td class="text_margins" style="white-space: nowrap">
					<img alt="" src="', $settings['images_smg'], '/folder_edit.png" title="', $txt['mgallery_admin_edit'], '" />&nbsp;<a href="', $scripturl, '?action=admin;area=mgallery;sa=albums;do=edit;id=', $album['id'], ';' . $context['session_var'] . '=', $context['session_id'], '">'.$txt['mgallery_admin_edit'].'</a>
					<img alt="" src="', $settings['images_smg'], '/folder_delete.png" title="', $txt['mgallery_admin_delete'], '" />&nbsp;<a href="', $scripturl, '?action=admin;area=mgallery;sa=albums;do=delete;id=', $album['id'], ';' . $context['session_var'] . '=', $context['session_id'], '" onclick="return confirm(\'', $txt['mgallery_admin_album_confirm'], '\');">'.$txt['mgallery_admin_delete'].'</a>
					<img alt="" src="', $settings['images_smg'], '/arrow_inout.png" title="', $txt['mgallery_admin_move'], '" />&nbsp;<a href="'.$scripturl.'?action=admin;area=mgallery;sa=albums;move='.$album['id'].';' . $context['session_var'] . '='.$context['session_id'].'">'.$txt['mgallery_admin_move'].'</a>', $album['approved'] == 0 ? '
					<img alt="" src="'.$settings['images_smg'].'/tick.png" title="'.$txt['mgallery_admin_approve'].'" />&nbsp;<a href="'.$scripturl.'?action=mgallery;area=moderate;sa=submissions;do=approve;type=albums;id='.$album['id'].';' . $context['session_var'] . '='.$context['session_id'].'">'.$txt['mgallery_admin_approve'].'</a>' : '', '
				</td>
			</tr>
			<tr class="windowbg" style="display: none" id="tr_expand_', $album['id'], '">
				<td colspan="4">
					<div>', $txt['mgallery_items'], ': ', $album['num_items'], '</div>
					<div>', $txt['mgallery_add_desc'], ': ', $album['description'], '</div>
					', $album['type'] == 'user' ? '<div>'.$txt['mgallery_owner'].': '.smg_profile($album['owner']['id'], $album['owner']['name']).'</div>' : '', '
					<div class="catbg" style="margin-top: 15px">', $txt['mgallery_admin_icon_info'], '</div>
					<div><img alt="" src="" id="img_'.$album['id'].'" /></div>';

		if ($album['icon']['id'] == 0)
			echo '<div>', $txt['mgallery_admin_no_icon'], '</div>';
		else
			echo '
					<div>', $txt['mgallery_width'], ': ', $album['icon']['width'], '</div>
					<div>', $txt['mgallery_height'], ': ', $album['icon']['height'], '</div>
					<div>', $txt['mgallery_filesize'], ': ', $album['icon']['size'], ' ', $txt['mgallery_kb'], '</div>';

		echo '
				</td>
			</tr>';
	}
	echo '
		</table>';
}

function template_mgallery_admin_submissions()
{
	global $context, $txt, $scripturl, $galurl, $settings;

	$filter = $context['mgallery_filter'];

	// Show some extra info
	echo '
		<form action="', $galurl, 'area=moderate;sa=submissions;type=', $filter, '" method="post">
			<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">
				<tr class="windowbg2">
					<td>', $txt['mgallery_admin_total_submissions'], ': ', $context['mgallery_total'], '</td>
				</tr>
				<tr class="windowbg2">
					<td>', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '</td>
				</tr>
			</table>';
	
	// Show the actual submissions
	echo '
			<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor" id="approvals">
				<tr class="titlebg">
					<td width="2%">&nbsp;</td>
					<td>', $txt['mgallery_name'], '</td>
					<td>', $txt['mgallery_posted_by'], '</td>
					<td>', $txt['mgallery_admin_moderation'], '</td>', $filter != 'albums' ? '
					<td>' . $txt['mgallery_posted_on'] . '</td>' : '', '
					<td width="4%"><input type="checkbox" name="checkAll" id="checkAll" onclick="invertAll(this, this.form, \'items[]\');" /></td>
				</tr>
				<tr class="windowbg2">
					<td colspan="', $filter == 'albums' ? 5 : 6, '"><a href="javascript:admin_toggle_all();">', $txt['mgallery_toggle_all'], '</a></td>
				</tr>';
	$alt = false;
	foreach ($context['mgallery_items'] as $item)
	{
		echo '
				<tr class="windowbg', $alt ? '2' : '', '" id="' . $item['id'] . '">
					<td><a href="javascript:admin_toggle('.$item['id'].', false);"><img alt="" src="', $settings['images_url'], '/expand.gif" id="toggle_img_', $item['id'], '" /></a></td>
					<td><a href="', $item['item_link'], '">', $item['title'], '</a></td>
					<td>', $item['poster'], '</td>
					<td><img alt="" src="'.$settings['images_smg'].'/tick.png" title="'.$txt['mgallery_admin_approve'].'" /> <a href="javascript:doSubAction(\'', $scripturl, '?action=mgallery;area=moderate;sa=submissions;do=approve;id=', $item['id'], ';type=', $filter, ';' . $context['session_var'] . '=', $context['session_id'], ';xml\');">'.$txt['mgallery_admin_approve'].'</a>
						<img alt="" src="'.$settings['images_smg'].'/folder_edit.png" title="'.$txt['mgallery_admin_edit'].'" /> <a href="', $item['edit_link'], '">'.$txt['mgallery_admin_edit'].'</a>
						<img alt="" src="'.$settings['images_smg'].'/folder_delete.png" title="'.$txt['mgallery_admin_delete'].'" /> <a href="javascript:doSubAction(\'', $item['del_link'], ';xml\');" onclick="return confirm(\'', $txt['mgallery_confirm'], '\');">'.$txt['mgallery_admin_delete'].'</a>
						', $filter == 'items' ? '<a href="'. $galurl .'sa=media;id='.$item['id'].';preview"' . ($mgalSettings['use_lightbox'] ? ' class="hs" onclick="return hs.expand(this);"' : '') . '><img src="'.$settings['images_smg'].'/magnifier.png" alt="view" /> '.$txt['mgallery_admin_view_image'].'</a>' : '', '
					</td>', $filter != 'albums' ? '
					<td>' . $item['posted_on'] . '</td>' : '', '
					<td><input type="checkbox" name="items[]" value="', $item['id'], '" id="items[]" /></td>
				</tr>
				<tr id="tr_expand_' . $item['id'] . '" class="windowbg', $alt ? '2' : '', '" style="display: none">
					<td colspan="', $filter == 'albums' ? 4 : 5, '">
						', !empty($item['description']) ? '<div>' . $txt['mgallery_add_desc'] .' : '. $item['description'] . '</div>' : '',
						!empty($item['keywords']) ? '<div>'.$txt['mgallery_keywords'].' : ' . $item['keywords'] . '</div>' : '', '
					</td>
				</tr>';
		$alt = !$alt;
	}
	
	echo '
				<tr class="windowbg', $alt ? '' : '2', '">
					<td colspan="', $filter == 'albums' ? 5 : 6, '" align="right">
						', $txt['mgallery_admin_wselected'], ' : 
						<select name="do">
							<option value="approve">', $txt['mgallery_admin_approve'], '</option>
							<option value="delete">', $txt['mgallery_admin_delete'], '</option>
						</select>&nbsp;
						<input type="submit" name="submit_mgal" value="', $txt['mgallery_submit'], '" />
					</td>
				</tr>
			</table>
		</form>';
}

// Maintenance homepage
function template_mgallery_admin_maintenance()
{
	global $txt, $context;

	// Maintenance headers
	if ($context['mgallery_maintenance_done'] !== false)
	{
		if ($context['mgallery_maintenance_done'] === true)
			$color = 'green';
		elseif ($context['mgallery_maintenance_done'] == 'pending')
			$color = 'orange';
		else
			$color = 'red';

		echo '<div class="windowbg2" style="border: 1px dashed '.$color.'; color: '.$color.'; padding: 1ex 2ex; margin: 1ex">', !empty($context['mgallery_maintenance_message']) ? $context['mgallery_maintenance_message'] : $txt['mgallery_maintenance_done'], '</div>';
	}

	echo '
		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">';

	foreach ($context['mgallery_dos'] as $type => $contents)
	{
		echo '
			<tr>
				<td class="titlebg">', $txt['mgallery_admin_maintenance_' . $type], '</td>
			</tr>
			<tr class="windowbg2">
				<td>
					<ul style="margin-top: 0px; margin-bottom: 0px">';

		$count = count($contents);
		foreach ($contents as $counter => $task)
		{
			echo '
						<li>
							<a href="', $task['href'], '">', $task['title'], '</a>', !empty($task['subtext']) ? '<div class="mg_subtext">' . $task['subtext'] . '</div>' : '';
			if ($count > $counter + 1)
				echo '
							<hr />';
			echo '
						</li>';
		}

		echo '
					</ul>
				</td>
			</tr>';
	}

	echo '
		</table>';
}

// Prune page template
function template_mgallery_admin_maintenance_prune()
{
	global $context, $scripturl, $txt;

	echo '
		<form action="', $scripturl, '?action=admin;area=mgallery;sa=maintenance;do=prune;' . $context['session_var'] . '=', $context['session_id'], '" method="post">
			<table cellpadding="6" cellspacing="0" border="0" class="tborder" width="100%">
				<tr>
					<td class="titlebg">', $txt['mgallery_pruning'], '</td>
				</tr>
				<tr>
					<td class="windowbg2">
						<input type="radio" name="pruning" value="item" onclick="admin_prune_toggle(\'item\',\'com\');" checked="checked" /> ', $txt['mgallery_items'], '<br />
						<input type="radio" name="pruning" value="comments" onclick="admin_prune_toggle(\'com\', \'item\');" /> ', $txt['mgallery_comments'], '
					</td>
				</tr>
				<tr id="item_prune_opts">
					<td style="padding: 0px; margin: 0px; border: 0px">
						<table cellpadding="6" cellspacing="0" border="0" class="tborder" width="100%">
							<tr class="catbg">
								<td>', $txt['mgallery_items'], '</td>
							</tr>
							<tr class="windowbg2">
								<td><div class="mg_subtext">', $txt['mgallery_admin_maintenance_prune_item_help'], '</div></td>
							</tr>
							<tr class="windowbg2">
								<td><input type="text" size="4" name="days" value="60" /> ', $txt['mgallery_admin_maintenance_prune_days'], '</td>
							</tr>
							<tr class="windowbg2">
								<td><hr /></td>
							</tr>
							<tr class="windowbg2">
								<td>', $txt['mgallery_admin_maintenance_prune_max_views'], ' <input type="text" size="4" name="max_views" /></td>
							</tr>
							<tr class="windowbg2">
								<td>', $txt['mgallery_admin_maintenance_prune_max_coms'], ' <input type="text" size="4" name="max_coms" /></td>
							</tr>
							<tr class="windowbg2">
								<td>', $txt['mgallery_admin_maintenance_prune_last_comment_age'], ' <input type="text" size="4" name="last_comment_age" /> ', isset($txt['days_word']) ? $txt['days_word'] : $txt[579], '</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr id="com_prune_opts" style="display: none">
					<td style="padding: 0px; margin: 0px; border: 0px">
						<table cellpadding="6" cellspacing="0" border="0" class="tborder" width="100%">
							<tr class="catbg">
								<td>', $txt['mgallery_comments'], '</td>
							</tr>
							<tr class="windowbg2">
								<td><div class="mg_subtext">', $txt['mgallery_admin_maintenance_prune_com_help'], '</div></td>
							</tr>
							<tr class="windowbg2">
								<td><input type="text" size="4" name="days_com" value="60" /> ', $txt['mgallery_admin_maintenance_prune_days'], '</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="catbg">', $txt['mgallery_albums'], '</td>
				</tr>
				<tr>
					<td class="windowbg2"><input type="checkbox" name="all_albums" /> ', $txt['mgallery_all_albums'], '</td>
				</tr>
				<tr>
					<td class="windowbg2">
						<select name="albums[]" multiple="multiple" size="9">';
	foreach ($context['mgallery_album_list'] as $list)
		echo '
							<option value="', $list, '">', str_repeat('-', $context['mgallery_albums'][$list]['child_level']), ' ', $context['mgallery_albums'][$list]['name'], '</option>';
	echo '
						</select>
					</td>
				</tr>
				<tr>
					<td class="windowbg2" align="center"><input type="submit" value="', $txt['mgallery_submit'], '" name="submit_mgal" onclick="return confirm(\'', $txt['mgallery_confirm'], '\');" /></td>
				</tr>
			</table>
		</form>';
}

function template_mgallery_admin_modlog()
{
	global $context, $scripturl, $galurl, $txt;

	echo '
	<form action="'.$galurl . 'area=moderate;sa=modlog;' . $context['session_var'] . '=', $context['session_id'], '" method="post">
		<table cellpadding="6" cellspacing="0" border="0" class="bordercolor" width="100%">
			', !empty($context['mgallery_logs']) ? '<tr>
				<td class="windowbg2" align="right">
					<input type="submit" name="delete" value="'.$txt['mgallery_admin_rm_selected'].'" style="margin-right: 10px" onclick="return confirm(\''.$txt['mgallery_confirm'].'\');" /><input type="submit" name="delete_all" value="'.$txt['mgallery_admin_rm_all'].'" style="margin-right: 10px" onclick="return confirm(\''.$txt['mgallery_confirm'].'\');" />
				</td>
			</tr>' : '', '
			<tr>
				<td class="catbg">
					', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '
				</td>
			</tr>
		</table>
		<table cellpadding="6" cellspacing="0" border="0" class="bordercolor" width="100%">
			<tr>
				<td class="titlebg" width="5%">&nbsp;</td>
				<td class="titlebg">', $txt['mgallery_action'], '</td>
				<td class="titlebg">', $txt['mgallery_time'], '</td>
				<td class="titlebg">', $txt['mgallery_member'], '</td>
			</tr>';

	foreach ($context['mgallery_logs'] as $log)
	{
		echo '
			<tr class="windowbg2">
				<td valign="middle" width="5%"><input type="checkbox" name="to_delete[]" value="'.$log['id'].'" /></td>
				<td class="smalltext">', $log['text'], '</td>
				<td class="smalltext">', $log['time'], '</td>
				<td class="smalltext"><a href="'.$log['action_by_href'].'">'.$log['action_by_name'].'</a></td>
			</tr>';
	}

	echo '
			<tr>
		</table>
	</form>
	<form action="', $scripturl, '?action=admin;area=mgallery;sa=modlog;' . $context['session_var'] . '=', $context['session_id'], '" method="post">
		<table cellpadding="10" cellspacing="0" border="0" class="bordercolor" width="100%">
			<tr class="titlebg">
				<td>
					', $txt['mgallery_admin_modlog_qsearch'], ' : <input type="text" name="qsearch_mem" size="15" /> <input type="submit" name="qsearch_go" value="', $txt['mgallery_submit'], '" />
				</td>
			</tr>
		</table>
	</form>';
}

function template_mgallery_admin_reports()
{
	// Shows the reports page
	global $galurl, $scripturl, $context, $txt, $settings, $mgalSettings;

	echo '

		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr class="titlebg">
				<td width="2%">&nbsp;</td>
				<td>', $txt['mgallery_admin_reported_item'], '</td>
				<td>', $txt['mgallery_admin_reported_by'], '</td>
				<td>', $txt['mgallery_admin_reported_on'], '</td>
				<td>', $txt['mgallery_admin_moderation'], '</td>
			</tr>
			<tr class="windowbg2">
				<td colspan="5"><a href="javascript:admin_toggle_all();">', $txt['mgallery_toggle_all'], '</a></td>
			</tr>';

	foreach ($context['mgallery_reports'] as $report)
	{
		echo '
			<tr class="windowbg2">
				<td><a href="javascript:admin_toggle('.$report['id_report'].');"><img alt="" src="', $settings['images_url'], '/expand.gif" id="toggle_img_'.$report['id_report'].'" /></a></td>
				<td><a href="', $galurl, 'sa=item;id='.($context['mgallery_report_type'] == 'comment' ? $report['id2'].'$com'.$report['id'] : $report['id']).'">'.$report['title'].'</a></td>
				<td>', smg_profile($report['reported_by']['id'], $report['reported_by']['name']), '</td>
				<td>', $report['reported_on'], '</td>
				<td><a href="', $scripturl, '?action=mgallery;area=moderate;sa=reports;do=delete;items;id=', $report['id_report'], ';' . $context['session_var'] . '=', $context['session_id'], '">', $txt['mgallery_admin_del_report'], '</a>
				<br /><a href="', $scripturl, '?action=mgallery;area=moderate;sa=reports;items;do=deleteitem;id=', $report['id_report'], ';' . $context['session_var'] . '=', $context['session_id'], '" onclick="return confirm(\'' . $txt['quickmod_confirm'] . '\');">', $txt['mgallery_admin_del_report_item'], '</a></td>
			</tr>
			<tr class="windowbg" id="tr_expand_'.$report['id_report'].'" style="display: none">
				<td colspan="5">
					', $txt['mgallery_posted_by'], ': ', smg_profile($report['posted_by']['id'], $report['posted_by']['name']), '<br />
					', $txt['mgallery_posted_on'], ': ', $report['posted_on'], '<br />
					', $txt['mgallery_admin_report_reason'], ': ', $report['reason'], '
				</td>
			</tr>';
	}

	echo '
		</table>';
}

// The main ban page
function template_mgallery_admin_bans()
{
	global $txt, $scripturl, $context;

	$buttons = array(
		'add' => array('text' => 'mgallery_admin_bans_add', 'url' => $scripturl.'?action=admin;area=mgallery;sa=bans;do=add;' . $context['session_var'] . '='.$context['session_id'], 'lang' => false, 'image' => 'mgallery/user.png'),
	);

	echo mgal_button_strip($buttons), '

		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr class="titlebg">
				<td>', $txt['mgallery_admin_banned'], '</td>
				<td>', $txt['mgallery_admin_banned_on'], '</td>
				<td>', $txt['mgallery_admin_expires_on'], '</td>
				<td>', $txt['mgallery_admin_ban_type'], '</td>
				<td>', $txt['mgallery_admin_moderation'], '</td>
			</tr>
			<tr class="windowbg2">
				<td colspan="5">', $txt['mgallery_pages'], ': ', $context['mgallery_page_index'], '</td>
			</tr>';

	foreach ($context['mgallery_bans'] as $ban)
	{
		echo '
			<tr class="windowbg2">
				<td>', smg_profile($ban['banned']['id'], $ban['banned']['name']), '</td>
				<td>', $ban['banned_on'], '</td>
				<td>', $ban['expires_on'], '</td>
				<td>', $ban['type_txt'], '</td>
				<td><a href="', $scripturl, '?action=admin;area=mgallery;sa=bans;do=edit;id=', $ban['id'], ';' . $context['session_var'] . '=', $context['session_id'], '">', $txt['mgallery_admin_edit'], '</a>/<a href="', $scripturl, '?action=admin;area=mgallery;sa=bans;do=delete;id=', $ban['id'], ';' . $context['session_var'] . '=', $context['session_id'], '">', $txt['mgallery_admin_delete'], '</a></td>
			</tr>';
	}

	echo '
		</table>';
}

// The admin "about" page
function template_mgallery_admin_about()
{
	global $txt, $scripturl, $context, $mgalSettings;

	echo '
		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor" style="margin-top: 1ex">
			<tr class="titlebg">
				<td>', $txt['mgallery_admin_credits'], ' <span class="smalltext" style="font-weight: normal">~ ', $txt['mgallery_admin_credits_thanks'], '</span></td>
			</tr>';

	foreach ($context['mgallery_credits'] as $credit)
		echo '
			<tr class="windowbg2">
				<td>', $credit['name'], ' ', $txt['mgallery_aka'], ' ', $credit['nickname'], ' - <a href="', $credit['site'], '">', $credit['site'], '</a> - ', $credit['position'], '</td>
			</tr>';

	echo '
		</table>

		<table border="0" width="100%" style="margin-top: 8px">
			<tr><td width="40%" valign="top">
				<table cellpadding="0" cellspacing="1" border="0" width="100%" class="bordercolor">
					<tr><td class="catbg" style="padding: 6px" align="center">', $txt['mgallery_admin_live'], '</td></tr>
					<tr><td class="windowbg2" height="190" id="smgnews">&nbsp;</td></tr>
				</table>
			</td><td id="servInfo" valign="top">
				<table cellpadding="0" cellspacing="1" border="0" width="100%" class="bordercolor">
					<tr><td class="catbg" style="padding: 6px" align="center">', $txt['mgallery_admin_about_header'], '</td></tr>
					<tr><td height="190">
						<table cellpadding="3" cellspacing="1" border="0" width="100%" class="windowbg" height="190">
							<tr>
								<td class="windowbg" width="50%">', $txt['mgallery_admin_smf_ver'], ': ', $context['mgallery_data']['smf'], '</td>
								<td class="windowbg" width="50%">', $txt['mgallery_admin_php_ver'], ': ', $context['mgallery_data']['php'], '</td>
							</tr>
							<tr>
								<td colspan="2" class="windowbg">', $txt['mgallery_admin_ffmpeg'], ': ', $context['mgallery_data']['ffmpeg'], '</td>
							</tr>
							<tr>
								<td colspan="2" class="windowbg">', $txt['mgallery_gd2'], ': ', $context['mgallery_data']['gd'], '</td>
							</tr>
							<tr>
								<td colspan="2" class="windowbg">', $txt['mgallery_imagemagick'], ': ', $context['mgallery_data']['imagemagick'], '
								(', $txt['mgallery_imagick'], ': ', $context['mgallery_data']['imagick'], ' -
								', $txt['mgallery_MW'], ': ', $context['mgallery_data']['magickwand'], ')</td>
							</tr>
							<tr>
								<td colspan="2" class="catbg" align="center">', mgallery_copyright(), '</td>
							</tr>
							<tr>
								<td colspan="2" class="windowbg2">', $txt['mgallery_admin_installed_on'], ': ', timeformat($mgalSettings['installed_on']), '</td>
							</tr>
							<tr>
								<td class="windowbg2">', $txt['mgallery_version'], ': <span id="curVer">', $mgalSettings['version'], '</span></td>
								<td class="windowbg2">', $txt['mgallery_latest_version'], ': <span id="latestVer">???</span></td>
							</tr>
						</table>
					</td></tr>
				</table>
			</td></tr>
		</table>

		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor" style="margin-top: 8px">
			<tr class="titlebg">
				<td>', $txt['mgallery_admin_thanks'], '</td>
			</tr>
			<tr class="windowbg2">
				<td class="smalltext">';

	foreach ($context['mgallery_thanks'] as $credit)
		echo '
					', $credit['name'], isset($credit['nickname']) ? ' '. $txt['mgallery_aka']. ' '. $credit['nickname'] : '', isset($credit['site']) ? ' - <a href="' . $credit['site'] . '">' . $credit['site'] . '</a>' : '', ' - ', $credit['position'], '<br />';

	echo '
				</td>
			</tr>
			<tr class="titlebg">
				<td>', $txt['mgallery_admin_about_modd'], '</td>
			</tr>';

	$managers = array();
	$moderators = array();
	if (isset($context['mgallery_admins']['managers']))
		foreach ($context['mgallery_admins']['managers'] as $m)
			$managers[] = $m['link'];
	if (isset($context['mgallery_admins']['moderators']))
		foreach ($context['mgallery_admins']['moderators'] as $m)
			$moderators[] = $m['link'];
	echo '
			<tr class="windowbg2">
				<td>
					', !empty($managers) ? '<div>'.$txt['mgallery_admin_managers'].': '.implode(', ', $managers).'</div>' : '',
					!empty($moderators) ? '<div>'.$txt['mgallery_admin_moderators'].': '.implode(', ', $moderators).'</div>' : '', '
				</td>
			</tr>
		</table>

		<script src="http://smf-media.com/smg/latestversion.js" type="text/javascript" language="JavaScript"></script>
		<script src="http://smf-media.com/smg/news.js" type="text/javascript" language="JavaScript"></script>
		<script type="text/javascript"><!-- // --><![CDATA[
			function checkVersion()
			{
				if (window.ver == "undefined")
					return;

				if (document.getElementById("curVer").innerHTML != window.ver)
				{
					document.getElementById("latestVer").innerHTML = "<a href=\"http://custom.simplemachines.org/mods/index.php?mod=1365\">" + window.ver + "</a>";
					document.getElementById("curVer").style.color = "red";
					document.getElementById("curVer").style.fontWeight = "bold";
				}
				else
					document.getElementById("latestVer").innerHTML = window.ver;
			}
			function fetchNews()
			{
				if (window.news == "undefined")
					return;

				var str = "<div id=\"actNews\" style=\"height: 180px; overflow: auto; padding: 4px\" class=\"smalltext\">";
				for (i = 0; i < window.news.length; i++)
				{
					var sdate = new Date(Date.parse(window.news[i].time));
					str += "\n		<div style=\"padding-bottom: 2px\"><a href=\"" + window.news[i].href + "\">" + window.news[i].title + "</a> ' . strtolower($txt['mgallery_on_date']) . ' " + sdate.toLocaleString() + "</div>";
					str += "\n		<div style=\"padding-left: 2ex; margin-bottom: 1.5ex; border-top: 1px dashed\">";
					str += "\n			" + window.news[i].message;
					str += "\n		</div>";
				}
				str += "\n</div>";
				document.getElementById("smgnews").innerHTML = str;
			}
			window.onload = function()
			{
				checkVersion();
				fetchNews();
			}
		// ]]></script>';
}

function template_mgallery_text_editor()
{
	global $context, $settings;

	if ($context['is_smf2'])
		echo '
	<div>', template_control_richedit($context['post_box_name'], array('bbc', 'smileys', 'message')), '</div>';
	else
		echo '
	<table cellpadding="0" cellspacing="0" border="0">
		', theme_postbox($context['post_box_value']), '
	</table>';
}

function template_mgallery_multiUpload_xml()
{
	global $context, $txt;

	// Prepare the items
	$item_array = array();
	foreach ($context['items'] as $item)
		$item_array[] = $item['id'] . ',' . $item['title'];

	// Prepare the errors
	$error_array = array();
	$error_list = array(
			'file_not_found' => 'upload_failed', 'dest_not_found' => 'upload_failed', 'size_too_big' => 'upload_file_too_big',
			'width_bigger' => 'error_width', 'height_bigger' => 'error_height', 'invalid_extension' => 'invalid_extension');

	foreach ($context['errors'] as $error)
	{
		$message = isset($error_list[$error['code']]) ? $txt['mgallery_' . $error_list[$error['code']]] : $txt['mgallery_upload_failed'];
		$error_array[] = $error['fname'] . ' - ' . $message;
	}

	// Output it
	echo implode(';', $item_array), '|', implode(';', $error_array);
}

function template_mgallery_multiUpload()
{
	global $context, $txt, $galurl, $mgalSettings, $settings;
	echo '
	<table cellpadding="6" cellspacing="0" border="0" width="100%">
		<tr class="titlebg">
			<td>', $txt['mgallery_multi_upload'], '</td>
		</tr>
		<tr class="windowbg">
			<td>
				<ul class="normallist">
					<li>', $txt['mgallery_max_file_size'], ': ', $txt['mgallery_image'], ' - ', $context['mgallery_max_file_size']['image'], ' ', $txt['mgallery_kb'], ', ', $txt['mgallery_video'], ' - ', $context['mgallery_max_file_size']['video'], ' ', $txt['mgallery_kb'], ', ', $txt['mgallery_audio'], ' - ', $context['mgallery_max_file_size']['audio'], ' ', $txt['mgallery_kb'], ', ', $txt['mgallery_doc'], ' - ', $context['mgallery_max_file_size']['doc'], ' ', $txt['mgallery_kb'], '
					<li>', $txt['mgallery_needs_js_flash'], '</li>
				</ul>
			</td>
		</tr>
		<tr class="windowbg2">
			<td>
				', $txt['mgallery_add_allowedTypes'], ':
				<ul class="normallist">';

	foreach ($context['allowed_types'] as $k => $v)
		echo '
					<li><b>', $txt['mgallery_filetype_'.$k], '</b>: ', str_replace('*.', '', implode(', ', $v)), '</li>';

	echo '
				</ul>
			</td>
		</tr>
		<tr class="windowbg2">
			<td>
				<form action="'. $context['mgallery_submit_url'] .'" id="upload_form" method="post">
					<div id="mu_container" style="text-align: center">
						<p>
							<span id="browse" style="position: absolute; z-index: 2"></span>
							<span id="browseBtnSpan" style="z-index: 1"><a id="browseBtn" href="#">', $txt['mgallery_selectFiles'], '</a></span> |
							<a id="upload" href="#">', $txt['mgallery_upload'], '</a>
						</p>
						<div>
							<strong id="overall_title" class="overall-title">', $txt['mgallery_overall_prog'], '</strong><br />
							<img alt="" src="', $settings['images_smg'], '/bar.gif" class="progress overall-progress" id="overall_progress" /> <strong id="overall_prog_perc">0%</strong>
						</div>
						<div>
							<strong class="current-title" id="current_title">', $txt['mgallery_curr_prog'], '</strong><br />
							<img alt="" src="', $settings['images_smg'], '/bar.gif" class="progress2 current-progress" id="current_progress" /> <strong id="current_prog_perc">0%</strong>
						</div>
						<div class="current-text" id="current_text"></div>
					</div>
					<div>
						<div>
							<ul id="current_list">
								<li style="visibility: hidden"></li>
							</ul>
						</div>
						<br style="clear: both;" />
						<div style="text-align: center;" id="mu_items"><input type="submit" name="mgal_submit" value="', $txt['mgallery_submit'], '" /></div>
					</div>
				</form>
			</td>
		</tr>
		<tr id="mu_items_tr" style="display: none" class="titlebg">
			<td>', $txt['mgallery_errors'], '</td>
		</tr>
		<tr id="mu_items_tr2" style="display: none" class="windowbg2">
			<td id="mu_items_error" style="color: red;">
			</td>
		</tr>
	</table>';
}

function template_mgallery_admin_settings_above()
{
	global $txt, $context, $scripturl;

	$buttons = array();

	foreach($context['setting_areas'] as $area)
		$buttons[] = array(
			'text' => $area['title'],
			'url' => $scripturl . '?action=admin;area=mgallery;sa=settings;ar='.$area['id'].';' . $context['session_var'] . '='.$context['session_id'],
			'custom' => $context['current_area'] == $area['id'] ? 'class="currentbutton"' : null,
			'lang' => false,
			'image' => null
		);

	echo mgal_button_strip($buttons), '

		<table cellpadding="0" cellspacing="0" border="0" width="100%">
			<tr>
				<td>';
}

function template_mgallery_admin_settings_below()
{
	echo '
				</td>
			</tr>
		</table>';
}

function template_mgallery_admin_perms()
{
	global $txt, $context, $scripturl, $settings;

	echo '
	<form method="post" action="', $context['base_url'], ';', $context['session_var'], '=', $context['session_id'], '">
		<table width="50%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">';
	if ($context['force_ua'])
		echo '
			<tr class="windowbg2">
				<td colspan="3" style="border: 1px dashed red; color: red; text-align: center;">', $txt['mgallery_admin_perms_uaf'], '</td>
			</tr>';
	echo '
			<tr class="titlebg">
				<td colspan="3"><span title="', $txt['mgallery_permissions_help'], '"><img src="', $settings['images_url'], '/helptopics.gif" alt="Help" align="top" /></span> ' , $txt['mgallery_admin_labels_perms'] , '</td>
			</tr>', !$context['is_ua'] && !$context['force_ua'] ? '
			<tr class="windowbg2">
				<td colspan="3"><a href="' . $context['base_url'] . ';ua">' . $txt['mgallery_admin_view_uap'] . '</a></td>
			</tr>' : '', '
			<tr class="catbg">
				<td width="50%">', $txt['mgallery_admin_prof_name'], '</td>
				<td width="25%">', $txt['mgallery_albums'], '</td>
				<td width="25%">', $txt['mgallery_delete_this_item'], '</td>
			</tr>';
	$alt = false;
	foreach ($context['mgallery_profiles'] as $prof)
	{
		$alt = !$alt;
		echo '
			<tr class="windowbg', $alt ? '2' : '', '">
				<td><a href="', $context['base_url'], ';do=view;id=', $prof['id'], ';', $context['session_var'], '=', $context['session_id'], '">', $prof['name'], '</a>', $context['force_ua'] && !empty($prof['member']) ? ' <span style="font-style: italic;">(' . $txt['mgallery_owner'] . ' : ' . $prof['member']['href'] . ')</span>' : '', '</td>
				<td><a href="javascript:getPermAlbums(', $prof['id'], ');">', $prof['albums'], '</a></td>
				<td', !empty($prof['undeletable']) ? ' title="' . $txt['mgallery_permissions_undeletable'] . '"' : '', '><input name="delete_prof_', $prof['id'], '" type="checkbox" onclick="return permDelCheck(', $prof['id'], ', this, \'', $txt['mgallery_confirm'], '\');"', !empty($prof['undeletable']) || $context['force_ua'] ? ' disabled="disabled"' : '', ' /></td>
			</tr>
			<tr class="windowbg', $alt ? '2' : '', '" id="albums_' . $prof['id'] . '" style="display: none">
				<td colspan="3" id="albums_td_' . $prof['id'] . '"></td>
			</tr>';
	}
	if (!$context['force_ua'])
	{
		echo '
				<tr class="windowbg', $alt ? '' : '2', '">
					<td colspan="2">', $txt['mgallery_admin_prof_del_switch'], '<br /><span class="smalltext">', $txt['mgallery_admin_prof_del_switch_help'], '</span></td>
					<td>
						<select name="del_prof">
							<option value=""></option>';
		foreach ($context['mgallery_profiles'] as $prof)
			echo '
							<option value="', $prof['id'], '">', $prof['name'], '</option>';
		echo '
						</select>
					</td>
				</tr>
				<tr class="windowbg', $alt ? '2' : '', '">
					<td colspan="3" align="right"><input type="submit" name="mgal_delete_profs" value="', $txt['mgallery_delete_this_item'], '" /></td>
				</tr>';
	}
	echo '
		</table>
	</form>';

	if (!$context['force_ua'])
		echo '
		<form method="post" action="', $context['base_url'], ';do=add;', $context['session_var'], '=', $context['session_id'], '">
			<table width="50%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">
				<tr class="titlebg">
					<td>', $txt['mgallery_admin_profile_add'], '</td>
				</tr>
				<tr class="windowbg2">
					<td>', $txt['mgallery_admin_prof_name'], ' : <input type="text" name="name" /></td>
				</tr>
				<tr class="windowbg">
					<td align="right"><input type="submit" name="submit_mgal" value="', $txt['mgallery_admin_create_prof'], '" /></td>
				</tr>
			</table>
		</form>';
}
function template_mgallery_admin_perms_view()
{
	global $txt, $context, $scripturl;

	echo '
		<form action="', $context['base_url'], ';do=quick;profile=', $context['mgallery_profile']['id'], ';', $context['session_var'], '=', $context['session_id'], '" method="post">
			<table width="70%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">
				<tr class="catbg">
					<td colspan="5">', $txt['mgallery_perm_profile'], ' : "', $context['mgallery_profile']['name'], '"</td>
				</tr>
				<tr class="titlebg">
					<td width="40%">', $txt['mgallery_admin_membergroups'], '</td>
					<td width="20%">', $txt['mgallery_admin_members'], '</td>
					<td width="25%">', $txt['mgallery_admin_labels_perms'], '</td>
					<td width="10%">', $txt['mgallery_edit_this_item'] , '</td>
					<td width="5%"><input type="checkbox" name="checkAll" id="checkAll" onclick="invertAll(this, this.form, \'groups[]\');" /></td>
				</tr>';

	$alt = false;
	$membergroup_string = '';
	foreach ($context['membergroups'] as $id => $group)
	{
		$alt = !$alt;
		echo '
				<tr class="windowbg', $alt ? '2' : '', '">
					<td>', $group['name'], '</td>
					<td>', $group['num_members'], '</a></td>
					<td>', $group['perms'], '</td>
					<td><a href="', $context['base_url'], ';do=edit;id=', $context['mgallery_profile']['id'], ';group=', $id, ';', $context['session_var'], '=', $context['session_id'], '">', $txt['mgallery_edit_this_item'] , '</a></td>
					<td><input type="checkbox" name="groups[]" value="', $id, '" id="groups[]" /></td>
				</tr>';
		$membergroup_string .= "\n" . '<option value="' . $id . '">' . $group['name'] . '</option>';
	}
	echo '
				<tr class="windowbg', $alt ? '' : '2', '">
					<td colspan="4" align="right" style="margin-top: 2px">
						<div style="margin-bottom: 1ex">', $txt['mgallery_admin_wselected'], '</div>
						', $txt['mgallery_admin_set_mg_perms'], ' : 
							<select name="copy_membergroup">
								<option value=""></option>', $membergroup_string, '
							</select><br /><br />
						<select name="with_selected">
							<option value="apply">', $txt['mgallery_admin_apply_perm'], '</option>
							<option value="clear">', $txt['mgallery_admin_clear_perm'], '</option>
						</select>&nbsp;
						<select name="selected_perm">
							<option value=""></option>';
	foreach ($context['permissions'] as $perm)
		echo '
							<option value="', $perm, '">', $txt['permissionname_mgallery_' . $perm], '</option>';
	echo '
						</select>
					</td>
					<td width="16%" valign="bottom">
						<input type="submit" name="submit" value="', $txt['mgallery_submit'], '" />
					</td>
				</tr>
			</table>';
}

// Membergroup quota template
function template_mgallery_admin_quotas()
{
	global $txt, $context, $scripturl;

	echo '
	<form method="post" action="', $scripturl, '?action=admin;area=mgallery;sa=quotas;', $context['session_var'], '=', $context['session_id'], '">
		<table width="50%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">';

	echo '
			<tr class="titlebg">
				<td colspan="3">' , $txt['mgallery_admin_labels_quotas'] , '</td>
			</tr>
			<tr class="catbg">
				<td width="50%">', $txt['mgallery_admin_prof_name'], '</td>
				<td width="25%">', $txt['mgallery_albums'], '</td>
				<td width="25%">', $txt['mgallery_delete_this_item'], '</td>
			</tr>';
	$alt = false;
	foreach ($context['mgallery_profiles'] as $prof)
	{
		$alt = !$alt;
		echo '
			<tr class="windowbg', $alt ? '2' : '', '">
				<td><a href="', $scripturl, '?action=admin;area=mgallery;sa=quotas;do=view;id=', $prof['id'], ';', $context['session_var'], '=', $context['session_id'], '">', $prof['name'], '</a></td>
				<td><a href="javascript:getPermAlbums(', $prof['id'], ', \';prof=', $prof['id'], ';xml\');">', $prof['albums'], '</a></td>
				<td><input name="delete_prof_', $prof['id'], '" type="checkbox" onclick="return permDelCheck(', $prof['id'], ', this, \'', $txt['mgallery_confirm'], '\');"', !empty($prof['undeletable']) ? ' disabled="disabled"' : '', ' /></td>
			</tr>
			<tr class="windowbg', $alt ? '2' : '', '" id="albums_' . $prof['id'] . '" style="display: none">
				<td colspan="3" id="albums_td_' . $prof['id'] . '"></td>
			</tr>';
	}

	if (!empty($context['mgallery_profiles']))
	{
		echo '
				<tr class="windowbg', $alt ? '' : '2', '">
					<td colspan="2">', $txt['mgallery_admin_prof_del_switch'], '<br /><span class="smalltext">', $txt['mgallery_admin_prof_del_switch_help'], '</span></td>
					<td>
						<select name="del_prof">
							<option value=""></option>';
		foreach ($context['mgallery_profiles'] as $prof)
			echo '
							<option value="', $prof['id'], '">', $prof['name'], '</option>';
		echo '
						</select>
					</td>
				</tr>
				<tr class="windowbg', $alt ? '2' : '', '">
					<td colspan="3" align="right"><input type="submit" name="mgal_delete_profs" value="', $txt['mgallery_delete_this_item'], '" /></td>
				</tr>';
	}

	echo '
		</table>
	</form>';

		echo '
	<form method="post" action="', $scripturl, '?action=admin;area=mgallery;sa=quotas;do=add;', $context['session_var'], '=', $context['session_id'], '">
		<table width="50%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">
			<tr class="titlebg">
				<td>', $txt['mgallery_admin_profile_add'], '</td>
			</tr>
			<tr class="windowbg2">
				<td>', $txt['mgallery_admin_prof_name'], ' : <input type="text" name="name" /></td>
			</tr>
			<tr class="windowbg">
				<td align="right"><input type="submit" name="submit_mgal" value="', $txt['mgallery_admin_create_prof'], '" /></td>
			</tr>
		</table>
	</form>';
}

// Viewing a profile
function template_mgallery_admin_quota_view()
{
	global $txt, $context, $scripturl;

	echo '
		<table width="70%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">
			<tr class="catbg">
				<td colspan="4">', $txt['mgallery_quota_profile'], ' : "', $context['mgallery_profile']['name'], '"</td>
			</tr>
			<tr class="titlebg">
				<td width="65%">', $txt['mgallery_admin_membergroups'], '</td>
				<td width="20%">', $txt['mgallery_admin_members'], '</td>
				<td width="15%">', $txt['mgallery_edit_this_item'] , '</td>
			</tr>';
	$alt = false;
	foreach ($context['membergroups'] as $id => $group)
	{
		$alt = !$alt;
		echo '
			<tr class="windowbg', $alt ? '2' : '', '">
				<td>', $group['name'], '</td>
				<td>', $group['num_members'], '</a></td>
				<td><a href="', $scripturl, '?action=admin;area=mgallery;sa=quotas;do=edit;id=', $context['mgallery_profile']['id'], ';group=', $id, ';', $context['session_var'], '=', $context['session_id'], '">', $txt['mgallery_edit_this_item'] , '</a></td>
			</tr>';
	}
	echo '
		</table>';
}

// Custom fields template
function template_mgallery_admin_fields()
{
	global $txt, $galurl, $scripturl, $context;

	echo '
		<table width="50%" align="center" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex">
			<tr class="titlebg">
				<td colspan="3">' , $txt['mgallery_cf'] , '</td>
			</tr>
			<tr class="catbg">
				<td width="50%">', $txt['mgallery_cf_name'], '</td>
				<td width="25%">', $txt['mgallery_cf_type'], '</td>
				<td width="25%">', $txt['mgallery_admin_moderation'], '</td>
			</tr>
			<tr class="windowbg2">
				<td colspan="3"><a href="', $scripturl, '?action=admin;area=mgallery;sa=fields;do=edit;', $context['session_var'], '=', $context['session_id'], '">', $txt['mgallery_cf_add'], '</a></td>
			</tr>';
	$alt = false;
	foreach ($context['custom_fields'] as $field)
	{
		echo '
			<tr class="windowbg', $alt ? '2' : '', '">
				<td>', $field['name'], '</td>
				<td>', $txt['mgallery_cf_' . $field['type']], '</td>
				<td><a href="', $scripturl, '?action=admin;area=mgallery;sa=fields;do=edit;id=', $field['id'], ';', $context['session_var'], '=', $context['session_id'], '">', $txt['mgallery_edit_this_item'], '</a> / <a href="', $scripturl, '?action=admin;area=mgallery;sa=fields;delete=', $field['id'], ';', $context['session_var'], '=', $context['session_id'], '" onclick="return confirm(\'', $txt['mgallery_confirm'], '\');">', $txt['mgallery_delete_this_item'], '</a></td>
			</tr>';
		$alt = !$alt;
	}
	echo '
		</table>';
}

// Profile summary template
function template_mgallery_profile_summary()
{
	global $txt, $galurl, $context, $settings, $scripturl;

	$member = $context['mgallery_member'];

	echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr>
				<td class="titlebg"><img src="', $settings['images_url'], '/admin/mgallery.png" alt="" border="0" />&nbsp;&nbsp;', $txt['mgallery_profile_sum_pt'], '</td>
			</tr>
			<tr>
				<td class="windowbg smalltext" style="padding: 2ex;">', $txt['mgallery_profile_sum_desc'], '</td>
			</tr>
			<tr>
				<td class="titlebg">', $txt['mgallery_profile_stats'], '</td>
			</tr>
			<tr>
				<td class="windowbg2">
					<a href="', $scripturl, '?action=profile;u=', $member['id'], $context['is_smf2'] ? ';area' : ';sa', '=mgalitems">', $txt['mgallery_total_items'], '</a>: ', $member['items'], '<br />
					<a href="', $scripturl, '?action=profile;u=', $member['id'], $context['is_smf2'] ? ';area' : ';sa', '=mgalcoms">', $txt['mgallery_total_comments'], '</a>: ', $member['coms'], '<br />
					', $txt['mgallery_avg_items'], ': ', $member['avg_items'], '<br />
					', $txt['mgallery_avg_comments'], ': ', $member['avg_coms'], '<br />
				</td>
			</tr>';
			if (!empty($member['user_albums']))
			{
				echo '
			<tr>
				<td class="titlebg">', $txt['mgallery_user_albums'], '</td>
			</tr>
			<tr>
				<td class="windowbg2">
					<table cellpadding="5" cellspacing="5" border="0" width="100%">
					<tr class="catbg"><td width="2%">' . $txt['mgallery_icon'] . '</td><td>' . $txt['mgallery_album_name'] . '</td></tr>';

				foreach ($member['user_albums'] as $album)
					echo '
					<tr><td><img alt="" src="'.$galurl.'sa=media;id='.$album['id'].';icon" /></td><td>
						<div class="mg_large mg_pb4"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a></div>', !empty($album['last_item']) ? '
						<div>' . $album['items'] . ' ' . $txt['mgallery_items'] . ' - ' . $txt['mgallery_latest_item'] . ': <a href="'.$galurl.'sa=item;id='.$album['last_item'].'">'.$album['last_item_title'].'</a> (' . $album['last_item_date'] . ')</div>' : '', '
						<div class="mg_desc">', $album['description'], '</div>
					</td></tr>';

				echo '
					</table>
				</td>
			</tr>';
			}
			echo '
		</table>';

			if (!empty($member['recent_items']))
			{
				echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor margintop">
			<tr>
				<td class="titlebg">', $txt['mgallery_recent_items'], '</td>
			</tr>
		</table>

		<div id="home">
			<div id="recent_items">',
				smg_item_list($member['recent_items']), '
			</div>
		</div>';
			}

			if (!empty($member['top_albums']))
			{
				echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor margintop">
			<tr>
				<td class="titlebg">', $txt['mgallery_top_albums'], '</td>
			</tr>
			<tr>
				<td style="padding: 0px;">
					<table cellpadding="6" cellspacing="0" width="100%" border="0">';

				foreach ($member['top_albums'] as $album)
					echo '
						<tr>
							<td class="windowbg2" width="50%"><a href="', $galurl, 'sa=album;id=', $album['id'], '">', $album['name'], '</a></td>
							<td class="windowbg2" width="40%"><img src="', $settings['images_url'], '/bar.gif" width="', $album['percent'], '" alt="" border="0" height="15" /></td>
							<td class="windowbg2" width="10%">', $album['total_items'], '</td>
						</tr>';
						echo '
					</table>
				</td>
			</tr>';
			}
		echo '
		</table>';
}

// Template for viewing all items from a single member
function template_mgallery_profile_viewitems()
{
	global $context, $txt, $galurl, $settings;

	echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr>
				<td class="titlebg"><img src="', $settings['images_url'], '/admin/mgallery.png" alt="" border="0" />&nbsp;&nbsp;', $txt['mgallery_profile_viewitems_pt'], '</td>
			</tr>
			<tr>
				<td class="windowbg smalltext" style="padding: 2ex;">', $txt['mgallery_profile_viewitems_desc'], '</td>
			</tr>
			<tr>
				<td class="titlebg">', $txt['mgallery_pages'], ': ', $context['page_index'], '</td>
			</tr>
		</table>

		<div id="home">
			<div id="recent_items">',
				smg_item_list($context['mgallery_items']), '
			</div>
		</div>';
}

// Template for viewing all items from a single member
function template_mgallery_profile_viewcoms()
{
	global $context, $txt, $settings;

	echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr>
				<td class="titlebg"><img src="', $settings['images_url'], '/admin/mgallery.png" alt="" border="0" />&nbsp;&nbsp;', $txt['mgallery_profile_viewcoms_pt'], '</td>
			</tr>
			<tr>
				<td class="windowbg smalltext" style="padding: 2ex;">', $txt['mgallery_profile_viewcoms_desc'], '</td>
			</tr>
			<tr>
				<td class="titlebg">', $txt['mgallery_pages'], ': ', $context['page_index'], '</td>
			</tr>
		</table>

		<div>';

	// Recent comments!
	if (!empty($context['mgallery_coms']))
	{
		foreach ($context['mgallery_coms'] as $i)
			echo '
		<div class="smalltext" style="padding: 8px">
			', $txt['mgallery_comment_in'], ' <a href="', $i['url'], '"><b>', $i['media_title'], '</a></b> - ',
			$txt['mgallery_posted_on' . (is_numeric($i['posted_on'][0]) ? '_date' : '')], ' ', $i['posted_on'], '
			<blockquote class="windowbg comment_preview">', parse_bbc($i['msg']), '</blockquote>
		</div>';
	}

	echo '
		</div>';
}

// Template for viewing all votes from a single member
function template_mgallery_profile_viewvotes()
{
	global $context, $txt, $settings, $scripturl, $mgalFunc;

	echo '
		<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr>
				<td class="titlebg"><img src="', $settings['images_url'], '/admin/mgallery.png" alt="" border="0" />&nbsp;&nbsp;', $txt['mgallery_profile_viewvotes_pt'], '</td>
			</tr>
			<tr>
				<td class="windowbg smalltext" style="padding: 2ex;">', $txt['mgallery_profile_viewvotes_desc'], '</td>
			</tr>
			<tr>
				<td class="titlebg">', $txt['mgallery_pages'], ': ', $context['page_index'], '</td>
			</tr>
		</table>

		<div>';

	if (!empty($context['smg_rating_logs']))
	{
		echo '<h2>' . $context['smg_voter_name'] . '</h2>';

		foreach ($context['smg_rating_logs'] as $log)
		{
			echo ' <img src="' . $settings['images_smg'] . '/star' . $log['star'] . '.gif" style="vertical-align: middle" alt="' . $log['star'] . '" />';
			echo '&nbsp;&nbsp;<b><a href="' . $scripturl . '?action=mgallery;sa=item;id=' . $log['id_media'] . '">' . $log['title'] . '</a></b>';
			echo ' (<a href="' . $scripturl . '?action=mgallery;sa=album;id=' . $log['album_id'] . '">' . $log['name'] . '</a>)';
			if (!empty($log['messages']))
				echo ' (' . $log['messages'] . ' <a href="' . $scripturl . '?topic=' . $log['id_topic'] . '.0">' . $txt['mgallery_post' . ($log['messages'] > 1 ? 's' : '') . '_noun'] . '</a>)';
			echo '<br />';
		}
		echo '<br /><h3>' . $txt['mgallery_voter_list'] . ':</h3>';
		foreach ($context['smg_other_voters'] as $row)
			echo '<br /><a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . ($context['is_smf2'] ? ';area' : ';sa') . '=mgalvotes">' . $row['real_name'] . '</a> (' . $row['co'] . ' ' . $txt['mgallery_vote' . ($row['co'] > 1 ? 's' : '') . '_noun'] . ')';
	}

	echo '
		</div>';
}

// Who rated what list
function template_mgallery_whoRatedWhat()
{
	global $context, $txt, $settings, $galurl;

	echo '
		<table cellpadding="6" cellspacing="1" border="0" width="100%" class="bordercolor">
			<tr>
				<td colspan="3" align="center" class="windowbg2">', $txt['mgallery_who_rated_what'], ' (<a href="', $galurl, 'sa=item;id=', $context['item']['id_media'], '">', $context['item']['title'], '</a>)</td>
			</tr>
			<tr>
				<td class="titlebg" width="60%">', $txt['mgallery_member'], '</td>
				<td class="titlebg" width="15%">', $txt['mgallery_rating'], '</td>
				<td class="titlebg" width="25%">', $txt['mgallery_date'], '</td>
			</tr>
			<tr>
				<td class="windowbg2" colspan="3">', $txt['mgallery_pages'], ': ', $context['page_index'], '</td>
			</tr> ';

		foreach ($context['item']['rating_logs'] as $log)
		{
			echo '
				<tr>
					<td class="windowbg2"><a href="', $log['member_link'], '">', $log['member_name'], '</a></td>
					<td class="windowbg2">', str_repeat('<img src="' . $settings['images_url'] . '/star.gif" border="0" alt="*" />', $log['rating']), '</td>
					<td class="windowbg2">', $log['time'], '</td>
				</tr>';
		}
	echo '
		</table>';
}

// FTP Import template
function template_mgallery_admin_ftpimport()
{
	global $context, $scripturl, $txt, $settings;

	$albumOpts_str = '<option value="0">----</option>';
	foreach ($context['mgallery_album_list'] as $list)
		$albumOpts_str .= '\\n	<option value="' . $list . '">' . str_repeat('-', $context['mgallery_albums'][$list]['child_level']) . ' ' . $context['mgallery_albums'][$list]['name'] . '</option>';

	echo '
		<form action="', $scripturl, '?action=admin;area=mgallery;sa=ftp;' . $context['session_var'] . '=', $context['session_id'], '" method="post">
			<table cellpadding="4" cellspacing="1" border="0" class="bordercolor" width="100%">
				<tr>
					<td class="titlebg">', $txt['mgallery_admin_labels_ftp'], '</td>
				</tr>
				<tr>
					<td class="windowbg smalltext" style="padding: 10px">', $txt['mgallery_admin_ftp_help'], '</td>
				</tr>
				<tr>
					<td class="catbg">', $txt['mgallery_admin_ftp_files'], '</td>
				</tr>';
		if	($context['is_halted'])
			echo '
				<tr>
					<td class="unapproved_yet">', sprintf($txt['mgallery_admin_ftp_halted'], $context['ftp_done'], $context['total_files']), '</td>
				</tr>';
		foreach ($context['ftp_folder_list'] as $folder)
		{
			echo '
				<tr>
					<td class="windowbg2 smalltext" style="padding-left: ', (30 * $context['ftp_map'][$folder]['child_level']), 'px">
						<img src="', $settings['images_smg'], '/album.png" alt="folder" border="0" /> ', $context['ftp_map'][$folder]['fname'], ' (', count($context['ftp_map'][$folder]['files']), ' ', $txt['mgallery_files'], ')
						&nbsp;<select name="mgal_folder_', $folder, '">', $albumOpts_str, '</select>
					</td>
				</tr>';
			foreach ($context['ftp_map'][$folder]['files'] as $file)
			{
				echo '
				<tr>
					<td class="windowbg2 smalltext" style="padding-left: ', (30 * ($context['ftp_map'][$folder]['child_level'] + 1)), 'px">', $file[0], ' (', round($file[1] / 1024), ' ', $txt['mgallery_kb'], ')</td>
				</tr>';
			}
		}
		echo '
				<tr>
					<td class="windowbg2" align="center">
						<input type="submit" name="mgal_submit" value="', $txt['mgallery_submit'], '" />
						<input type="hidden" name="mgal_folder" value="pass" />
					</td>
				</tr>
			</table>
		</form>';
}

// Filestack view for gallery
function smg_filestack_list($items)
{
	global $galurl, $scripturl, $context, $txt, $settings;

	echo '
		<table cellpadding="4" cellspacing="1" border="0" style="width: 100%" class="bordercolor">
			<tr class="catbg">
				<td width="40%">', $txt['mgallery_name'], '</td>
				<td width="10%">', $txt['mgallery_posted_by'], '</td>
				<td width="20%">', $txt['mgallery_posted_on'], '</td>
				<td width="10%">', $txt['mgallery_views'], '</td>
				<td width="10%">', $txt['mgallery_comments'], '</td>
				<td width="10%">', $txt['mgallery_rating'], '</td>
			</tr>';

	$alt = false;
	foreach ($items as $item)
	{
		echo '
			<tr class="windowbg', $alt ? '2' : '', $item['approved'] ? '' : ' unapp', '">
				<td><a href="', $galurl, 'sa=item;id=', $item['id'], '">', $item['title'], '</a></td>
				<td>', smg_profile($item['poster_id'], $item['poster_name']), '</td>
				<td>', $item['posted_on'], '</td>
				<td>', $item['views'], '</td>
				<td>', $item['comments'], '</td>
				<td>', !empty($item['rating']) ? $item['rating'] : 0, ' <span class="smalltext">(', $item['voters'], ' ', $txt['mgallery_vote' . ($item['voters'] > 1 ? 's' : '') . '_noun'], ')</span></td>
			</tr>';
		$alt = !$alt;
	}
	echo '
		</table>';
}

function template_mgallery_playlist()
{
	global $context;

	if (!empty($context['smg_foxy_rendered_playlist']))
		echo '<br />' . $context['smg_foxy_rendered_playlist'];
}

function template_mgallery_rating_object($item)
{
	global $context, $settings, $txt, $galurl;

	$object = ($item['can_rate'] ? '
				<form action="'.$galurl.'sa=item;id='.$item['id_media'].'" method="post" id="ratingForm">' : '') . '
					' . ($item['voters'] > 0 ? str_repeat('<img alt="" src="'.$settings['images_url'].'/star.gif" />', round($item['avg_rating'])) . ' ' . round($item['avg_rating'], 2) . ' (' . (mgalAllowedTo('whoratedwhat') ? '<a href="' . $galurl . 'sa=whoratedwhat;id=' . $item['id_media'] . '">' : '') . $item['voters'] . ' ' . $txt['mgallery_vote' . ($item['voters'] > 1 ? 's' : '') . '_noun'] . (mgalAllowedTo('whoratedwhat') ? '</a>' : '') . ')' : '') .
					(!empty($item['weighted']) ? ' (' . $txt['mgallery_weighted_mean'] . ': ' . sprintf('%01.2f', $item['weighted']) . ')' : '');

	if ($item['can_rate'])
		$object .= '
					<select name="rating" id="rating">
						<option value="0">0</option>
						<option value="1">1</option>
						<option value="2">2</option>
						<option value="3">3</option>
						<option value="4">4</option>
						<option value="5">5</option>
					</select>
					<input type="button" value="'.$txt['mgallery_rate_it'].'" onclick="ajaxRating();"/>
				</form>';

	return $object;
}

function template_mgallery_xml_rated()
{
	global $context, $txt;

	echo '<?xml version="1.0" encoding="', $context['character_set'], '"?', '>
<ratingObject><![CDATA[', template_mgallery_rating_object($context['item_data']), ']]></ratingObject>';
}
?>