//  SMF-Media.com
// uploader.js
// Handler for uploading files using Yahoo UI Uploader
//
// Users of this software are bound by the terms of the
// SMG license. You can view it in the license_smg.txt file,
// or online at http://smf-media.com/smg/license.php
//  
// Support and updates for this software can be found at          
// http://smf-media.com	

// This should be called after window.load
var Uploader = {

	init: function(areas)
	{
		Uploader.currentProgress = YAHOO.util.Dom.get(areas['cprog']);
		Uploader.currentProgressText = YAHOO.util.Dom.get(areas['cprogtxt']);
		Uploader.currentProgressText2 = YAHOO.util.Dom.get(areas['cprogtxt2']);
		Uploader.currentProgressText3 = YAHOO.util.Dom.get(areas['cprogtxt3']);
		Uploader.overallProgress = YAHOO.util.Dom.get(areas['oprog']);
		Uploader.overallProgressText = YAHOO.util.Dom.get(areas['oprogtxt']);
		Uploader.overallProgressText2 = YAHOO.util.Dom.get(areas['oprogtxt2']);
		Uploader.browse = YAHOO.util.Dom.get(areas['browse']);
		Uploader.upload = YAHOO.util.Dom.get(areas['upload']);
		Uploader.list = YAHOO.util.Dom.get(areas['list']);
		Uploader.submit = YAHOO.util.Dom.get(areas['submit']);
		Uploader.tabindex = 0;
		Uploader.overAllTotal = 0;
		Uploader.overAllProg = 0;
		Uploader.tempAllProg = 0;
		Uploader.currProg = 0;
		Uploader.curOverallText = Uploader.overallProgressText.innerHTML;
		Uploader.browseBtn = YAHOO.util.Dom.getRegion(areas['browseBtn']);
		Uploader.upload.href = "javascript:Uploader.startNext();";
		Uploader.postURL = areas['postURL'];
		Uploader.files = new Array();
		Uploader.lastDone = 0;
		Uploader.done = new Array();
		Uploader.fileFilters = areas['filters'];
		YAHOO.util.Dom.setStyle(Uploader.browse, 'width', (Uploader.browseBtn.right - Uploader.browseBtn.left) + 'px');
		YAHOO.util.Dom.setStyle(Uploader.browse, 'height', (Uploader.browseBtn.bottom - Uploader.browseBtn.top) + 'px');

		YAHOO.widget.Uploader.SWFURL = areas['swfurl'];
		Uploader.uploader = new YAHOO.widget.Uploader('browse');

		Uploader.uploader.addListener('contentReady', Uploader.onContentReady);
	},

	onContentReady: function()
	{
		Uploader.uploader.setAllowMultipleFiles(true);
		Uploader.uploader.setFileFilters(Uploader.fileFilters);
		Uploader.uploader.addListener('fileSelect', Uploader.onFilesSelect);
		Uploader.uploader.addListener('uploadStart', Uploader.onUploadStart);
		Uploader.uploader.addListener('uploadProgress', Uploader.onUploadProgress);
		Uploader.uploader.addListener('uploadCompleteData', Uploader.onCompleteData);

		if (is_safari || is_chrome)
			document.getElementById('mu_container').style.textAlign = '';
	},

	setProg: function(which, prog)
	{
		var toSet = which == 'overall' ? Uploader.overallProgress : Uploader.currentProgress;
		YAHOO.util.Dom.setStyle(toSet, 'backgroundPosition', (100 - prog) + '%');

		if (which == 'current')
			Uploader.currentProgressText3.innerHTML = prog + '%';
		else
			Uploader.overallProgressText2.innerHTML = prog + '%';
	},

	setOverallTotal: function(toIncrement)
	{
		Uploader.overAllTotal += toIncrement;
		Uploader.overallProgressText.innerHTML = Uploader.curOverallText + ' (' + Uploader.bytesToSize(Uploader.overAllTotal) + ')';
	},

	setOverallProg: function(toProg)
	{
		var progPercent = Math.round(((toProg + Uploader.overAllProg) / Uploader.overAllTotal) * 100);
		Uploader.setProg('overall', progPercent);
	},

	bytesToSize: function (size)
	{
		if (size < 1024)
			return size + ' bytes';
		else if (size > 1024 && size < (1024 * 1024))
			return Math.round(size / 1024) + ' KB';
		else
			return Math.round(size / (1024 * 1024)) + ' MB';
	},

	onFilesSelect: function(event)
	{
		for (i in event.fileList)
		{
			if (document.getElementById(i))
				continue;

			var file = event.fileList[i];

			Uploader.setOverallTotal(file.size);

			var fsize = document.createElement('span');
			YAHOO.util.Dom.addClass(fsize, 'file-size');
			fsize.innerHTML = Uploader.bytesToSize(file.size);

			var rem = document.createElement('a');
			YAHOO.util.Dom.addClass(rem, 'file-remove');
			rem.href = 'javascript:Uploader.removeFile(\'' + file.id + '\');';
			rem.innerHTML = 'Remove';
			rem.id = 'rem_' + file.id;
			var name = document.createElement('span');
			YAHOO.util.Dom.addClass(name, 'file-name');
			name.innerHTML = file.name;

			var mainEl = document.createElement('li');
			YAHOO.util.Dom.addClass(mainEl, 'file');
			mainEl.id = file.id;

			mainEl.appendChild(fsize);
			mainEl.appendChild(rem);
			mainEl.appendChild(name);

			Uploader.list.appendChild(mainEl);

			Uploader.files[Uploader.files.length] = file;			
		}
	},

	onUploadStart: function(event)
	{
		var file = Uploader.files[Uploader.lastDone];
		var element = YAHOO.util.Dom.get(file.id);
		Uploader.currentProgressText2.innerHTML = file.name;
		YAHOO.util.Dom.addClass(element, 'file-uploading');
		Uploader.currProg = 0;
	},

	onCompleteData: function(event)
	{
		if (typeof(Uploader.files[Uploader.lastDone]) == 'undefined')
			return false;

		Uploader.overAllProg += Uploader.tempAllProg;
		Uploader.tempAllProg = 0;
		var file = Uploader.files[Uploader.lastDone];
		var element = YAHOO.util.Dom.get(file.id);

		if (!YAHOO.util.Dom.get('submit_title_update'))
		{
			var sub = document.createElement('input');
			sub.type = 'hidden';
			sub.name = 'submit_title_update';
			sub.id = sub.name;
			sub.value = 'dummy';

			Uploader.list.appendChild(sub);
		}

		var ret = event.data.split('|');
		var items = ret[0].split(';');
		var errors = ret[1].split(';');

		YAHOO.util.Dom.removeClass(element, 'file-uploading');
		YAHOO.util.Dom.addClass(element, 'file-success');
		YAHOO.util.Dom.setStyle(YAHOO.util.Dom.get('rem_' + file.id), 'display', 'none');		
		if (typeof(items) == 'object')
		{
			for (i = 0; i < items.length; i++)
			{
				var this_ret = items[i].split(',');

				if (this_ret[0].length == 0 || this_ret[0] == '')
					continue;

				var li = document.createElement('li');
				YAHOO.util.Dom.addClass(li, 'succ_item');

				var title_p = document.createElement('p');

				var title = document.createElement('input');
				title.type = 'text';
				title.value = this_ret[1];
				title.name = 'item_title_' + this_ret[0];
				title.tabindex = Uploader.tabindex;

				var img = document.createElement('img');
				img.src = galurl + 'sa=media;id=' + this_ret[0] + ';thumb';

				title_p.appendChild(title);
				li.appendChild(title_p);
				li.appendChild(img);

				element.appendChild(li);
				
				YAHOO.util.Dom.setStyle(YAHOO.util.Dom.get('mu_items'), 'display', 'block');			
			}
		}

		if (typeof(errors) == 'object')
		{
			for (i = 0; i < errors.length; i++)
			{
				if (!errors[i] || errors[i].length == 0)
					continue;

				var div = document.createElement('div');
				YAHOO.util.Dom.addClass(div, 'file-error');
				div.innerHTML = errors[i];

				element.appendChild(div);

				YAHOO.util.Dom.removeClass(element, 'file-success');
				YAHOO.util.Dom.addClass(element, 'file-failed');
			}
		}

		Uploader.done[Uploader.done.length] = file.id;
		Uploader.tabindex++;
		Uploader.lastDone++;

		Uploader.startNext();

		return true;
	},

	onUploadProgress: function(event)
	{
		var prog = Math.round((event['bytesLoaded'] / event['bytesTotal']) * 100);
		Uploader.setProg('current', prog);
		Uploader.currProg += prog;
		Uploader.tempAllProg = event['bytesLoaded'];
		Uploader.setOverallProg(event['bytesLoaded']);
	},

	startNext: function()
	{
		if (Uploader.files.length != Uploader.lastDone && typeof(Uploader.files[Uploader.lastDone]) != 'undefined')
			Uploader.uploader.upload(Uploader.files[Uploader.lastDone].id, Uploader.postURL, "POST", null, "Filedata", {});
	},

	removeFile: function(file_id)
	{
		Uploader.uploader.removeFile(file_id);
		YAHOO.util.Dom.setStyle(YAHOO.util.Dom.get(file_id), 'display', 'none');

		var file_key = 0;
		for (i in Uploader.files)
		{
			if (Uploader.files[i].id == file_id)
				file_key = i;
		}

		Uploader.setOverallTotal(Uploader.files[file_key].size * -1);
		delete Uploader.files[file_key];

		var files = Uploader.files;
		var inc = 0;
		Uploader.files = new Array();
		for (i in files)
		{
			Uploader.files[inc] = files[i];
			inc++;
		}
	}
}
