<?php
/****************************************************************
* SMF Media Gallery												*
* Version 2.0													*
*  SMF-Media.com												*
*****************************************************************
* db_mgallery.php												*
*****************************************************************
* Users of this software are bound by the terms of the			*
* SMG license. You can view it in the license_smg.txt file,		*
* or online at http://smf-media.com/smg/license.php				*
*																*
* Support and updates for this software can be found at			*
* http://smf-media.com											*
****************************************************************/

// This is the DB installer/upgrader for SMF Media Gallery
// This runs standalone if its in the same directory as SSI.php or it runs via the Package Manager
// Does edits for both, SMF 1.1 and SMF 2.0

// OK First load the stuff
global $smcFunc, $db_prefix, $context, $boarddir, $db_name, $db_passwd, $db_user, $db_server, $modSettings, $scripturl, $boardurl, $sourcedir;

$doing_manual_install = false;

if (!defined('SMF') && file_exists(dirname(__FILE__) . '/SSI.php'))
{
	require_once(dirname(__FILE__) . '/SSI.php');
	$doing_manual_install = true;
}
elseif (!defined('SMF'))
	die('The installer wasn\'t able to connect to SMF! Make sure that you are either installing this via the Package Manager or the SSI.php file is in the same directory.');

if (isset($_GET['delete']))
{
	@unlink(__FILE__);

	// From SMF
	header('Location: http://' . (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT']) . dirname($_SERVER['PHP_SELF']) . '/Themes/default/images/blank.gif');
	exit;
}

if ($doing_manual_install)
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head>
	<title>SMF Media Gallery Database Installer</title>
     <link rel="stylesheet" type="text/css" href="Themes/default/style.css" />
</head>
<body>
	<br /><br />';

// Some variables
$galprefix = $db_prefix . 'mgallery_';
// The new settings
$newsettings = array(
	'version' => '2.0 beta 4',
	'installed_on' => time(),
	'data_dir_path' => $boarddir . '/mgal_data',
	'max_dir_files' => '150',
	'num_items_per_page' => '15',
	'num_items_per_line' => '5',
	'num_items_per_line_ext' => '5',
	'max_dir_size' => '51400',
	'max_file_size' => '1024',
	'max_width' => '1024',
	'max_height' => '1024',
	'allow_over_max' => '1',
	'upload_security_check' => '0',
	'jpeg_compression' => '80',
	'num_unapproved_items' => '0',
	'num_unapproved_albums' => '0',
	'num_unapproved_comments' => '0',
	'num_unapproved_item_edits' => '0',
	'num_unapproved_album_edits' => '0',
	'num_reported_items' => '0',
	'num_reported_comments' => '0',
	'recent_item_limit' => '5',
	'random_item_limit' => '5',
	'recent_comments_limit' => '10',
	'recent_albums_limit' => '10',
	'total_items' => '0',
	'total_comments' => '0',
	'total_albums' => '0',
	'total_contests' => '0',
	'show_sub_albums_on_index' => '1',
	'enable_re-rating' => '0',
	'use_exif_date' => '1',
	'max_thumb_width' => '120',
	'max_thumb_height' => '120',
	'max_preview_width' => '500',
	'max_preview_height' => '500',
	'max_thumbs_per_page' => '10',
	'max_title_length' => '30',
	'show_extra_info' => '1',
	'entities_convert' => '0',
	'image_handler' => 1,
	'enable_cache' => 1,
	'use_lightbox' => 1,
	'show_linking_code' => 1,
	'album_edit_unapprove' => 1,
	'item_edit_unapprove' => 1,
);
$altered_mem_table_1 = false;
$altered_mem_table_2 = false;
$altered_mem_table_3 = false;

// Start it!
if (isset($smcFunc))
{
	// SMF 2 installer
	// Fix up some stuff for manual install
	//if ($doing_manual_install) {
	//	$smcFunc['db_select_db']($db_name);
	//	$db_prefix = substr($db_prefix, strlen($db_name) + 3);
	//}
	// First load the SMF 2's Extra DB Functions
	db_extend('packages');
	db_extend('extra');

	// Get the table list
	$tables = array();
	$tmp = $smcFunc['db_list_tables']();
	foreach ($tmp as $t)
		if (substr($db_prefix,0,strlen($db_name) + 3) != '`'.$db_name.'`.')
			$tables[] = $t;
		else
			$tables[] = '`'.$db_name . '`.'.$t;

	// Create the tables

	// The mgallery_media table
	$smcFunc['db_create_table'](
		'mgallery_media',
		array(
			array('name' => 'id_media', 'type' => 'INT', 'auto' => true),
			array('name' => 'id_member', 'type' => 'INT', 'default' => 0),
			array('name' => 'member_name', 'type' => 'VARCHAR', 'default' => '', 'size' => '25'),
			array('name' => 'last_edited', 'type' => 'INT', 'default' => 0),
			array('name' => 'last_edited_by', 'type' => 'INT', 'default' => 0),
			array('name' => 'last_edited_name', 'type' => 'text', 'default' => ''),
			array('name' => 'id_file', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_thumb', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_preview', 'type' => 'INT', 'default' => 0),
			array('name' => 'type', 'type' => 'VARCHAR', 'size' => '10', 'default' => 'image'),
			array('name' => 'album_id', 'type' => 'INT', 'default' => 0),
			array('name' => 'rating', 'type' => 'INT', 'default' => 0),
			array('name' => 'voters', 'type' => 'MEDIUMINT', 'default' => 0),
			array('name' => 'weighted', 'type' => 'FLOAT', 'default' => 0),
			array('name' => 'title', 'type' => 'VARCHAR', 'size' => '255', 'default' => '(No title)'),
			array('name' => 'description', 'type' => 'text', 'default' => ''),
			array('name' => 'approved', 'type' => 'TINYINT', 'size' => '1', 'default' => '0'),
			array('name' => 'time_added', 'type' => 'INT', 'default' => '0'),
			array('name' => 'views', 'type' => 'INT', 'default' => '0'),
			array('name' => 'downloads', 'type' => 'INT', 'default' => '0'),
			array('name' => 'last_viewed', 'type' => 'TINYINT', 'size' => '1', 'default' => '0'),
			array('name' => 'keywords', 'type' => 'text', 'default' => ''),
			array('name' => 'embed_url', 'type' => 'text', 'default' => ''),
			array('name' => 'id_last_comment', 'type' => 'INT', 'default' => '0'),
			array('name' => 'log_last_access_time', 'type' => 'INT', 'default' => '0'),
			array('name' => 'num_comments', 'type' => 'INT', 'default' => '0'),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_media')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'media';

	// The mgallery_files table
	$smcFunc['db_create_table'](
		'mgallery_files',
		array(
			array('name' => 'id_file', 'type' => 'INT', 'auto' => true),
			array('name' => 'filesize', 'type' => 'INT', 'size' => '20', 'default' => '0'),
			array('name' => 'filename', 'type' => 'text', 'default' => ''),
			array('name' => 'width', 'type' => 'INT', 'default' => '1', 'size' => '4'),
			array('name' => 'height', 'type' => 'INT', 'default' => '1', 'size' => '4'),
			array('name' => 'directory', 'type' => 'text', 'default' => ''),
			array('name' => 'id_album', 'type' => 'INT', 'default' => '0', 'size' => '20'),
			array('name' => 'exif', 'type' => 'text', 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_file')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'files';

	// The mgallery_albums table
	$smcFunc['db_create_table'](
		'mgallery_albums',
		array(
			array('name' => 'id_album', 'type' => 'INT', 'auto' => true),
			array('name' => 'album_of', 'type' => 'INT', 'default' => '0'),
			array('name' => 'member_name', 'type' => 'VARCHAR', 'default' => '', 'size' => '25'),
			array('name' => 'type', 'type' => 'VARCHAR', 'size' => '10', 'default' => ''),
			array('name' => 'name', 'type' => 'VARCHAR', 'size' => '50', 'default' => ''),
			array('name' => 'description', 'type' => 'text', 'default' => ''),
			array('name' => 'icon', 'type' => 'INT', 'default' => '0'),
			array('name' => 'passwd', 'type' => 'VARCHAR', 'size' => '64', 'default' => ''),
			array('name' => 'directory', 'type' => 'text', 'default' => ''),
			array('name' => 'parent', 'type' => 'INT', 'default' => '0'),
			array('name' => 'access', 'type' => 'VARCHAR', 'size' => '255', 'default' => ''),
			array('name' => 'approved', 'type' => 'TINYINT', 'size' => '1', 'default' => '0'),
			array('name' => 'a_order', 'type' => 'INT', 'default' => '0'),
			array('name' => 'child_level', 'type' => 'INT', 'default' => '0'),
			array('name' => 'id_last_media', 'type' => 'INT', 'default' => '0'),
			array('name' => 'num_items', 'type' => 'INT', 'default' => '0'),
			array('name' => 'options', 'type' => 'text', 'default' => ''),
			array('name' => 'id_perm_profile', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_quota_profile', 'type' => 'INT', 'default' => 0),
			array('name' => 'hidden', 'type' => 'TINYINT', 'size' => '1', 'default' => '0'),
			array('name' => 'allowed_members', 'type' => 'VARCHAR', 'size' => '255', 'default' => ''),
			array('name' => 'denied_members', 'type' => 'VARCHAR', 'size' => '255', 'default' => ''),
			array('name' => 'id_topic', 'type' => 'INT', 'default' => '0'),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_album')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'albums';

	// The mgallery_settings table
	$smcFunc['db_create_table'](
		'mgallery_settings',
		array(
			array('name' => 'name', 'type' => 'VARCHAR', 'size' => '30', 'default' => ''),
			array('name' => 'value', 'type' => 'text', 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('name')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'settings';

	// The mgallery_variables table
	$smcFunc['db_create_table'](
		'mgallery_variables',
		array(
			array('name' => 'id', 'type' => 'INT', 'auto' => true),
			array('name' => 'type', 'type' => 'VARCHAR', 'size' => '15', 'default' => ''),
			array('name' => 'val1', 'type' => 'text', 'default' => ''),
			array('name' => 'val2', 'type' => 'text', 'default' => ''),
			array('name' => 'val3', 'type' => 'text', 'default' => ''),
			array('name' => 'val4', 'type' => 'text', 'default' => ''),
			array('name' => 'val5', 'type' => 'text', 'default' => ''),
			array('name' => 'val6', 'type' => 'text', 'default' => ''),
			array('name' => 'val7', 'type' => 'text', 'default' => ''),
			array('name' => 'val8', 'type' => 'text', 'default' => ''),
			array('name' => 'val9', 'type' => 'text', 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'variables';

	// The mgallery_comments table
	$smcFunc['db_create_table'](
		'mgallery_comments',
		array(
			array('name' => 'id_comment', 'type' => 'INT', 'default' => '', 'auto' => true),
			array('name' => 'id_member', 'type' => 'INT', 'default' => '0'),
			array('name' => 'id_media', 'type' => 'INT', 'default' => '0'),
			array('name' => 'id_album', 'type' => 'INT', 'default' => '0'),
			array('name' => 'message', 'type' => 'text', 'default' => ''),
			array('name' => 'posted_on', 'type' => 'INT', 'default' => '0'),
			array('name' => 'last_edited', 'type' => 'INT', 'default' => '0'),
			array('name' => 'last_edited_by', 'type' => 'INT', 'default' => '0'),
			array('name' => 'last_edited_name', 'type' => 'VARCHAR', 'size' => '25', 'default' => ''),
			array('name' => 'approved', 'type' => 'TINYINT', 'size' => '1', 'default' => '0'),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_comment')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'comments';

	// The mgallery_log_media table
	$smcFunc['db_create_table'](
		'mgallery_log_media',
		array(
			array('name' => 'id_media', 'type' => 'INT', 'default' => '0'),
			array('name' => 'id_member', 'type' => 'INT', 'default' => '0'),
			array('name' => 'time', 'type' => 'INT', 'default' => '0'),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_media', 'id_member')
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'log_media';

	// The mgallery_log_ratings table
	$smcFunc['db_create_table'](
		'mgallery_log_ratings',
		array(
			array('name' => 'id_media', 'type' => 'INT', 'default' => '0'),
			array('name' => 'id_member', 'type' => 'INT', 'default' => '0'),
			array('name' => 'rating', 'type' => 'INT', 'default' => '0'),
			array('name' => 'time', 'type' => 'INT', 'default' => '0')
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_media', 'id_member'),
			)
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'log_ratings';

	// The permissions table
	$smcFunc['db_create_table'](
		'mgallery_perms',
		array(
			array('name' => 'id_group', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_profile', 'type' => 'INT', 'default' => 0),
			array('name' => 'permission', 'type' => 'VARCHAR', 'size' => 255, 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_group', 'id_profile', 'permission'),
			),
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'perms';

	// The member group quotas table
	$smcFunc['db_create_table'](
		'mgallery_quotas',
		array(
			array('name' => 'id_profile', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_group', 'type' => 'INT', 'default' => 0),
			array('name' => 'type', 'type' => 'VARCHAR', 'size' => 10, 'default' => ''),
			array('name' => 'limit', 'type' => 'INT', 'default' => 0),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_profile', 'id_group', 'type'),
			),
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'quotas';

	// The custom fielsd table
	$smcFunc['db_create_table'](
		'mgallery_fields',
		array(
			array('name' => 'id_field', 'type' => 'INT', 'auto' => true, 'default' => 0),
			array('name' => 'name', 'type' => 'VARCHAR', 'size' => 100, 'default' => ''),
			array('name' => 'type', 'type' => 'VARCHAR', 'size' => 20, 'default' => 'text'),
			array('name' => 'options', 'type' => 'text', 'default' => ''),
			array('name' => 'required', 'type' => 'TINYINT', 'size' => 1, 'default' => 0),
			array('name' => 'searchable', 'type' => 'TINYINT', 'size' => 1, 'default' => 0),
			array('name' => 'desc', 'type' => 'text', 'default' => ''),
			array('name' => 'bbc', 'type' => 'TINYINT', 'size' => 1, 'default' => 0),
			array('name' => 'albums', 'type' => 'text', 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_field'),
			),
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'fields';

	// The custom field's data table
	$smcFunc['db_create_table'](
		'mgallery_field_data',
		array(
			array('name' => 'id_field', 'type' => 'INT', 'default' => 0),
			array('name' => 'id_media', 'type' => 'INT', 'default' => 0),
			array('name' => 'value', 'type' => 'text', 'default' => ''),
		),
		array(
			array(
				'type' => 'primary',
				'columns' => array('id_field', 'id_media'),
			),
		),
		array(),
		'ignore'
	);
	$created_tables[] = $galprefix . 'field_data';

	$mem_columns = $smcFunc['db_list_columns']('members', false);
	$file_columns = $smcFunc['db_list_columns']('mgallery_files', false);
	$album_columns = $smcFunc['db_list_columns']('mgallery_albums', false);
	$media_columns = $smcFunc['db_list_columns']('mgallery_media', false);
	if (!in_array('id_perm_profile', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'id_perm_profile', 'type' => 'INT', 'default' => 0));
	if (!in_array('id_quota_profile', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'id_quota_profile', 'type' => 'INT', 'default' => 0));
	if (!in_array('hidden', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'hidden', 'type' => 'TINYINT', 'size' => '1', 'default' => 0));
	if (!in_array('allowed_members', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'allowed_members', 'type' => 'VARCHAR', 'size' => '255', 'default' => ''));
	if (!in_array('denied_members', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'denied_members', 'type' => 'VARCHAR', 'size' => '255', 'default' => ''));
	if (!in_array('id_topic', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'id_topic', 'type' => 'INT', 'default' => 0));

	if (!in_array('mgal_total_items', $mem_columns))
	{
		$smcFunc['db_add_column']('members', array('name' => 'mgal_total_items', 'type' => 'INT', 'null' => null, 'default' => '0'));
		$altered_mem_table_1 = true;
	}
	if (!in_array('mgal_total_comments', $mem_columns))
	{
		$smcFunc['db_add_column']('members', array('name' => 'mgal_total_comments', 'type' => 'INT', 'null' => null, 'default' => '0'));
		$altered_mem_table_2 = true;
	}
	if (!in_array('mgal_unseen', $mem_columns))
	{
		$smcFunc['db_add_column']('members', array('name' => 'mgal_unseen', 'type' => 'INT', 'null' => null, 'default' => '-1'));
		$altered_mem_table_3 = true;
	}
	if (!in_array('exif', $file_columns))
		$smcFunc['db_add_column']('mgallery_files', array('name' => 'exif', 'type' => 'text', 'default' => ''));
	if (!in_array('options', $album_columns))
		$smcFunc['db_add_column']('mgallery_albums', array('name' => 'options', 'type' => 'text', 'default' => ''));
	if (!in_array('id_preview', $media_columns))
	{
		$smcFunc['db_add_column']('mgallery_media', array('name' => 'id_preview', 'type' => 'INT', 'default' => '0'));
		$smcFunc['db_change_column']('mgallery_media', 'type', array('type' => 'VARCHAR', 'size' => '10', 'default' => 'image'));
	}
	// 1.5 beta process
	if (!in_array('downloads', $media_columns))
	{
		$smcFunc['db_add_column']('mgallery_media', array('name' => 'downloads', 'type' => 'INT', 'default' => '0'));
		$smcFunc['db_change_column']('mgallery_albums', 'access', array('size' => 255));
		$smcFunc['db_change_column']('mgallery_albums', 'name', array('size' => 50));
	}
	if (!in_array('weighted', $media_columns))
	{
		$smcFunc['db_add_column']('mgallery_media', array('name' => 'weighted', 'type' => 'FLOAT', 'default' => '0'));
		$smcFunc['db_change_column']('mgallery_media', 'title', array('size' => 255));
		require_once($sourcedir . '/Subs-MGallery.php');
		if (function_exists('smg_update_weighted'))
		{
			loadMGal_Settings();
			smg_update_weighted();
		}
	}
	$smcFunc['db_change_column']('mgallery_media', 'title', array('size' => 255));

	// Permissions processing...dabadabadum way?
	if (!in_array($galprefix . 'perms', $tables))
	{
		// Insert a brand new profile
		$smcFunc['db_insert'](
			'ignore',
			'{db_prefix}mgallery_variables',
			array(
				'type' => 'string',
				'val1' => 'string',
			),
			array(
				'perm_profile',
				'Default',
			),
			array('id')
		);
		$id_profile = $smcFunc['db_insert_id']('{db_prefix}mgallery_variables');

		// Bypass to a small issue
		if ($id_profile == 1)
		{
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}mgallery_variables
				SET id = 2
				WHERE id = 1',
				array()
			);
			$smcFunc['db_query']('', '
				ALTER TABLE {db_prefix}mgallery_variables AUTO_INCREMENT = 3', array());
		}

		// Get existing permissions
		$request = $smcFunc['db_query']('', '
			SELECT permission, add_deny, id_group
			FROM {db_prefix}permissions',
			array()
		);
		$removals = array();
		$perms = array();
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			if (!in_array($row['permission'], array('mgallery_download_item', 'mgallery_add_videos', 'mgallery_add_audios', 'mgallery_add_images', 'mgallery_add_embeds', 'mgallery_add_docs', 'mgallery_rate_items', 'mgallery_edit_own_com', 'mgallery_edit_own_item', 'mgallery_comment', 'mgallery_report_item', 'mgallery_report_com', 'mgallery_auto_approve_com', 'mgallery_auto_approve_item', 'mgallery_multi_upload', 'mgallery_multi_download', 'mgallery_whoratedwhat')))
				continue;

			if (!isset($perms[$row['id_group']]))
				$perms[$row['id_group']] = array();
			if (!isset($removals[$row['id_group']]))
				$removals[$row['id_group']] = array();

			if (empty($row['add_deny']))
				$removals[$row['id_group']][] = substr($row['permission'], 9);
			else
				$perms[$row['id_group']][] = substr($row['permission'], 9);
		}
		$smcFunc['db_free_result']($request);

		if (!empty($modSettings['permission_enable_deny']))
			foreach ($perms as $group => $permarray)
				$perms[$group] = array_diff($perms[$group], $removals[$group]);

		// Insert it to the profile
		foreach ($perms as $group => $permArray)
			foreach ($permArray as $perm)
				$smcFunc['db_insert']('ignore',
					'{db_prefix}mgallery_perms',
					array(
						'id_profile' => 'int',
						'id_group' => 'int',
						'permission' => 'string',
					),
					array(
						$id_profile,
						$group,
						$perm,
					),
					array('id_profile', 'id_group', 'permission')
				);

		// Update the albums
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}mgallery_albums
			SET id_perm_profile = {int:profile}
			WHERE type != {string:user}',
			array(
				'profile' => $id_profile,
				'user' => 'user',
			)
		);
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}mgallery_albums
			SET id_perm_profile = 1
			WHERE type = {string:user}',
			array(
				'user' => 'user',
			)
		);
	}
	// Import the settings now
	$setting_entries = array();
	foreach ($newsettings as $name => $value)
	{
		$smcFunc['db_insert']('ignore', $galprefix . 'settings', array('name' => 'string', 'value' => 'string'), array($name, $value), '');
		if ($smcFunc['db_affected_rows']() > 0)
			$setting_entries[] = $name;
	}

	// Insert the mandatory data
	$smcFunc['db_query']('', 'DELETE FROM {db_prefix}mgallery_files WHERE id_file <= 4');

	$smcFunc['db_insert']('',
		$db_prefix.'mgallery_files',
		array('id_file' => 'int', 'filename' => 'string-255', 'filesize' => 'int', 'directory' => 'string-255', 'width' => 'int', 'height' => 'int', 'id_album' => 'int'),
		array(1, 'music.png', 4118, 'generic_images', 48, 48, 0),
		array('id_file')
	);
	$smcFunc['db_insert']('',
		$db_prefix.'mgallery_files',
		array('id_file' => 'int', 'filename' => 'string-255', 'filesize' => 'int', 'directory' => 'string-255', 'width' => 'int', 'height' => 'int', 'id_album' => 'int'),
		array(2, 'film.png', 2911, 'generic_images', 48, 48, 0),
		array('id_file')
	);
	$smcFunc['db_insert']('',
		$db_prefix.'mgallery_files',
		array('id_file' => 'int', 'filename' => 'string-255', 'filesize' => 'int', 'directory' => 'string-255', 'width' => 'int', 'height' => 'int', 'id_album' => 'int'),
		array(3, 'camera.png', 2438, 'generic_images', 48, 48, 0),
		array('id_file')
	);
	$smcFunc['db_insert']('',
		$db_prefix.'mgallery_files',
		array('id_file' => 'int', 'filename' => 'string-255', 'filesize' => 'int', 'directory' => 'string-255', 'width' => 'int', 'height' => 'int', 'id_album' => 'int'),
		array(4, 'folder.png', 2799, 'generic_images', 48, 48, 0),
		array('id_file')
	);

	$request = $smcFunc['db_query']('', '
		SELECT value FROM {db_prefix}mgallery_settings WHERE name={string:data_dir}',
		array('data_dir' => 'data_dir_path'));
	list($data_dir) = $smcFunc['db_fetch_row']($request);
	$data_dir .= '/generic_images/';
	$ex_data_dir = $boarddir . '/mgal_data/generic_images/';
	$cam = $data_dir . 'camera.png';
	if ((!file_exists($cam) || filesize($cam) == 665) && filesize($ex_data_dir . 'camera.png') == 2438)
	{
		@copy($ex_data_dir . 'camera.png', $data_dir . 'camera.png');
		@copy($ex_data_dir . 'film.png', $data_dir . 'film.png');
		@copy($ex_data_dir . 'music.png', $data_dir . 'music.png');
		@copy($ex_data_dir . 'folder.png', $data_dir . 'folder.png');
	}
	$smcFunc['db_free_result']($request);

	if (file_exists($sourcedir . '/Subs-MGallery-Vital.php'))
	{
		require_once($sourcedir . '/Subs-MGallery-Vital.php');
		if (function_exists('getAllowedTypes'))
		{
			$aty = getAllowedTypes();
			$aty['do'][] = 'default';
			foreach ($aty['do'] as $ty)
				if (!file_exists($data_dir . $ty . '.png') && file_exists($ex_data_dir . $ty . '.png'))
					@copy($ex_data_dir . $ty . '.png', $data_dir . $ty . '.png');
		}
	}
	// Update the version no matter what
	$smcFunc['db_query']('', '
		UPDATE {db_prefix}mgallery_settings
		SET value = {string:value}
		WHERE name = {string:name}',
		array(
			'value' => $newsettings['version'],
			'name' => 'version',
		)
	);
}
else
{
	// SMF 1.1 installer
	// First list all the tables
	$request = db_query("
		SHOW TABLES
		FROM `$db_name`"
	,__FILE__,__LINE__);
	$tables = array();
	while ($row = mysql_fetch_row($request))
		if (substr($db_prefix,0,strlen($db_name) + 3) != '`'.$db_name.'`.')
			$tables[] = $row[0];
		else
			$tables[] = '`'.$db_name . '`.'.$row[0];

	mysql_free_result($request);
	// Create the tables

	// The mgallery_media table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}media (
			id_media INT AUTO_INCREMENT PRIMARY KEY NOT NULL,
			id_member INT NOT NULL,
			member_name VARCHAR(25) NOT NULL DEFAULT '',
			last_edited INT NOT NULL DEFAULT 0,
			last_edited_by INT NOT NULL DEFAULT 0,
			last_edited_name text NOT NULL DEFAULT '',
			id_file INT NOT NULL DEFAULT 0,
			id_thumb INT NOT NULL DEFAULT 0,
			id_preview INT NOT NULL DEFAULT 0,
			type VARCHAR(10) NOT NULL DEFAULT 'image',
			album_id INT NOT NULL DEFAULT 0,
			rating INT NOT NULL DEFAULT 0,
			voters MEDIUMINT NOT NULL DEFAULT 0,
			weighted FLOAT NOT NULL DEFAULT 0,
			title VARCHAR(255) NOT NULL DEFAULT '(No title)',
			description text NOT NULL DEFAULT '',
			approved TINYINT(1) NOT NULL DEFAULT 0,
			time_added INT NOT NULL DEFAULT 0,
			views INT NOT NULL DEFAULT 0,
			downloads INT NOT NULL DEFAULT 0,
			last_viewed INT NOT NULL DEFAULT 0,
			keywords text NOT NULL DEFAULT '',
			embed_url text NOT NULL DEFAULT '',
			id_last_comment INT NOT NULL DEFAULT 0,
			log_last_access_time INT NOT NULL DEFAULT 0,
			num_comments INT NOT NULL DEFAULT 0
		)",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'media';

	// The mgallery_files table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}files (
			id_file INT AUTO_INCREMENT PRIMARY KEY NOT NULL,
			filesize INT NOT NULL DEFAULT 0,
			filename text NOT NULL DEFAULT '',
			width INT NOT NULL DEFAULT 1,
			height INT NOT NULL DEFAULT 1,
			directory text NOT NULL DEFAULT '',
			id_album INT NOT NULL DEFAULT 0,
			exif text NOT NULL DEFAULT ''
		)
	",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'files';

	// The mgallery_albums table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}albums (
			id_album INT AUTO_INCREMENT PRIMARY KEY NOT NULL,
			album_of INT NOT NULL DEFAULT 0,
			member_name VARCHAR(25) NOT NULL DEFAULT '',
			type VARCHAR(10) NOT NULL DEFAULT '',
			name VARCHAR(50) NOT NULL DEFAULT '',
			description text NOT NULL DEFAULT '',
			icon INT NOT NULL DEFAULT 0,
			passwd VARCHAR(64) NOT NULL DEFAULT '',
			directory text NOT NULL DEFAULT '',
			parent INT NOT NULL DEFAULT 0,
			access VARCHAR(255) NOT NULL DEFAULT '',
			approved TINYINT(1) NOT NULL DEFAULT 0,
			a_order INT NOT NULL DEFAULT 0,
			child_level INT NOT NULL DEFAULT 0,
			id_last_media INT NOT NULL DEFAULT 0,
			num_items INT NOT NULL DEFAULT 0,
			options text NOT NULL DEFAULT '',
			id_perm_profile INT NOT NULL DEFAULT 0,
			id_quota_profile INT NOT NULL DEFAULT 0,
			hidden TINYINT(1) NOT NULL DEFAULT 0,
			allowed_members VARCHAR(255) NOT NULL DEFAULT '',
			denied_members VARCHAR(255) NOT NULL DEFAULT '',
			id_topic INT NOT NULL DEFAULT 0
		)
	",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'albums';

	// The mgallery_settings table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}settings (
			name VARCHAR(30) PRIMARY KEY NOT NULL DEFAULT '',
			value text NOT NULL DEFAULT ''
		)
	",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'settings';

	// The mgallery_variables table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}variables (
			id INT PRIMARY KEY AUTO_INCREMENT NOT NULL,
			type VARCHAR(15) NOT NULL DEFAULT '',
			val1 text NOT NULL DEFAULT '',
			val2 text NOT NULL DEFAULT '',
			val3 text NOT NULL DEFAULT '',
			val4 text NOT NULL DEFAULT '',
			val5 text NOT NULL DEFAULT '',
			val6 text NOT NULL DEFAULT '',
			val7 text NOT NULL DEFAULT '',
			val8 text NOT NULL DEFAULT '',
			val9 text NOT NULL DEFAULT ''
		)
	",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'variables';

	// The mgallery_comments table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}comments (
			id_comment INT PRIMARY KEY AUTO_INCREMENT  NOT NULL,
			id_member INT NOT NULL DEFAULT 0,
			id_media INT NOT NULL DEFAULT 0,
			id_album INT NOT NULL DEFAULT 0,
			message text NOT NULL DEFAULT '',
			posted_on INT NOT NULL DEFAULT 0,
			last_edited INT NOT NULL DEFAULT 0,
			last_edited_by INT NOT NULL DEFAULT 0,
			last_edited_name VARCHAR(25) NOT NULL DEFAULT '',
			approved TINYINT(1) NOT NULL DEFAULT 0
		)
	",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'comments';

	// The mgallery_log_media table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}log_media (
			id_media INT NOT NULL DEFAULT 0,
			id_member INT NOT NULL DEFAULT 0,
			time INT NOT NULL DEFAULT 0,
			PRIMARY KEY (id_media, id_member)
		)",__FILE__,__LINE__);

	$created_tables[] = $galprefix . 'log_media';

	// The mgallery_log_ratings table
	db_query("
		CREATE TABLE IF NOT EXISTS {$galprefix}log_ratings (
			id_media INT NOT NULL DEFAULT 0,
			id_member INT NOT NULL DEFAULT 0,
			rating TINYINT(1) NOT NULL DEFAULT 0,
			time INT NOT NULL DEFAULT 0,
			PRIMARY KEY (id_media, id_member)
		)
	",__FILE__,__LINE__);
	$created_tables[] = $galprefix . 'log_ratings';

	// The permissions table
	db_query("
		CREATE TABLE IF NOT EXISTS {$db_prefix}mgallery_perms (
			id_group INT NOT NULL DEFAULT 0,
			id_profile INT NOT NULL DEFAULT 0,
			permission VARCHAR(255) NOT NULL DEFAULT '',
			PRIMARY KEY (id_group, id_profile, permission)
		)
	",__FILE__,__LINE__);
	$created_tables[] = $galprefix . 'perms';

	// The permissions table
	db_query("
		CREATE TABLE IF NOT EXISTS {$db_prefix}mgallery_quotas (
			id_profile INT NOT NULL DEFAULT 0,
			id_group INT NOT NULL DEFAULT 0,
			type VARCHAR(10) NOT NULL DEFAULT '',
			`limit` INT NOT NULL DEFAULT 0,
			PRIMARY KEY (id_profile, id_group, type)
		)
	",__FILE__,__LINE__);
	$created_tables[] = $galprefix . 'quotas';

	// The custom fields table
	db_query("
		CREATE TABLE IF NOT EXISTS {$db_prefix}mgallery_fields (
			id_field INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
			name VARCHAR(100) NOT NULL DEFAULT '',
			type VARCHAR(20) NOT NULL DEFAULT 'text',
			options text NOT NULL DEFAULT '',
			required TINYINT(1) NOT NULL DEFAULT 0,
			searchable TINYINT(1) NOT NULL DEFAULT 0,
			`desc` text NOT NULL DEFAULT '',
			bbc TINYINT(1) NOT NULL DEFAULT 0,
			albums text NOT NULL DEFAULT ''
		)",__FILE__,__LINE__);
	$created_tables[] = $galprefix . 'fields';

	// Custom fields' data table
	db_query("
		CREATE TABLE IF NOT EXISTS {$db_prefix}mgallery_field_data (
			id_field INT NOT NULL DEFAULT 0,
			id_media INT NOT NULL DEFAULT 0,
			value text NOT NULL DEFAULT '',
			PRIMARY KEY (id_media, id_field)
		)",__FILE__,__LINE__);
	$created_tables[] = $galprefix . 'field_data';

	// Member table alterations
	$request = db_query("SHOW FIELDS FROM {$db_prefix}members",__FILE__,__LINE__);
	$fields = array();
	while ($row = mysql_fetch_assoc($request))
		$fields[] = $row['Field'];
	mysql_free_result($request);

	if (!in_array('mgal_total_items', $fields))
	{
		db_query("ALTER TABLE {$db_prefix}members ADD mgal_total_items INT NOT NULL DEFAULT '0'",__FILE__,__LINE__);
		$altered_mem_table_1 = true;
	}
	if (!in_array('mgal_total_comments', $fields))
	{
		db_query("ALTER TABLE {$db_prefix}members ADD mgal_total_comments INT NOT NULL DEFAULT '0'",__FILE__,__LINE__);
		$altered_mem_table_2 = true;
	}
	if (!in_array('mgal_unseen', $fields))
	{
		db_query("ALTER TABLE {$db_prefix}members ADD mgal_unseen INT NOT NULL DEFAULT '-1'",__FILE__,__LINE__);
		$altered_mem_table_3 = true;
	}

	// Files table alterations
	$request = db_query("SHOW FIELDS FROM {$galprefix}files",__FILE__,__LINE__);
	$fields = array();
	while ($row = mysql_fetch_assoc($request))
		$fields[] = $row['Field'];
	mysql_free_result($request);

	if (!in_array('exif', $fields))
		db_query("ALTER TABLE {$galprefix}files ADD exif text NOT NULL DEFAULT ''",__FILE__,__LINE__);

	// Albums table alterations
	$request = db_query("SHOW FIELDS FROM {$galprefix}albums",__FILE__,__LINE__);
	$fields = array();
	while ($row = mysql_fetch_assoc($request))
		$fields[] = $row['Field'];
	mysql_free_result($request);

	if (!in_array('options', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD options text NOT NULL DEFAULT ''",__FILE__,__LINE__);
	if (!in_array('id_perm_profile', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD id_perm_profile INT NOT NULL DEFAULT 0",__FILE__,__LINE__);
	if (!in_array('id_quota_profile', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD id_quota_profile INT NOT NULL DEFAULT 0",__FILE__,__LINE__);
	if (!in_array('hidden', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD hidden TINYINT(1) NOT NULL DEFAULT 0",__FILE__,__LINE__);
	if (!in_array('allowed_members', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD allowed_members VARCHAR(255) NOT NULL DEFAULT ''",__FILE__,__LINE__);
	if (!in_array('denied_members', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD denied_members VARCHAR(255) NOT NULL DEFAULT ''",__FILE__,__LINE__);
	if (!in_array('id_topic', $fields))
		db_query("ALTER TABLE {$galprefix}albums ADD id_topic INT NOT NULL DEFAULT 0",__FILE__,__LINE__);

	// Permissions processing...dabadabadum way?
	if (!in_array($galprefix . 'perms', $tables))
	{
		// Insert a brand new profile
		db_query("
			INSERT IGNORE INTO {$db_prefix}mgallery_variables
			(type, val1)
			VALUES
			('perm_profile', 'Default')",__FILE__,__LINE__);
		$id_profile = db_insert_id();

		// Bypass to a small issue
		if ($id_profile == 1)
		{
			db_query("
				UPDATE {$db_prefix}mgallery_variables
				SET id = 2
				WHERE id = 1",
				__FILE__,__LINE__
			);
			db_query("
				ALTER TABLE {$db_prefix}mgallery_variables AUTO_INCREMENT = 3",__FILE__,__LINE__);
		}

		// Get existing permissions
		$request = db_query("
			SELECT permission, addDeny AS add_deny, ID_GROUP AS id_group
			FROM {$db_prefix}permissions",
			__FILE__,__LINE__);
		$removals = array();
		$perms = array();
		while ($row = mysql_fetch_assoc($request))
		{
			if (!in_array($row['permission'], array('mgallery_download_item', 'mgallery_add_videos', 'mgallery_add_audios', 'mgallery_add_images', 'mgallery_add_embeds', 'mgallery_add_docs', 'mgallery_rate_items', 'mgallery_edit_own_com', 'mgallery_edit_own_item', 'mgallery_comment', 'mgallery_report_item', 'mgallery_report_com', 'mgallery_auto_approve_com', 'mgallery_auto_approve_item', 'mgallery_multi_upload', 'mgallery_multi_download', 'mgallery_whoratedwhat')))
				continue;

			if (!isset($perms[$row['id_group']]))
				$perms[$row['id_group']] = array();
			if (!isset($removals[$row['id_group']]))
				$removals[$row['id_group']] = array();

			if (empty($row['add_deny']))
				$removals[$row['id_group']][] = $row['permission'];
			else
				$perms[$row['id_group']][] = $row['permission'];
		}
		mysql_free_result($request);

		if (!empty($modSettings['permission_enable_deny']))
			foreach ($perms as $group => $permarray)
				$perms[$group] = array_diff($perms[$group], $removals[$group]);

		// Insert it to the profile
		foreach ($perms as $group => $permArray)
			foreach ($permArray as $perm)
				db_query("
					INSERT IGNORE INTO {$db_prefix}mgallery_perms
					(id_profile, id_group, permission)
					VALUES
					($id_profile, $group, '$permission')",__FILE__,__LINE__);

		// Update the albums
		db_query("
			UPDATE {$db_prefix}mgallery_albums
			SET id_perm_profile = $id_profile
			WHERE type != 'user'",__FILE__,__LINE__
		);
		db_query("
			UPDATE {$db_prefix}mgallery_albums
			SET id_perm_profile = 1
			WHERE type = 'user'",__FILE__,__LINE__
		);
	}

	// Media table alterations
	$request = db_query("SHOW FIELDS FROM {$galprefix}media",__FILE__,__LINE__);
	$fields = array();
	while ($row = mysql_fetch_assoc($request))
		$fields[] = $row['Field'];
	mysql_free_result($request);

	if (!in_array('id_preview', $fields))
	{
		db_query("ALTER TABLE {$galprefix}media ADD id_preview INT NOT NULL DEFAULT '0'",__FILE__,__LINE__);
		db_query("ALTER TABLE {$galprefix}media CHANGE type type VARCHAR(10) NOT NULL DEFAULT 'image'",__FILE__,__LINE__);
	}

	if (!in_array('downloads', $fields))
	{
		db_query("ALTER TABLE {$galprefix}media ADD downloads INT NOT NULL DEFAULT '0'",__FILE__,__LINE__);
		db_query("ALTER TABLE {$galprefix}albums CHANGE access access VARCHAR(255) NOT NULL DEFAULT ''",__FILE__,__LINE__);
		db_query("ALTER TABLE {$galprefix}albums CHANGE name name VARCHAR(50) NOT NULL DEFAULT ''",__FILE__,__LINE__);
	}

	if (!in_array('weighted', $fields))
	{
		db_query("ALTER TABLE {$galprefix}media ADD weighted FLOAT NOT NULL DEFAULT '0'",__FILE__,__LINE__);
		db_query("ALTER TABLE {$galprefix}media CHANGE title title VARCHAR(255) NOT NULL DEFAULT '(No title)'",__FILE__,__LINE__);
		require_once($sourcedir . '/Subs-MGallery.php');
		if (function_exists('smg_update_weighted'))
		{
			loadMGal_Settings();
			smg_update_weighted();
		}
	}

	// Insert the settings now
	$setting_entries = array();
	foreach ($newsettings as $name => $value)
	{
		$value = addslashes($value);
		db_query("INSERT IGNORE INTO {$galprefix}settings (name, value) VALUES ('$name', '$value')",__FILE__,__LINE__);
		if (db_affected_rows() > 0)
			$setting_entries[] = $name;
	}

	// Insert the mandatory data
	db_query("DELETE FROM {$db_prefix}mgallery_files WHERE id_file <= 4",__FILE__,__LINE__);

	db_query("
		INSERT INTO {$db_prefix}mgallery_files
		(id_file, filename, filesize, directory, width, height, id_album)
		VALUES
		(1, 'music.png', 4118, 'generic_images', 48, 48, 0)",__FILE__,__LINE__);
	db_query("
		INSERT INTO {$db_prefix}mgallery_files
		(id_file, filename, filesize, directory, width, height, id_album)
		VALUES
		(2, 'film.png', 2911, 'generic_images', 48, 48, 0)",__FILE__,__LINE__);
	db_query("
		INSERT INTO {$db_prefix}mgallery_files
		(id_file, filename, filesize, directory, width, height, id_album)
		VALUES
		(3, 'camera.png', 2438, 'generic_images', 48, 48, 0)",__FILE__,__LINE__);
	db_query("
		INSERT INTO {$db_prefix}mgallery_files
		(id_file, filename, filesize, directory, width, height, id_album)
		VALUES
		(4, 'folder.png', 2799, 'generic_images', 48, 48, 0)",__FILE__,__LINE__);

	$request = db_query("SELECT value FROM {$galprefix}settings WHERE name='data_dir_path'",__FILE__,__LINE__);
	list($data_dir) = mysql_fetch_row($request);
	$data_dir .= '/generic_images/';
	$ex_data_dir = $boarddir . '/mgal_data/generic_images/';
	$cam = $data_dir . 'camera.png';
	if ((!file_exists($cam) || filesize($cam) == 665) && filesize($ex_data_dir . 'camera.png') == 2438)
	{
		@copy($ex_data_dir . 'camera.png', $data_dir . 'camera.png');
		@copy($ex_data_dir . 'film.png', $data_dir . 'film.png');
		@copy($ex_data_dir . 'music.png', $data_dir . 'music.png');
		@copy($ex_data_dir . 'folder.png', $data_dir . 'folder.png');
	}
	mysql_free_result($request);

	require_once($sourcedir . '/Subs-MGallery-Vital.php');
	if (function_exists('getAllowedTypes'))
	{
		$aty = getAllowedTypes();
		$aty['do'][] = 'default';
		foreach ($aty['do'] as $ty)
			if (!file_exists($data_dir . $ty . '.png') && file_exists($ex_data_dir . $ty . '.png'))
				@copy($ex_data_dir . $ty . '.png', $data_dir . $ty . '.png');
	}

	db_query("
		UPDATE {$db_prefix}mgallery_settings
		SET value = '$newsettings[version]'
		WHERE name = 'version'",__FILE__,__LINE__);
}

// OK, time to report, output all the stuff to be shown to the user
echo '
<table cellpadding="0" cellspacing="0" border="0" class="tborder" width="550" align="center"><tr><td>
<div class="titlebg" style="padding: 1ex">
	SMF Media Gallery Database Installer
</div>
<div class="windowbg2" style="padding: 2ex">';

// Tell them what has been done
echo '<b>Creating / Updating Tables</b>
<br /><br />
<ul class="normallist">';
foreach ($created_tables as $table_name)
	if (in_array($table_name, $tables))
		echo '
	<li>Table <i>'.preg_replace('/`[^`]+`\./', '', $table_name).'</i> already exists.</li>';
	else
		echo '
	<li>'.$table_name.' table created.</li>';
if ($altered_mem_table_1)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'members table, added field "mgal_total_items".</li>';
if ($altered_mem_table_2)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'members table, added field "mgal_total_comments".</li>';
if ($altered_mem_table_3)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'members table, added field "mgal_unseen".</li>';

echo '
</ul>
<br /><br /><b>Initializing settings</b>
<br /><br />
<ul class="normallist">';

if (count($setting_entries) == count($newsettings))
	echo '
	<li>All ', count($setting_entries), ' records have been inserted into the settings table.</li>';
else
	echo '
	<li>', empty($setting_entries) ? 'No' : count($setting_entries), ' new record(s) have been inserted into the settings table.</li>', !empty($setting_entries) ? '
	<li>Full list: <span style="color: #888">' . implode(', ', $setting_entries) . '</span></li>' : '';

echo '
</ul>
<div style="padding-top:30px">
	<b>Your database update has been completed successfully!</b>
	<br /><br />If this is your first install, you should now go to the Admin area, Members section, and head to the
	<a href="', $scripturl, '?action=admin;area=mgallery;sa=perms;', isset($smcFunc) ? $context['session_var'] : 'sesc', '=', $context['session_id'], '">Gallery Permissions</a>
	section. Create and manage your permission profiles and apply them to your albums.
	<br /><br />If you\'re experiencing errors "403" or "406" when using the Mass Upload tool, please rename the <b>mod_security.htaccess</b> file to .htaccess (leave it
	where it is, i.e. <pre>/Themes/default/mgallery/</pre>).
	<br /><br />Additionally, if it doesn\'t work for you, you can contact your host, or create a new .htaccess at the root of your SMF folder, and add the following instructions in it: <pre>
	SecFilterEngine Off
	SecFilterScanPOST Off</pre>';

if ($doing_manual_install && (is_writable(dirname(__FILE__)) || is_writable(__FILE__)))
	echo '
	<label for="delete_self"><input type="checkbox" id="delete_self" onclick="doTheDelete(this);" /> Delete this file.</label> <i>(doesn\'t work on all servers.)</i>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		function doTheDelete(theCheck)
		{
			var theImage = document.getElementById ? document.getElementById("delete_upgrader") : document.all.delete_upgrader;

			theImage.src = "', $_SERVER['PHP_SELF'], '?delete=1&ts_" + (new Date().getTime());
			theCheck.disabled = true;
		}
	// ]]></script>
	<img src="', $boardurl, '/Themes/default/images/blank.gif" alt="" id="delete_upgrader" />';

echo '
	<br /><br /><b>Thank you for trying out SMF Media Gallery!</b>
</div>
<div style="font-size: 9px; margin-top: 20px;" align="center">
	SMF Media Gallery &copy; <a href="http://smf-media.com">SMF-Media.com</a>
</div>
</td></tr></table>
<br />';

if ($doing_manual_install)
	echo '
</body></html>';

?>
